<?php

$accountsObj = new accounts();

class accounts {

    public Iplus $mDb;
    public array $mConfig;
    public string $dateTime;
    public string $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new Iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE; // Default to 'en' if LANGUAGE is not defined
    }

    function getAccounts($aStart, $aLimit, $sort, $type, $searchTitle, $parent) {

        global $userObj;

        $sql = " SELECT  a.id,a.code,a.name,a.parent,a.type,ap.code AS 'parent_code',a.account_type,a.mode,a.is_deleted,u.user_name,sl.title as store_title,t.name as safes_name  ";
        $sql .= "FROM  accounts a ";
        $sql .= " LEFT JOIN `accounts` ap ON ap.id = a.parent ";
        $sql .= " LEFT JOIN  treasures t ON t.account_code = a.code AND a.mode = 'safes' ";
        $sql .= " LEFT JOIN  users u ON u.account_code = a.code AND a.mode = 'clients' ";
        $sql .= " LEFT JOIN  stores s ON s.account_code = a.code AND a.mode = 'stores' ";
        $sql .= " LEFT JOIN  store_langs sl ON sl.store_id = s.id and sl.lang_code='ar' ";
        $sql .= " WHERE  a.id > 0 and a.is_deleted ='0'  ";
        $sql .= $searchTitle ? ' AND (a.name like "%' . $searchTitle . '%"  ||  a.code ="' . $searchTitle . '"  || u.user_name like "%' . $searchTitle . '%" || sl.title like "%' . $searchTitle . '%" || t.name like "%' . $searchTitle . '%" ) ' : '';

        $sql .= " AND a.parent='{$parent}'  ";
        $sql .= " ORDER BY a.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        $result = $this->mDb->getAll($sql);

        foreach ($result as $k => $v) {
//                 $result[$k]['name'] = $this->getUserNameByAccountId($v['code']);
            if ($v['mode'] == 'clients') {
                $result[$k]['name'] = $v['user_name'];
            } elseif ($v['mode'] == 'stores') {
                $result[$k]['name'] = $v['store_title'];
            } elseif ($v['mode'] == 'safes') {
                $result[$k]['name'] = $v['safes_name'];
            }
            $sub_code = $this->getCodeInSub($v['id']);
            $result[$k]['sub_code'] = $sub_code ? $v['code'] . ',' . implode(",", $sub_code) : $v['code'];
            $result[$k]['balance_value'] = $userObj->get_balanceInDailyRestrictions($result[$k]['sub_code']);
        }
        return $result;
    }

    function getSearchAccountsCount($sort, $type, $searchTitle, $parent) {
        $sql = "SELECT COUNT(DISTINCT a.`id`) as 'result_count' FROM accounts a ";
        $sql .= " LEFT JOIN  treasures t ON t.account_code = a.code AND a.mode = 'safes' ";
        $sql .= " LEFT JOIN  users u ON u.account_code = a.code AND a.mode = 'clients' ";
        $sql .= " LEFT JOIN  stores s ON s.account_code = a.code AND a.mode = 'stores' ";
        $sql .= " LEFT JOIN  store_langs sl ON sl.store_id = s.id and sl.lang_code='ar' ";
        $sql .= " WHERE  a.id > 0   ";
        $sql .= $searchTitle ? ' AND (a.name like "%' . $searchTitle . '%"  ||  a.code ="' . $searchTitle . '"  || u.user_name like "%' . $searchTitle . '%" || sl.title like "%' . $searchTitle . '%" || t.name like "%' . $searchTitle . '%" ) ' : '';

        $sql .= " AND a.parent='{$parent}' and a.is_deleted='0' ";
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    function getAccountsArray($sort, $type, $searchTitle) {

        $sql = "SELECT id,name FROM accounts  ";

        $sql .= " WHERE  id > 0  and is_deleted='0' ";
        $sql .= $searchTitle ? ' AND ( name like "%' . $searchTitle . '%" ||   code ="' . $searchTitle . '" ) ' : " AND parent='0'";
        $sql .= " ORDER BY  {$sort} {$type}";

        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getAccountsSearch($searchTitle, $account_type = '0') {

        $sql = "SELECT id,name,parent,code FROM accounts  ";
        $sql .= " WHERE  id > 0  and is_deleted='0' ";
        $sql .= $account_type == '1' ? " and account_type='1'  and mode IS NULL " : " and account_type='0' and parent !='0'";
        $sql .= $searchTitle ? ' AND ( name like "%' . $searchTitle . '%" ||   code ="' . $searchTitle . '" ) ' : " ";
        $res = $this->mDb->getAll($sql);
        $groupedData = array_reduce($res, function ($carry, $item) {
            $parentId = $item["parent"];
            $carry[$parentId]["parent"] = $parentId;
            $carry[$parentId]["label"] = implode(" > ", $this->getParentNameTree($parentId));
            $carry[$parentId]["items"][] = $item;
            return $carry;
        }, []);

        $result = array_values($groupedData);

//        print_r($groupedData);
        return $result;
    }

    function getAccountsSearchAccountCode($searchTitle, $account_type = '1') {

        $sql = "SELECT a.id,a.name,a.parent,a.code,a.mode,u.user_name,sl.title as store_title,t.name as safes_name  FROM accounts a ";
        $sql .= " LEFT JOIN  treasures t ON t.account_code = a.code AND a.mode = 'safes' ";
        $sql .= " LEFT JOIN  users u ON u.account_code = a.code AND a.mode = 'clients' ";
        $sql .= " LEFT JOIN  stores s ON s.account_code = a.code AND a.mode = 'stores' ";
        $sql .= " LEFT JOIN  store_langs sl ON sl.store_id = s.id and sl.lang_code='ar' ";
        $sql .= " WHERE a.id > 0  and a.is_deleted='0' ";
        $sql .= $account_type == '1' ? " and a.account_type='1'    " : " and a.account_type='0' and a.parent !='0'";
        $sql .= $searchTitle ? ' AND (a.name like "%' . $searchTitle . '%"  ||  a.code ="' . $searchTitle . '"  || u.user_name like "%' . $searchTitle . '%" || sl.title like "%' . $searchTitle . '%" || t.name like "%' . $searchTitle . '%" ) ' : " and a.id='0'";
//      echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        foreach ($res as $k => $v) {
            if ($v['mode'] == 'clients') {
                $res[$k]['name'] = $v['code'] . ' - ' . $v['user_name'];
            } elseif ($v['mode'] == 'stores') {
                $res[$k]['name'] = $v['code'] . ' - ' . $v['store_title'];
            } elseif ($v['mode'] == 'safes') {
                $res[$k]['name'] = $v['code'] . ' - ' . $v['safes_name'];
            } else {
                $res[$k]['name'] = $v['code'] . ' - ' . $v['name'];
            }
            $res[$k]['label'] = implode(" > ", $this->getParentNameTree($v['parent']));
        }
//        $groupedData = array_reduce($res, function($carry, $item) {
//            if ($item['mode'] == 'clients') {
//                $item['name'] = $item['user_name'];
//            } elseif ($item['mode'] == 'stores') {
//                $item['name'] = $item['store_title'];
//            } elseif ($item['mode'] == 'safes') {
//                $item['name'] = $item['safes_name'];
//            }
//
//            $parentId = $item["parent"];
//            $carry[$parentId]["parent"] = $parentId;
//            $carry[$parentId]["label"] = implode(" > ", $this->getParentNameTree($parentId));
//            $carry[$parentId]["child"][] = $item;
//            return $carry;
//        }, []);
//
//        $result = array_values($groupedData);
//        print_r($groupedData);
        return $res;
    }

    function getParentNameTree($aId) {


        $sql = "SELECT id, name, parent FROM accounts WHERE  id='{$aId}' and is_deleted='0'";
//        echo $sql."<hr>";
        $result = $this->mDb->getAll($sql);
        $tree = array();
        foreach ($result as $tier) {
            if ($tier['id']) {
                $tree[] = $tier['name'];
                $tier_arr = $this->getParentNameTree($tier['parent']);
                if (is_array($tier_arr)) {
                    $tree = array_merge($tier_arr, $tree);
                }
            }
        }

        return $tree;
    }

    function getBreadcrumbTree($aId) {


        $sql = "SELECT id, name, parent,code,account_type,mode,is_deleted FROM accounts WHERE  id='{$aId}' and is_deleted='0'";
//        echo $sql."<hr>";
        $result = $this->mDb->getAll($sql);
        $tree = array();
        foreach ($result as $tier) {
            if ($tier['id']) {
                if ($tier['mode'] == 'clients') {
                    $tier['name'] = $this->getUserNameByAccountId($tier['code']);
                } elseif ($tier['mode'] == 'stores') {
                    $tier['name'] = $this->getStoreNameByAccountId($tier['code']);
                } elseif ($tier['mode'] == 'safes') {
                    $tier['name'] = $this->getSafeNameByAccountId($tier['code']);
                }
                $tree[] = $tier;

                $tier_arr = $this->getBreadcrumbTree($tier['parent']);
                if (is_array($tier_arr)) {
                    $tree = array_merge($tree, $tier_arr);
                }
            }
        }

        return $tree;
    }

    function getAccountsTree($sort, $type, $parent = 0, $searchTitle = '') {

        $sql = "SELECT id,name as text,parent as parent_ ,code,'fa fa-folder icon-lg m--font-warning' as icon,account_type,mode,is_deleted  FROM accounts ";
        $sql .= "WHERE id > 0 and is_deleted='0' and mode IS NULL ";
        $sql .= $searchTitle ? ' AND ( name like "%' . $searchTitle . '%" ||   code ="' . $searchTitle . '" ) ' : " AND parent='{$parent}' ";
        $sql .= " ORDER BY {$sort} {$type}";
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        $tree = array();
        foreach ($res as $account) {
            if ($account['id']) {
                $account['li_attr']['data_id'] = $account['id'];
                $account['li_attr']['data_code'] = $account['code'];
                $account['li_attr']['data_account_type'] = $account['account_type'];

                if ($account['parent_'] == '0') {
                    $account['state']['opened'] = true;
                }
//                if ($account['mode'] == 'clients') {
//                    $account['text'] = $this->getUserNameByAccountId($account['code']);
//                }
                $AccountCode = $this->getRoutingByAccountId($account['code']);
                if ($AccountCode['routing_key'] && $account['account_type'] === '0') {
                    $account['icon'] = "fa  fa-solid fa-rotate-left icon-lg m--font-warning";
                }
                if ($account['account_type'] == '1') {
                    $account['icon'] = "fa fa-file-o";
                }
                $account['children'] = $this->getAccountsTree($sort, $type, $account['id'], '');

                $tree[] = $account;
            } else {
                $tree[] = [];
            }
        }

        return $tree;
    }

    function getCodeInSub($id) {

        $sql = "SELECT id,code FROM accounts  ";
        $sql .= " WHERE  id > 0 and parent='{$id}'   ";

        $res = $this->mDb->getAll($sql);
        foreach ($res as $k => $v) {
            if ($v['id']) {
                $tree[] = $v['code'];
                $res_arr = $this->getCodeInSub($v['id']);
                if (is_array($res_arr)) {
                    $tree = array_merge($tree, $res_arr);
                }
            }
        }
        // echo $sql; die();
//echo "<pre>";
//print_r($tree);
//echo "</pre>";
        return $tree;
    }

    function getUserNameByAccountId($code) {
        $sql = "SELECT user_name FROM users  ";
        $sql .= " WHERE  `account_code` = '{$code}'";
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    function getSafeNameByAccountId($code) {
        $sql = "SELECT name FROM treasures  ";
        $sql .= " WHERE  `account_code` = '{$code}'";
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    function getStoreNameByAccountId($code) {
        $sql = "SELECT sl.title  FROM stores s ";
        $sql .= " LEFT JOIN  store_langs sl ON sl.store_id = s.id and sl.lang_code='ar' ";
        $sql .= " WHERE  s.`account_code` = '{$code}'";
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    function getAccountsCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `accounts` where is_deleted='0' ";
        return $this->mDb->getOne($sql);
    }

    function addEditAccount($temp) {



        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `accounts` SET ";
            foreach ($this->mDb->getCols('accounts', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
//             echo  $sql ."<hr>";
            $res = $this->mDb->query($sql);

            return $res;
        } else {

            $sql = "UPDATE `accounts` SET ";
            foreach ($this->mDb->getCols('accounts', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            // echo $sql ;die();
            $res = $this->mDb->query($sql);

            return $res;
        }
    }

    function addEditRestrictions($temp) {
        global $settings;
        global $userObj;

        $data_table['table_name'] = "daily_restrictions";
        $data_table['column_name'] = "count_restrictions";
        $temp['count_restrictions'] = $settings->getlastIdFromByTableName($data_table);
        $temp['count_restrictions'] = $temp['count_restrictions'] + 1;
        $temp['type'] = 'manual-restrictions';
        $temp['mode'] = "manual-restrictions";

        $sql = "INSERT INTO `daily_restrictions` SET ";
        foreach ($this->mDb->getCols('daily_restrictions', $temp) as $k => $v) {
            $sql .= ($k == 'id' || $k == 'list') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}' ";
//  echo $sql."<hr>";
        $id = $this->mDb->queryreturnlastid($sql);
        if ($id) {
            for ($i = 0; $i < count($temp['list']); $i++) {
                $sql = "INSERT INTO `daily_restrictions_list` SET ";
                foreach ($this->mDb->getCols('daily_restrictions_list', $temp['list'][$i]) as $k => $v) {
                    $sql .= ($k == 'id' || $k == 'list') ? "" : "`{$k}`='{$v}',";
                }
                $sql .= "p_id='{$id}', `date_added` = '{$this->dateTime}' ";
                $res = $this->mDb->queryreturnlastid($sql);
                if ($res) {
                    $userId = $this->getUserIdByAccountId($temp['list'][$i]['account_code']);
                    if ($userId) {
                        if ($temp['list'][$i]['debtor'] > 0) {
                            $balance['transaction'] = 'start_client_dept';
                            $balance['value'] = $temp['list'][$i]['debtor'];
                        }
                        if ($temp['list'][$i]['creditor'] > 0) {
                            $balance['transaction'] = 'start_client_pay';
                            $balance['value'] = $temp['list'][$i]['creditor'];
                        }

                        $balance['user_id'] = $userId;
                        $balance['for_id'] = '0';

                        $userObj->addBalance($balance);
                    }
                }
            }
        }
        return $id;
    }

    public function getUserIdByAccountId($code) {
        $sql = "SELECT id FROM `{$this->mPrefix}users`  ";
        $sql .= "WHERE  account_code = '{$code}' ";
//        echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res ? $res : "";
    }

    function getOneAccount($id) {
        $sql = "SELECT * FROM `accounts`";
        $sql .= " WHERE `id` = '{$id}' and is_deleted='0' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {

            if ($res['mode'] == 'clients') {
                $res['name'] = $this->getUserNameByAccountId($res['code']);
            } elseif ($res['mode'] == 'stores') {
                $res['name'] = $this->getStoreNameByAccountId($res['code']);
            } elseif ($res['mode'] == 'safes') {
                $res['name'] = $this->getSafeNameByAccountId($res['code']);
            }
            $routing = $this->getRoutingByAccountId($res['code']);
            $res['routing_key'] = $routing['routing_key'];
        }

        return $res;
    }

    public function getRoutingByAccountId($code) {
        $sql = "SELECT routing_key FROM `{$this->mPrefix}accounts_routing_list`  ";
        $sql .= "WHERE  account_code = '{$code}' ";
//        echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);
        return $res ? $res : "";
    }

    function deleteAccount($ids) {
//        $sql = "DELETE FROM `accounts` ";
//        $sql.= " WHERE `id` = 0";
//        foreach ($ids as $id) {
//            $sql .= " || `id` = '{$id}' ";
//        }
        $sql = "UPDATE  `accounts` SET `is_deleted`='1' ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

    function getAccountsRouting() {
        $sql = "SELECT * FROM accounts_routing ";
        $sql .= " WHERE  id > 0  ";
        $sql .= " ORDER BY sort ASC ";
        $res = $this->mDb->getAll($sql);

        foreach ($res as $k => $v) {
            $res[$k]['list'] = $this->getAccountsRoutingList($v['id']);
        }

        return $res;
    }

    function getAccountsRoutingList($parent) {
        $sql = "SELECT *,'account_code' as `column_show` FROM accounts_routing_list ";
        $sql .= " WHERE  parent ='{$parent}'  ";
        $sql .= " ORDER BY sort ASC ";
        return $this->mDb->getAll($sql);
    }

    function getAccountRoutingOne($account_code) {
        $sql = "SELECT * FROM accounts_routing_list ";
        $sql .= " WHERE  account_code ='{$account_code}'  ";
        return $this->mDb->getRow($sql);
    }

    function editAccountRouting($temp) {

        foreach ($temp as $k => $v) {
            foreach ($v['list'] as $k_l => $v_l) {
                $sql = "UPDATE `accounts_routing_list` SET ";
                $sql .= "`account_code`='{$v_l['account_code']}'";
                $sql .= " WHERE `parent` = '{$v['id']}' and `routing_key`='{$v_l['routing_key']}' ";
                $res = $this->mDb->query($sql);
            }
        }


        return $res;
    }

    function getDailyRestrictionsCount($mode, $searchAccountCode, $searchCountRestrictions, $searchDateFrom, $searchDateTo) {
        $sql = "SELECT COUNT(DISTINCT dr.`id`) as 'count' FROM `daily_restrictions` dr  ";
        $sql .= " LEFT JOIN `daily_restrictions_list` drl ON drl.p_id = dr.id ";
        $sql .= " WHERE dr.id > 0  ";
        $sql .= $mode ? ' AND ( dr.mode ="' . $mode . '"  ) ' : '';
        $sql .= $searchAccountCode ? ' AND ( drl.account_code ="' . $searchAccountCode . '"  ) ' : '';
        $sql .= $searchCountRestrictions ? ' AND ( dr.count_restrictions ="' . $searchCountRestrictions . '"  ) ' : '';
        $sql .= $searchDateFrom ? " AND dr.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND dr.`date_added`  <= '{$searchDateTo}' " : "";

//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    function getDailyRestrictions($aStart, $aLimit, $sort, $type, $mode, $searchAccountCode, $searchCountRestrictions, $searchDateFrom, $searchDateTo) {

        $sql = "SELECT dr.* FROM daily_restrictions dr ";
        $sql .= " LEFT JOIN `daily_restrictions_list` drl ON drl.p_id = dr.id ";
        $sql .= " WHERE dr.id > 0  ";
        $sql .= $mode ? ' AND ( dr.mode ="' . $mode . '"  ) ' : '';
        $sql .= $searchAccountCode ? ' AND ( drl.account_code ="' . $searchAccountCode . '"  ) ' : '';
        $sql .= $searchCountRestrictions ? ' AND ( dr.count_restrictions ="' . $searchCountRestrictions . '"  ) ' : '';
        $sql .= $searchDateFrom ? " AND dr.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND dr.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= " GROUP BY dr.`id`";
        $sql .= " ORDER BY dr.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql . "<hr>";

        $result = $this->mDb->getAll($sql);

        foreach ($result as $k => $v) {


            $result[$k]['list'] = $this->getDailyRestrictionsList($v['id']);
        }
        return $result;
    }

    function getDailyRestrictionsList($p_id) {

        $sql = "SELECT drl.*,a.code ,a.name ,a.mode,a.id as parent ,u.user_name,sl.title as store_title,t.name as safes_name FROM daily_restrictions_list drl ";
        $sql .= " LEFT JOIN `accounts` a ON a.code = drl.account_code ";
        $sql .= " LEFT JOIN  treasures t ON t.account_code = a.code  ";
        $sql .= " LEFT JOIN  users u ON u.account_code = a.code   ";
        $sql .= " LEFT JOIN  stores s ON s.account_code = a.code  ";
        $sql .= " LEFT JOIN  store_langs sl ON sl.store_id = s.id and sl.lang_code='ar' ";
        $sql .= " WHERE drl.id > 0  ";
        $sql .= " AND  drl.p_id ='{$p_id}' ";
        $sql .= " GROUP BY drl.`id`";

        $sql .= " ORDER BY drl.id ASC ";

//        echo $sql . "<hr>";

        $result = $this->mDb->getAll($sql);
        foreach ($result as $k => $v) {
            $result[$k]['debtor'] = number_format($v['debtor'], 2);
            $result[$k]['creditor'] = number_format($v['creditor'], 2);
            if ($v['mode'] == 'clients') {
                $result[$k]['account_name'] = $v['user_name'];
            } elseif ($v['mode'] == 'stores') {
                $result[$k]['account_name'] = $v['store_title'];
            } elseif ($v['mode'] == 'safes') {
                $result[$k]['account_name'] = $v['safes_name'];
            } else {
                $result[$k]['account_name'] = $v['name'];
            }
        }
        return $result;
    }

    function getAccountInfoByCodeCount($searchAccountCode, $searchDateFrom, $searchDateTo) {
        $sql = "SELECT COUNT(DISTINCT drl.`id`) as 'count' FROM `daily_restrictions_list` drl  ";
        $sql .= " LEFT JOIN `daily_restrictions` dr ON dr.id = drl.p_id ";
        $sql .= " WHERE drl.id > 0  ";
        $sql .= ' AND ( drl.account_code ="' . $searchAccountCode . '"  ) ';
        $sql .= $searchDateFrom ? " AND dr.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND dr.`date_added`  <= '{$searchDateTo}' " : "";

//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    function getAccountInfoByCode($aStart, $aLimit, $sort, $type, $searchAccountCode, $searchDateFrom, $searchDateTo) {
        global $userObj;
        $sql = "SELECT drl.*,dr.date_added as restrictions_date_added,dr.count_restrictions,dr.voucher_id,dr.invoice_id,dr.mode as restrictions_mode,dr.count_invoice_type,dr.type,a.name ,a.mode,a.id as parent ,u.user_name,sl.title as store_title,t.name as safes_name,v.count_voucher_type,v.voucher_type FROM daily_restrictions_list drl ";
        $sql .= " LEFT JOIN `daily_restrictions` dr ON dr.id = drl.p_id ";
        $sql .= " LEFT JOIN `vouchers` v ON dr.voucher_id = v.id ";

        $sql .= " LEFT JOIN `accounts` a ON a.code = drl.account_code ";
        $sql .= " LEFT JOIN  treasures t ON t.account_code = a.code  ";
        $sql .= " LEFT JOIN  users u ON u.account_code = a.code   ";
        $sql .= " LEFT JOIN  stores s ON s.account_code = a.code  ";
        $sql .= " LEFT JOIN  store_langs sl ON sl.store_id = s.id and sl.lang_code='ar' ";

        $sql .= " WHERE drl.id > 0  ";

        $sql .= ' AND ( drl.account_code ="' . $searchAccountCode . '"  ) ';
        $sql .= $searchDateFrom ? " AND dr.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND dr.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= " GROUP BY drl.`id`";
        $sql .= " ORDER BY dr.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql . "<hr>";

        $result = $this->mDb->getAll($sql);
        foreach ($result as $k => $v) {
            $result[$k]['debtor'] = number_format($v['debtor'], 2);
            $result[$k]['creditor'] = number_format($v['creditor'], 2);
            if ($v['mode'] == 'clients') {
                $result[$k]['account_name'] = $v['user_name'];
            } elseif ($v['mode'] == 'stores') {
                $result[$k]['account_name'] = $v['store_title'];
            } elseif ($v['mode'] == 'safes') {
                $result[$k]['account_name'] = $v['safes_name'];
            } else {
                $result[$k]['account_name'] = $v['name'];
            }


            $result[$k]['balance_value'] = $userObj->get_balanceInDailyRestrictions($v['account_code'], $v['p_id']);
        }
        return $result;
    }

    function getAccountsByType($searchTitle) {

        $sql = "SELECT a.id,a.name,a.parent,a.code,a.mode,u.user_name,sl.title as store_title,t.name as safes_name  FROM accounts a  ";

        $sql .= " LEFT JOIN  treasures t ON t.account_code = a.code AND a.mode = 'safes' ";
        $sql .= " LEFT JOIN  users u ON u.account_code = a.code AND a.mode = 'clients' ";
        $sql .= " LEFT JOIN  stores s ON s.account_code = a.code AND a.mode = 'stores' ";
        $sql .= " LEFT JOIN  store_langs sl ON sl.store_id = s.id and sl.lang_code='ar' ";

        $sql .= " WHERE  a.id > 0  and a.is_deleted='0' ";
        $sql .= " and a.account_type='1'  ";
        $sql .= $searchTitle ? ' AND ( a.name like "%' . $searchTitle . '%" ||   a.code ="' . $searchTitle . '" ) ' : " ";
        $res = $this->mDb->getAll($sql);
        $groupedData = array_reduce($res, function ($carry, $item) {
            $parentId = $item["parent"];
            if ($item['mode'] == 'clients') {
                $item['name'] = $item['user_name'];
            } elseif ($item['mode'] == 'stores') {
                $item['name'] = $item['store_title'];
            } elseif ($item['mode'] == 'safes') {
                $item['name'] = $item['safes_name'];
            }


            $carry[$parentId]["parent"] = $parentId;
            $carry[$parentId]["label"] = implode(" > ", $this->getParentNameTree($parentId));
            $carry[$parentId]["items"][] = $item;
            return $carry;
        }, []);

        $result = array_values($groupedData);

//        print_r($groupedData);
        return $result;
    }
}

?>