<?php

$importApi = new importApi();

class importApi {

    public $mDb;
    public $masterDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new iplus();
        $this->masterDb = new iplusMaster();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    public function cheackIfExitByFieldAndTable($value, $field, $table, $id) {

        $sql = "SELECT  id FROM `{$table}`   ";
        $sql .= " WHERE {$field} = '{$value}'  ";
        $sql .= $id ? " AND id != '{$id}' " : '';
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    public function getSomeAllData($aStart, $aLimit, $sort, $type, $searchName, $searchSecretkey) {

        $sql = "SELECT sa.*, u.user_name AS 'added_by'";
        $sql .= " FROM `import_api` sa ";
        $sql .= " LEFT JOIN `users` u ON u.id = sa.admin_id ";
        $sql .= " WHERE (sa.id > 0 || sa.id ='0') ";
        $sql .= $searchName ? ' AND sa.name like "%' . $searchName . '%"' : '';
        $sql .= $searchSecretkey ? " AND sa.secret_key = '{$searchSecretkey}'" : '';
        $sql .= " GROUP BY sa.`id`";
        $sql .= " ORDER BY sa.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql; die();
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function getSearchAllDataCount($searchName, $searchSecretkey) {

        $sql = "SELECT COUNT(DISTINCT sa.`id`) as 'result_count' FROM import_api sa ";
        $sql .= " WHERE (sa.id > 0 || sa.id ='0') ";
        $sql .= $searchName ? ' AND sa.`name` like "%' . $searchName . '%"' : '';
        $sql .= $searchSecretkey ? " AND sa.secret_key = '{$searchSecretkey}'" : '';
        // echo   $sql; die();
        return $this->mDb->getOne($sql);
    }

    public function updateSecretKey($id, $secretKey) {
        $sql = " UPDATE `import_api` SET `secret_key` = '{$secretKey}'";
        $sql .= " WHERE `id` = '{$id}'";
        // echo $sql; die();
        return $this->mDb->query($sql);
    }

    public function addImportApiSections($sections, $p_id) {
        if (count($sections) > 0) {
            $sql = "INSERT INTO `{$this->mPrefix}import_api_sections` 
                (p_id, api_parent,api_cat_id,parent, cat_id, deleted,deleted_to, date_added) VALUES ";
            foreach ($sections as $v) {
                if ($v['cat_id'] && $v['deleted_to'] == '0') {
                    $sql .= "('$p_id', '{$v['api_parent']}','{$v['api_cat_id']}','{$v['parent']}', '{$v['cat_id']}', '{$v['deleted']}','{$v['deleted_to']}', '{$this->dateTime}'),";
                }
            }
            $sql = substr($sql, 0, -1);
            $res = $this->mDb->query($sql);
        }
        return $res;
    }

    public function addImportApiStores($stores, $p_id) {
        if (count($stores) > 0) {
            $sql = "INSERT INTO `{$this->mPrefix}import_api_stores` 
                (p_id, store_id, deleted,deleted_to,active, date_added) VALUES ";
            foreach ($stores as $v) {
                $v['active'] = $v['active'] ? "1" : "0";
                if ($v['store_id'] && $v['active']) {
                    $sql .= "('$p_id', '{$v['store_id']}',  '{$v['deleted']}','{$v['deleted_to']}',  '{$v['active']}', '{$this->dateTime}'),";
                }
            }
            $sql = substr($sql, 0, -1);
            $res = $this->mDb->query($sql);
        }
        return $res;
    }

    public function deleteImportApiSections($p_id) {
        $sql = "DELETE From `{$this->mPrefix}import_api_sections`   ";
        $sql .= "where p_id ='{$p_id}'   ";
        $this->mDb->query($sql);
    }

    public function deleteImportApiStores($p_id) {
        $sql = "DELETE From `{$this->mPrefix}import_api_stores`   ";
        $sql .= "where p_id ='{$p_id}'   ";
        $this->mDb->query($sql);
    }

    public function addEditData($temp) {
        $temp['secret_key'] = trim($temp['secret_key']);
        $temp['active'] = $temp['active'] ? '1' : '0';

        if (!$temp['id'] && $temp['id'] != '0') {
            $sql = "INSERT INTO `import_api` SET ";
            foreach ($this->mDb->getCols('import_api', $temp) as $k => $v) {
                $sql .= ( $k == 'id' || $k == 'sections' || $k == 'stores' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}' ";
//     echo $sql; die();
            $id = $this->mDb->queryreturnlastid($sql);
            if ($id) {
                $this->addImportApiSections($temp['sections'], $id);
                $this->addImportApiStores($temp['stores'], $id);

                $this->mDb->addCronJob("* * * * * curl -s '{$this->mConfig['cronJob_url']}secret-api-cronJob/api-secret.php?action=getSecretKeyDetails&secret_key={$temp['secret_key']}&db_to={$temp['dealer_name']}&api_id_to={$id}'>/dev/null 2>&1");
                //  $this->mDb->addCronJob("*/2 * * * * curl -s '{$this->mConfig['cronJob_url']}secret-api-cronJob/api-secret.php?action=getProductsByEdit&secret_key={$temp['secret_key']}&db_to={$temp['dealer_name']}&api_id_to={$id}'>/dev/null 2>&1");
            }


            return $id;
        } else {
//edit
            $sql = "UPDATE `import_api` SET ";
            foreach ($this->mDb->getCols('import_api', $temp) as $k => $v) {
                $sql .= ($k == 'id' || $k == 'sections' || $k == 'stores' || $k == 'date_added') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
//             echo $sql."<hr>";
            $res = $this->mDb->query($sql);
            if ($res) {
                if ($temp['id'] > '0') {
                    //delete
                    $this->deleteImportApiSections($temp['id']);
                    $this->deleteImportApiStores($temp['id']);
                    //add
                    $this->addImportApiSections($temp['sections'], $temp['id']);
                    $this->addImportApiStores($temp['stores'], $temp['id']);

                    if ($temp['last_image'] != '') {
                        $old_image = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/importapi/' . $temp['last_image'];
                        if (file_exists($old_image)) {
                            @unlink($old_image);
                        }
                    }

                    $this->mDb->addCronJob("* * * * * curl -s '{$this->mConfig['cronJob_url']}secret-api-cronJob/api-secret.php?action=getSecretKeyDetails&secret_key={$temp['secret_key']}&db_to={$temp['dealer_name']}&api_id_to={$temp['id']}'>/dev/null 2>&1");
                }
            }
            return $res ? $temp['id'] : $res;
        }
    }

    public function unLinkLastImageImportApi($temp) {

        if ($temp['last_image'] != '') {
            $old_image = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/importapi/' . $temp['last_image'];

            if (file_exists($old_image)) {
                $res = @unlink($old_image);
            }
        }
        return $res ? $res : '';
    }

    public function getOneData($id) {
        global $productsObj;
        $sql = "SELECT  sa.*  FROM `import_api` sa";
        $sql .= " WHERE sa.`id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['sections'] = $this->getAllImportApiSections($res['id']);
            $res['stores'] = $this->getAllImportApiStores($res['id']);
            $res['all_products_excluded'] = [];
            if ($res['excluded_products']) {
                $res['all_products_excluded'] = $productsObj->getAllProductsExcluded($res['excluded_products']);
            }
        }

        return $res;
    }

    public function getAllImportApiSections($p_id) {
        $sql = "SELECT  *  FROM `{$this->mPrefix}import_api_sections`   ";
        $sql .= "WHERE   p_id = '{$p_id}' ";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : array();
    }

    public function getAllImportApiStores($p_id) {
        $sql = "SELECT  *  FROM `{$this->mPrefix}import_api_stores`   ";
        $sql .= "WHERE   p_id = '{$p_id}' ";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : array();
    }

    public function getAllImgImportApi($ids) {
        $sql = "SELECT  image  FROM `{$this->mPrefix}import_api`   ";
        $sql .= "WHERE   id  in({$ids}) ";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : array();
    }

    public function getAllImgShippingMethodsByImportApi($ids) {
        $sql = "SELECT  sm.image  FROM `{$this->mPrefix}shipping_methods`  sm ";
        $sql .= " LEFT JOIN import_api ia ON ia.id = sm.api_id_to";
        $sql .= " WHERE   ia.id  in({$ids}) ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : array();
    }

//    public function deleteData($ids) {
//
//        $idList = implode("','", $ids);
//        $imgList = $this->getAllImgImportApi($idList);
//        $sql = "DELETE FROM `import_api` WHERE  `id` IN ('$idList')";
//        $sql_sections = "DELETE FROM `import_api_sections` WHERE  `p_id` IN ('$idList')";
//        $sql_stores = "DELETE FROM `import_api_stores` WHERE  `p_id` IN ('$idList')";
//
//        $res = $this->mDb->query($sql);
//        if ($res) {
//            $this->mDb->query($sql_sections);
//            $this->mDb->query($sql_stores);
//
//            if (count($imgList) > 0) {
//                foreach ($imgList as $k => $v) {
//                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/importapi/' . $v['image'];
//                    if (file_exists($old_img)) {
//                        @unlink($old_img);
//                    }
//                }
//            }
//        }
//
//        return $res;
//    }
    public function deleteData($ids) {

        $idList = implode("','", $ids);
        $imgListimportapi = $this->getAllImgImportApi($idList);
        $imgListShipping_methods = $this->getAllImgShippingMethodsByImportApi($idList);

        $sql = " DELETE import_api, import_api_sections, import_api_stores, shipping_methods, shipping_methods_langs";
        $sql .= ", shipping_methods_governorate, shipping_methods_governorate_langs";
        $sql .= " FROM import_api";
        $sql .= " LEFT JOIN import_api_sections ON import_api.id = import_api_sections.p_id";
        $sql .= " LEFT JOIN import_api_stores ON import_api.id = import_api_stores.p_id";
        $sql .= " LEFT JOIN shipping_methods ON import_api.id = shipping_methods.api_id_to";
        $sql .= " LEFT JOIN shipping_methods_langs ON shipping_methods.id = shipping_methods_langs.p_id";
        $sql .= " LEFT JOIN shipping_methods_governorate ON shipping_methods.id = shipping_methods_governorate.p_id";
        $sql .= " LEFT JOIN shipping_methods_governorate_langs ON shipping_methods.id = shipping_methods_governorate_langs.p_id";
        $sql .= " WHERE import_api.id IN ('$idList')";

        $res = $this->mDb->query($sql);
        if ($res) {

            if (count($imgListimportapi) > 0) {
                foreach ($imgListimportapi as $k => $v) {
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/importapi/' . $v['image'];
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                }
            }
            if (count($imgListShipping_methods) > 0) {
                foreach ($imgListShipping_methods as $k => $v) {
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/shipping-methods/' . $v['image'];
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                }
            }
        }

        return $res;
    }

    public function deleteDataSections($id) {
        $sql = "DELETE FROM `import_api_sections` ";
        $sql .= " WHERE `p_id` = '{$id}' ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function deleteDataStores($id) {
        $sql = "DELETE FROM `import_api_stores` ";
        $sql .= " WHERE `p_id` = '{$id}' ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function addStoresAndSections($temp) {

        if (count($temp['stores']) > 0) {
            foreach ($temp['stores'] as $k => $v) {
                $v['active'] = $v['active'] ? '1' : '0';
                $temp['stores'][$k]['store_id_to'] = $this->getStoresByDealerIdAndStoreId($v, $temp);
                if ($v['active'] == '1') {

                    if (!$temp['stores'][$k]['store_id_to'] || $temp['stores'][$k]['store_id_to'] == '') {
                        $temp['stores'][$k]['store_id_to'] = $this->addStoresByDealerIdAndStoreId($v, $temp);
                    }
                }
            }
        }
        return $temp;
    }

    public function getStoresByDealerIdAndStoreId($Data, $temp) {
        $sql = "SELECT id  FROM `stores`  ";
        $sql .= " WHERE `api_dealer_id` = '{$temp['dealer_id_from']}' and `api_store_id` ='{$Data['store_id']}' and `type`='external' ";
//         echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);
//            echo $res['id'] . "<hr>";
        return $res ? $res : false;
    }

    public function addStoresByDealerIdAndStoreId($Data, $temp) {
        $Data['type'] = 'external';
        $Data['active'] = '1';
        $Data['api_store_id'] = $Data['store_id'];

        $Data['api_dealer_id'] = $temp['dealer_id_from'];
        $Data['admin_id'] = $temp['admin_id'];

        unset($Data['store_id']);
        $sql = "INSERT INTO `stores` SET ";
        foreach ($this->mDb->getCols('stores', $Data) as $k => $v) {
            $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' || $k == 'date_added') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}'";
//        echo $sql . "<hr>";
        $id = $this->mDb->queryreturnlastid($sql);
        if ($id) {
            //enter lang_details
            $Data['title'] = $Data['title_share'] ? $Data['title_share'] : $Data['title'];
            $sql = " INSERT INTO `store_langs` SET  lang_code = 'ar'  , title = '{$Data['title']}'   , store_id='{$id}' ";
            // echo "$sql";die();
            $res2 = $this->mDb->query($sql);
            # code...
        }
        return $id ? $id : '';
    }
}
