<?php

$invoicesObj = new Invoices();

class Invoices {

    private $mDb;
    private $mConfig;
    private $lang_code;
    private $dateTime;
    private $notifications;
    private $treasuresObj;
    private $productsObj;
    private $userObj;
    private $settings;
    private $generator;

    public function __construct() {
        global $Config;

        // تهيئة الكائنات
        $this->mDb = new iplus();
        $this->notifications = new notifications();
        $this->treasuresObj = new treasures();
        $this->settings = new Configuration();
        $this->userObj = new users();
        $this->productsObj = new Products();
        $this->generator = new Picqer\Barcode\BarcodeGeneratorJPG();

        // تعيين الإعدادات
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    public function addEditInvoice($Req) {
        if (isset($Req['show_free_delivery'])) {
            $Req['show_free_delivery'] = $Req['show_free_delivery'] ? 1 : 0;
        }
        if (!$Req['invoice_edit_id']) {
            $Req['additional_value_pers'] = $Req['additional_value_pers'] == '1' || $Req['additional_value_pers'] == true ? '1' : '0';
            $Req['discount_pers'] = $Req['discount_pers'] == '1' || $Req['discount_pers'] == true ? '1' : '0';

            $Req['affiliator_id'] = $Req['affiliator_id'] > '0' ? $Req['affiliator_id'] : '0';
            $Req['price_difference'] = $Req['price_difference'] ? $Req['price_difference'] : '0';

            $data_table['table_name'] = "invoices";
            $data_table['type_value'] = $Req['invoice_type'];
            $data_table['column_type'] = "invoice_type";
            $data_table['column_name'] = "count_invoice_type";
            $Req['count_invoice_type'] = $this->settings->getlastTypeIdFromByTableName($data_table);
            $Req['count_invoice_type'] = $Req['count_invoice_type'] + 1;
            $Req['bar_code'] = $Req['count_invoice_type'];
            $Req['bar_code_image'] = date('Y-m-d') . "_" . $Req['bar_code'] . '.jpg';
            $redColor = [0, 0, 0];
            file_put_contents('../uploads/' . DEALERUPLOAD . '/barcods/' . $Req['bar_code_image'], $this->generator->getBarcode($Req['bar_code'], $this->generator::TYPE_CODE_128, 3, 50, $redColor));
            $sql = "INSERT INTO `invoices` SET ";
            foreach ($this->mDb->getCols('invoices', $Req) as $k => $v) {
                $sql .= ($k == 'medias' || $k == 'invoice_logo' || $k == 'current_affiliator' || $k == 'id' || $k == 'invoice_items' || $k == 'client_name' || $k == 'added_by') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}' ";
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                if ($Req['shipping_type'] == 'shipping_to_customer' && $Req['profit'] != '' && $Req['profit'] != 0) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='" . CLIENT['id'] . "' , invoice_id ='{$id}'";
                    $sql .= ", mode ='drop_shipping' , value ='{$Req['profit']}',count_invoice_type='{$Req['count_invoice_type']}' ";
                    $sql .= ", type ='hanging'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
                    //                    echo $sql."<hr>";
                    $this->mDb->query($sql);
                }

                if ($Req['use_credit'] != "" && $Req['use_credit'] != 0) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='" . CLIENT['id'] . "' , invoice_id ='{$id}'";
                    $sql .= ", mode ='use_credit' , value ='{$Req['use_credit']}',count_invoice_type='{$Req['count_invoice_type']}'";
                    $sql .= ", type ='get'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
                    //                    echo $sql."<hr>";
                    $this->mDb->query($sql);
                }

                if ($Req['marketing_data']['client_id']) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='{$Req['marketing_data']['client_id']}' , invoice_id ='{$id}'";
                    $sql .= ", coupon_id ='{$Req['marketing_data']['coupon_id']}',count_invoice_type='{$Req['count_invoice_type']}' ";
                    $sql .= ", code ='{$Req['marketing_data']['code']}' , value ='{$Req['marketing_data']['value']}'";
                    $sql .= ", type ='hanging'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
                    $this->mDb->query($sql);
                }

                $this->userObj->updateCouponUsed($id, $Req);
                $this->addInvoiceItems($id, $Req['invoice_items'], $Req['admin_id'], $Req['invoice_type'], '', $Req['status']);
                //add  product_price To System
                //                $this->invoiceRestrictions($id, $Req); // قيود الفاتورة


                if ($Req['invoice_type'] == 'sale-invoice' && AFFILIATOR['subscription_info']['subscription_type'] == 'commission' && AFFILIATOR['subscription_info']['commission_value'] > 0) {
                    if ($Req['additional_value_pers'] == '1') {
                        $additional_value = (($Req['sup_total_price'] - $Req['discount'] - $Req['coupon_discount']) * $Req['additional_value'] / 100);
                    } else {
                        $additional_value = $Req['additional_value'];
                    }
                    $price = ($Req['total_price'] - $additional_value);

                    if (AFFILIATOR['subscription_info']['commission_rate'] == '1') {
                        $amount = ($price * (AFFILIATOR['subscription_info']['commission_value'] / 100));

                        if ($amount <= AFFILIATOR['subscription_info']['minimum_commission']) {
                            $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['minimum_commission'];
                        } else if ($amount >= AFFILIATOR['subscription_info']['maximum_commission']) {
                            $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['maximum_commission'];
                        } else {
                            $add_subscriptions['amount'] = $amount;
                        }
                    } else {
                        $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['commission_value'];
                    }
                    $add_subscriptions['transaction_id'] = $id;
                    $add_subscriptions['count_invoice_type'] = $Req['count_invoice_type'];
                    $add_subscriptions['dealer_id'] = AFFILIATOR['dealer_id'];
                    $add_subscriptions['transaction_type'] = 'commission_discount';

                    $this->userObj->addSubscriptions($add_subscriptions);
                }



                $this->completeInvoice($id, $Req);

                // if ($Req['pay_type'] == 'cash') {
                //   
                // }
                //enter lang_details
                # code...


                $data['notificationType'] = 'invoice_status';
                //                $data['client_id'] = CLIENT['id'];

                $data['client_id'] = defined('ADMIN') ? $Req['client_id'] : (CLIENT['id'] ?? 0);
                $data['invoice_id'] = $id;
                $data['count_invoice_type'] = $Req['count_invoice_type'];
                $data['page_status'] = $Req['status'];

                global $notifyObj;

                $notifyObj->sendNotificationType($data);
            }

            return $id;
        } else {
            $lastInvoice = $this->getOneInvoice($Req['invoice_edit_id']);
            $sql = "UPDATE  `invoices` SET ";
            foreach ($this->mDb->getCols('invoices', $Req) as $k => $v) {
                $sql .= ($k == 'lang_parameter' || $k == 'invoice_logo' || $k == 'current_affiliator' || $k == 'invoice_items' || $k == 'id' || $k == 'invoice_types' || $k == 'client_name' || $k == 'added_by') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " where `id` = '{$Req['invoice_edit_id']}' ";
            $res = $this->mDb->query($sql);
            if ($res) {

                $this->deleteCartItems($Req);

                $this->deleteBalanceItemsInMode($Req, 'drop_shipping');
                $this->deleteBalanceItemsInMode($Req, 'coupon_marketing');
                $this->deleteBalanceItemsInMode($Req, 'use_credit');

                $this->deleteInvoiceItems($Req['invoice_edit_id']);
                // ارجاع الكمية 

                if ($Req['invoice_type'] == 'sale-invoice') {
                    $product_stores['type'] = 'add';
                } elseif ($Req['invoice_type'] == 'receipt-invoice') {
                    $product_stores['type'] = 'remove';
                }
                for ($p = 0; $p < count($lastInvoice['invoice_items']); $p++) {
                    $product_stores['name'] = $lastInvoice['invoice_items'][$p]['product_type_name'];
                    $product_stores['product_id'] = $lastInvoice['invoice_items'][$p]['product_id'];
                    $product_stores['store_id'] = $lastInvoice['invoice_items'][$p]['store_id'];
                    $product_stores['expiration_date'] = $lastInvoice['invoice_items'][$p]['expiration_date'];
                    $product_stores['value'] = $lastInvoice['invoice_items'][$p]['quantity'];

                    $this->productsObj->addEditProductStoresAmounts($product_stores);
                    //                    //ارجاع الكمية على الرف 
                    $this->productsObj->removeProductStoresAmountsQuantityOnShelf($product_stores, $Req['status'], $lastInvoice['status']);
                }



                $this->deleteProductStoreInvoce($Req['invoice_edit_id'], $Req['invoice_type']);
                $this->addInvoiceItems($Req['invoice_edit_id'], $Req['invoice_items'], $Req['admin_id'], $Req['invoice_type'], $Req['date_added'], $Req['status']);
                $this->treasuresObj->deleteTreasures_balances($Req['invoice_edit_id'], $Req['invoice_type']);
                $Req['id'] = $Req['invoice_edit_id'];

                if ($Req['shipping_type'] == 'shipping_to_customer' && $Req['profit'] != '' && $Req['profit'] != 0) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='" . CLIENT['id'] . "' , invoice_id ='{$Req['id']}'";
                    $sql .= ", mode ='drop_shipping' , value ='{$Req['profit']}',count_invoice_type='{$Req['count_invoice_type']}'";
                    $sql .= ", type ='hanging'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
                    $this->mDb->query($sql);
                }


                if ($Req['use_credit'] != "" && $Req['use_credit'] != 0) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='" . CLIENT['id'] . "' , invoice_id ='{$Req['id']}'";
                    $sql .= ", mode ='use_credit' , value ='{$Req['use_credit']}',count_invoice_type='{$Req['count_invoice_type']}'";
                    $sql .= ", type ='get'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
                    $this->mDb->query($sql);
                }

                if ($Req['marketing_data']['client_id']) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='{$Req['marketing_data']['client_id']}' , invoice_id ='{$Req['id']}'";
                    $sql .= ", coupon_id ='{$Req['marketing_data']['coupon_id']}' ,count_invoice_type='{$Req['count_invoice_type']}'";
                    $sql .= ", code ='{$Req['marketing_data']['code']}' , value ='{$Req['marketing_data']['value']}'";
                    $sql .= ", mode ='coupon_marketing'";
                    $sql .= ", type ='hanging'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
                    $this->mDb->query($sql);
                }



                $del['transaction_id'] = $Req['id'];
                $del['dealer_id'] = AFFILIATOR['dealer_id'];
                $del['count_invoice_type'] = $Req['count_invoice_type'];
                $this->userObj->deleteSubscriptionItemsByInvoice($del);

                if ($Req['invoice_type'] == 'sale-invoice' && AFFILIATOR['subscription_info']['subscription_type'] == 'commission' && AFFILIATOR['subscription_info']['commission_value'] > 0) {
                    if ($Req['additional_value_pers'] == '1') {
                        $additional_value = (($Req['sup_total_price'] - $Req['discount'] - $Req['coupon_discount']) * $Req['additional_value'] / 100);
                    } else {
                        $additional_value = $Req['additional_value'];
                    }
                    $price = ($Req['total_price'] - $additional_value);

                    if (AFFILIATOR['subscription_info']['commission_rate'] == '1') {
                        $amount = ($price * (AFFILIATOR['subscription_info']['commission_value'] / 100));

                        if ($amount <= AFFILIATOR['subscription_info']['minimum_commission']) {
                            $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['minimum_commission'];
                        } else if ($amount >= AFFILIATOR['subscription_info']['maximum_commission']) {
                            $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['maximum_commission'];
                        } else {
                            $add_subscriptions['amount'] = $amount;
                        }
                    } else {
                        $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['commission_value'];
                    }
                    $add_subscriptions['transaction_id'] = $Req['id'];
                    $add_subscriptions['count_invoice_type'] = $Req['count_invoice_type'];
                    $add_subscriptions['dealer_id'] = AFFILIATOR['dealer_id'];
                    $add_subscriptions['transaction_type'] = 'commission_discount';

                    $this->userObj->addSubscriptions($add_subscriptions);
                }




                $this->userObj->updateCouponUsed($Req['invoice_edit_id'], $Req);
                $this->completeInvoice($Req['invoice_edit_id'], $Req);

                if ($lastInvoice) {
                    $this->historyEditInvoice($lastInvoice, $Req);
                }
            }
            return $res ? $Req['invoice_edit_id'] : $res;
        }
    }

    public function addDirectRequest($Req) {


        $Req['additional_value_pers'] = $Req['additional_value_pers'] == '1' || $Req['additional_value_pers'] == true ? '1' : '0';
        $Req['discount_pers'] = $Req['discount_pers'] == '1' || $Req['discount_pers'] == true ? '1' : '0';

        $Req['affiliator_id'] = $Req['affiliator_id'] > '0' ? $Req['affiliator_id'] : '0';
        $Req['price_difference'] = $Req['price_difference'] ? $Req['price_difference'] : '0';

        $data_table['table_name'] = "invoices";
        $data_table['type_value'] = $Req['invoice_type'];
        $data_table['column_type'] = "invoice_type";
        $data_table['column_name'] = "count_invoice_type";
        $Req['count_invoice_type'] = $this->settings->getlastTypeIdFromByTableName($data_table);
        $Req['count_invoice_type'] = $Req['count_invoice_type'] + 1;

        //  $Req['bar_code'] =  generateBarCodeKey();

        $Req['bar_code'] = $Req['count_invoice_type'];
        $Req['bar_code_image'] = date('Y-m-d') . "_" . $Req['bar_code'] . '.jpg';
        $redColor = [0, 0, 0];
        file_put_contents('../uploads/' . DEALERUPLOAD . '/barcods/' . $Req['bar_code_image'], $this->generator->getBarcode($Req['bar_code'], $this->generator::TYPE_CODE_128, 3, 50, $redColor));

//            if ($Req['is_paid'] == 'paid') {
//                $Req['status'] = 'delivered';
//            }

        $sql = "INSERT INTO `invoices` SET ";
        foreach ($this->mDb->getCols('invoices', $Req) as $k => $v) {
            $sql .= ($k == 'medias' || $k == 'invoice_logo' || $k == 'current_affiliator' || $k == 'id' || $k == 'invoice_items' || $k == 'client_name' || $k == 'added_by') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}' ";
//            echo $sql . "<hr>";
//             die();

        $res = $this->mDb->query($sql);

        if ($res) {
            $id = $this->mDb->getLastInsertId();
            if ($Req['shipping_type'] == 'shipping_to_customer' && $Req['profit'] != '' && $Req['profit'] != 0) {
                $sql = "INSERT INTO `balance` SET ";
                $sql .= " affiliator_id = '{$Req['affiliator_id']}' ";
                $sql .= ", client_id ='{$Req['client_id']}' , invoice_id ='{$id}'";
                $sql .= ", mode ='drop_shipping' , value ='{$Req['profit']}',count_invoice_type='{$Req['count_invoice_type']}' ";
                $sql .= ", type ='hanging'";
                $sql .= ", `date_added` = '{$this->dateTime}' ";
//                    echo $sql."<hr>";
                $this->mDb->query($sql);
            }

            if ($Req['use_credit'] != "" && $Req['use_credit'] != 0) {
                $sql = "INSERT INTO `balance` SET ";
                $sql .= " affiliator_id = '{$Req['affiliator_id']}' ";
                $sql .= ", client_id ='{$Req['client_id']}' , invoice_id ='{$id}'";
                $sql .= ", mode ='use_credit' , value ='{$Req['use_credit']}',count_invoice_type='{$Req['count_invoice_type']}'";
                $sql .= ", type ='get'";
                $sql .= ", `date_added` = '{$this->dateTime}' ";
//                    echo $sql."<hr>";
                $this->mDb->query($sql);
            }

            if ($Req['marketing_data']['client_id']) {
                $sql = "INSERT INTO `balance` SET ";
                $sql .= " affiliator_id = '{$Req['affiliator_id']}'  ";
                $sql .= ", client_id ='{$Req['marketing_data']['client_id']}' , invoice_id ='{$id}'";
                $sql .= ", coupon_id ='{$Req['marketing_data']['coupon_id']}',count_invoice_type='{$Req['count_invoice_type']}' ";
                $sql .= ", code ='{$Req['marketing_data']['code']}' , value ='{$Req['marketing_data']['value']}'";
                $sql .= ", type ='hanging'";
                $sql .= ", `date_added` = '{$this->dateTime}' ";
                $this->mDb->query($sql);
            }

            $this->userObj->updateCouponUsed($id, $Req);
            $this->addInvoiceItems($id, $Req['invoice_items'], $Req['admin_id'], $Req['invoice_type'], '', $Req['status']);
            //add  product_price To System
//                $this->invoiceRestrictions($id, $Req); // قيود الفاتورة


            if ($Req['invoice_type'] == 'sale-invoice' && AFFILIATOR['subscription_info']['subscription_type'] == 'commission' && AFFILIATOR['subscription_info']['commission_value'] > 0) {
                if ($Req['additional_value_pers'] == '1') {
                    $additional_value = (($Req['sup_total_price'] - $Req['discount'] - $Req['coupon_discount']) * $Req['additional_value'] / 100);
                } else {
                    $additional_value = $Req['additional_value'];
                }
                $price = ($Req['total_price'] - $additional_value);

                if (AFFILIATOR['subscription_info']['commission_rate'] == '1') {
                    $amount = ($price * (AFFILIATOR['subscription_info']['commission_value'] / 100));

                    if ($amount <= AFFILIATOR['subscription_info']['minimum_commission']) {
                        $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['minimum_commission'];
                    } else if ($amount >= AFFILIATOR['subscription_info']['maximum_commission']) {
                        $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['maximum_commission'];
                    } else {
                        $add_subscriptions['amount'] = $amount;
                    }
                } else {
                    $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['commission_value'];
                }
                $add_subscriptions['transaction_id'] = $id;
                $add_subscriptions['count_invoice_type'] = $Req['count_invoice_type'];
                $add_subscriptions['dealer_id'] = AFFILIATOR['dealer_id'];
                $add_subscriptions['transaction_type'] = 'commission_discount';

                $this->userObj->addSubscriptions($add_subscriptions);
            }



            $this->completeInvoice($id, $Req);

            // if ($Req['pay_type'] == 'cash') {
            //   
            // }
            //enter lang_details
            # code...


            $data['notificationType'] = 'invoice_status';
//                $data['client_id'] = CLIENT['id'];
            $data['client_id'] = $Req['client_id'];
            $data['invoice_id'] = $id;
            $data['count_invoice_type'] = $Req['count_invoice_type'];
            $data['page_status'] = $Req['status'];

            global $notifyObj;

            $notifyObj->sendNotificationType($data);
        }

        return $id;
    }

    public function addEditInvoiceByAdmin($Req) {

//        p($Req);
        // echo $this->time;
        // echo "<pre>";print_r($Req);die();
//echo 'invoice_edit_id='.$Req['invoice_edit_id']."<hr>";

        if (!$Req['invoice_edit_id']) {
            $Req['additional_value_pers'] = $Req['additional_value_pers'] == '1' || $Req['additional_value_pers'] == true ? '1' : '0';
            $Req['discount_pers'] = $Req['discount_pers'] == '1' || $Req['discount_pers'] == true ? '1' : '0';

            $Req['affiliator_id'] = $Req['affiliator_id'] > '0' ? $Req['affiliator_id'] : '0';
            $Req['price_difference'] = $Req['price_difference'] ? $Req['price_difference'] : '0';

            $data_table['table_name'] = "invoices";
            $data_table['type_value'] = $Req['invoice_type'];
            $data_table['column_type'] = "invoice_type";
            $data_table['column_name'] = "count_invoice_type";
            $Req['count_invoice_type'] = $this->settings->getlastTypeIdFromByTableName($data_table);
            $Req['count_invoice_type'] = $Req['count_invoice_type'] + 1;

            //  $Req['bar_code'] =  generateBarCodeKey();

            $Req['bar_code'] = $Req['count_invoice_type'];
            $Req['bar_code_image'] = date('Y-m-d') . "_" . $Req['bar_code'] . '.jpg';
            $redColor = [0, 0, 0];
            file_put_contents('../uploads/' . DEALERUPLOAD . '/barcods/' . $Req['bar_code_image'], $this->generator->getBarcode($Req['bar_code'], $this->generator::TYPE_CODE_128, 3, 50, $redColor));

//            if ($Req['is_paid'] == 'paid') {
//                $Req['status'] = 'delivered';
//            }

            $sql = "INSERT INTO `invoices` SET ";
            foreach ($this->mDb->getCols('invoices', $Req) as $k => $v) {
                $sql .= ($k == 'medias' || $k == 'invoice_logo' || $k == 'current_affiliator' || $k == 'id' || $k == 'invoice_items' || $k == 'client_name' || $k == 'added_by') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}' ";
//            echo $sql . "<hr>";
//             die();

            $res = $this->mDb->query($sql);

            if ($res) {
                $id = $this->mDb->getLastInsertId();
                if ($Req['shipping_type'] == 'shipping_to_customer' && $Req['profit'] != '' && $Req['profit'] != 0) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='" . CLIENT['id'] . "' , invoice_id ='{$id}'";
                    $sql .= ", mode ='drop_shipping' , value ='{$Req['profit']}',count_invoice_type='{$Req['count_invoice_type']}' ";
                    $sql .= ", type ='hanging'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
//                    echo $sql."<hr>";
                    $this->mDb->query($sql);
                }

                if ($Req['use_credit'] != "" && $Req['use_credit'] != 0) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='" . CLIENT['id'] . "' , invoice_id ='{$id}'";
                    $sql .= ", mode ='use_credit' , value ='{$Req['use_credit']}',count_invoice_type='{$Req['count_invoice_type']}'";
                    $sql .= ", type ='get'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
//                    echo $sql."<hr>";
                    $this->mDb->query($sql);
                }

                if ($Req['marketing_data']['client_id']) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='{$Req['marketing_data']['client_id']}' , invoice_id ='{$id}'";
                    $sql .= ", coupon_id ='{$Req['marketing_data']['coupon_id']}',count_invoice_type='{$Req['count_invoice_type']}' ";
                    $sql .= ", code ='{$Req['marketing_data']['code']}' , value ='{$Req['marketing_data']['value']}'";
                    $sql .= ", type ='hanging'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
                    $this->mDb->query($sql);
                }

                $this->userObj->updateCouponUsed($id, $Req);
                $this->addInvoiceItems($id, $Req['invoice_items'], $Req['admin_id'], $Req['invoice_type'], '', $Req['status']);
                //add  product_price To System
//                $this->invoiceRestrictions($id, $Req); // قيود الفاتورة


                if ($Req['invoice_type'] == 'sale-invoice' && AFFILIATOR['subscription_info']['subscription_type'] == 'commission' && AFFILIATOR['subscription_info']['commission_value'] > 0) {
                    if ($Req['additional_value_pers'] == '1') {
                        $additional_value = (($Req['sup_total_price'] - $Req['discount'] - $Req['coupon_discount']) * $Req['additional_value'] / 100);
                    } else {
                        $additional_value = $Req['additional_value'];
                    }
                    $price = ($Req['total_price'] - $additional_value);

                    if (AFFILIATOR['subscription_info']['commission_rate'] == '1') {
                        $amount = ($price * (AFFILIATOR['subscription_info']['commission_value'] / 100));

                        if ($amount <= AFFILIATOR['subscription_info']['minimum_commission']) {
                            $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['minimum_commission'];
                        } else if ($amount >= AFFILIATOR['subscription_info']['maximum_commission']) {
                            $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['maximum_commission'];
                        } else {
                            $add_subscriptions['amount'] = $amount;
                        }
                    } else {
                        $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['commission_value'];
                    }
                    $add_subscriptions['transaction_id'] = $id;
                    $add_subscriptions['count_invoice_type'] = $Req['count_invoice_type'];
                    $add_subscriptions['dealer_id'] = AFFILIATOR['dealer_id'];
                    $add_subscriptions['transaction_type'] = 'commission_discount';

                    $this->userObj->addSubscriptions($add_subscriptions);
                }



                $this->completeInvoice($id, $Req);

                // if ($Req['pay_type'] == 'cash') {
                //   
                // }
                //enter lang_details
                # code...


                $data['notificationType'] = 'invoice_status';
//                $data['client_id'] = CLIENT['id'];
                $data['client_id'] = ADMIN['id'] ? $Req['client_id'] : CLIENT['id'];
                $data['invoice_id'] = $id;
                $data['count_invoice_type'] = $Req['count_invoice_type'];
                $data['page_status'] = $Req['status'];

                global $notifyObj;

                $notifyObj->sendNotificationType($data);
            }
            $newRes['id'] = $id;
            $newRes['count_invoice_type'] = $Req['count_invoice_type'];
            return $newRes;
        } else {

            $lastInvoice = $this->getOneInvoiceByAdmin($Req['invoice_edit_id']);
//  p($Req);
            $sql = "UPDATE  `invoices` SET ";
            foreach ($this->mDb->getCols('invoices', $Req) as $k => $v) {
                $sql .= ($k == 'lang_parameter' || $k == 'invoice_logo' || $k == 'current_affiliator' || $k == 'invoice_items' || $k == 'id' || $k == 'invoice_types' || $k == 'client_name' || $k == 'added_by') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " where `id` = '{$Req['invoice_edit_id']}' ";
//            echo $sql."<hr>";
//             p($sql);
            // die($sql);
            $res = $this->mDb->query($sql);

            if ($res) {

                $this->deleteCartItems($Req);

                $this->deleteBalanceItemsInMode($Req, 'drop_shipping');
                $this->deleteBalanceItemsInMode($Req, 'coupon_marketing');
                $this->deleteBalanceItemsInMode($Req, 'use_credit');

                $this->deleteInvoiceItems($Req['invoice_edit_id']);
                // ارجاع الكمية 

                if ($Req['invoice_type'] == 'sale-invoice') {
                    $product_stores['type'] = 'add';
                } elseif ($Req['invoice_type'] == 'receipt-invoice') {
                    $product_stores['type'] = 'remove';
                }
                for ($p = 0; $p < count($lastInvoice['invoice_items']); $p++) {
                    $product_stores['name'] = $lastInvoice['invoice_items'][$p]['product_type_name'];
                    $product_stores['product_id'] = $lastInvoice['invoice_items'][$p]['product_id'];
                    $product_stores['store_id'] = $lastInvoice['invoice_items'][$p]['store_id'];
                    $product_stores['expiration_date'] = $lastInvoice['invoice_items'][$p]['expiration_date'];
                    $product_stores['value'] = $lastInvoice['invoice_items'][$p]['quantity'];

                    $this->productsObj->addEditProductStoresAmounts($product_stores);
                }



                $this->deleteProductStoreInvoce($Req['invoice_edit_id'], $Req['invoice_type']);
                $this->addInvoiceItems($Req['invoice_edit_id'], $Req['invoice_items'], $Req['admin_id'], $Req['invoice_type'], $Req['date_added'], $Req['status']);
                $this->treasuresObj->deleteTreasures_balances($Req['invoice_edit_id'], $Req['invoice_type']);
                $Req['id'] = $Req['invoice_edit_id'];

                if ($Req['shipping_type'] == 'shipping_to_customer' && $Req['profit'] != '' && $Req['profit'] != 0) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='" . CLIENT['id'] . "' , invoice_id ='{$Req['id']}'";
                    $sql .= ", mode ='drop_shipping' , value ='{$Req['profit']}',count_invoice_type='{$Req['count_invoice_type']}'";
                    $sql .= ", type ='hanging'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
//                     echo $sql."<hr>";
                    $this->mDb->query($sql);
                }


                if ($Req['use_credit'] != "" && $Req['use_credit'] != 0) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='" . CLIENT['id'] . "' , invoice_id ='{$Req['id']}'";
                    $sql .= ", mode ='use_credit' , value ='{$Req['use_credit']}',count_invoice_type='{$Req['count_invoice_type']}'";
                    $sql .= ", type ='get'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
//                    echo $sql."<hr>";
                    $this->mDb->query($sql);
                }

                if ($Req['marketing_data']['client_id']) {
                    $sql = "INSERT INTO `balance` SET ";
                    $sql .= " affiliator_id = " . AFFILIATOR['id'] . "  ";
                    $sql .= ", client_id ='{$Req['marketing_data']['client_id']}' , invoice_id ='{$Req['id']}'";
                    $sql .= ", coupon_id ='{$Req['marketing_data']['coupon_id']}' ,count_invoice_type='{$Req['count_invoice_type']}'";
                    $sql .= ", code ='{$Req['marketing_data']['code']}' , value ='{$Req['marketing_data']['value']}'";
                    $sql .= ", mode ='coupon_marketing'";
                    $sql .= ", type ='hanging'";
                    $sql .= ", `date_added` = '{$this->dateTime}' ";
                    $this->mDb->query($sql);
                }



                $del['transaction_id'] = $Req['id'];
                $del['dealer_id'] = AFFILIATOR['dealer_id'];
                $del['count_invoice_type'] = $Req['count_invoice_type'];
                $this->userObj->deleteSubscriptionItemsByInvoice($del);

                if ($Req['invoice_type'] == 'sale-invoice' && AFFILIATOR['subscription_info']['subscription_type'] == 'commission' && AFFILIATOR['subscription_info']['commission_value'] > 0) {
                    if ($Req['additional_value_pers'] == '1') {
                        $additional_value = (($Req['sup_total_price'] - $Req['discount'] - $Req['coupon_discount']) * $Req['additional_value'] / 100);
                    } else {
                        $additional_value = $Req['additional_value'];
                    }
                    $price = ($Req['total_price'] - $additional_value);

                    if (AFFILIATOR['subscription_info']['commission_rate'] == '1') {
                        $amount = ($price * (AFFILIATOR['subscription_info']['commission_value'] / 100));

                        if ($amount <= AFFILIATOR['subscription_info']['minimum_commission']) {
                            $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['minimum_commission'];
                        } else if ($amount >= AFFILIATOR['subscription_info']['maximum_commission']) {
                            $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['maximum_commission'];
                        } else {
                            $add_subscriptions['amount'] = $amount;
                        }
                    } else {
                        $add_subscriptions['amount'] = AFFILIATOR['subscription_info']['commission_value'];
                    }
                    $add_subscriptions['transaction_id'] = $Req['id'];
                    $add_subscriptions['count_invoice_type'] = $Req['count_invoice_type'];
                    $add_subscriptions['dealer_id'] = AFFILIATOR['dealer_id'];
                    $add_subscriptions['transaction_type'] = 'commission_discount';

                    $this->userObj->addSubscriptions($add_subscriptions);
                }




                $this->userObj->updateCouponUsed($Req['invoice_edit_id'], $Req);

//                $this->invoiceRestrictions($Req['invoice_edit_id'], $Req); // قيود الفاتورة
                $this->completeInvoice($Req['invoice_edit_id'], $Req);

                if ($lastInvoice) {
                    $this->historyEditInvoice($lastInvoice, $Req);
                }
            }
            //  echo $sql; die();

            $newRes['id'] = $res ? $Req['invoice_edit_id'] : $res;
            $newRes['count_invoice_type'] = $lastInvoice['count_invoice_type'];

            return $newRes;
        }
        //No Edit
    }

    public function addInvoicesAdjustShelves($Req) {





//            $Req['bar_code'] = $Req['count_invoice_type'];
//            $Req['bar_code_image'] = date('Y-m-d') . "_" . $Req['bar_code'] . '.jpg';
//            $redColor = [0, 0, 0];
//            file_put_contents('../uploads/'.DEALERUPLOAD.'/barcods/' . $Req['bar_code_image'], $this->generator->getBarcode($Req['bar_code'], $this->generator::TYPE_CODE_128, 3, 50, $redColor));



        $sql = "INSERT INTO `adjust_shelves_invoices` SET ";
        foreach ($this->mDb->getCols('invoices', $Req) as $k => $v) {
            $sql .= ( $k == 'id' || $k == 'invoice_items' ) ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}' ";
//            echo $sql . "<hr>";
//             die();

        $res = $this->mDb->query($sql);

        if ($res) {
            $id = $this->mDb->getLastInsertId();

            $this->addInvoicesAdjustShelvesItems($id, $Req['invoice_items']);
        }
        $newRes['id'] = $id;
        $newRes['count_invoice_type'] = $Req['count_invoice_type'];
        return $newRes;
    }

    public function getInvoiceProductsList($invoice_id, $invoice_type) {
        $sql = "SELECT * FROM `invoice_items`    ";
        $sql .= " WHERE  invoice_id = '{$invoice_id}'  ";
        // echo "<pre>";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function getInvoiceProductsItems($invoice_id) {
        global $productsObj;
        $sql = "SELECT 
                    ii.*,
                    p.product_barcode, 
                    pl.name as product_name
                FROM invoice_items ii
                LEFT JOIN `products` p  ON ii.product_id = p.id
                LEFT JOIN `product_langs` pl ON pl.product_id = p.id AND pl.lang_code = :lang_code
                WHERE  ii.invoice_id = :invoice_id
                ORDER BY ii.date_added DESC ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':invoice_id', $invoice_id);
        $stmt->bindParam(':lang_code', $this->lang_code);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['images'] = $this->getProductimgs($res[$i]['product_id'], 1);
                $res[$i]['image'] = $res[$i]['images'][0]['name'];
                $res[$i]['product_services'] = $productsObj->getProduct_services($res[$i]['product_id']);
                $res[$i]['store_amounts'] = $productsObj->getProductStoreAmounts($res[$i]['product_id'], $res[$i]['store_id']);
                $res[$i]['store_title'] = $this->getStoreTitle($res[$i]['store_id']);
                $res[$i]['parent_expiration_date'] = '0';
                for ($e = 0; $e < count($res[$i]['product_services']); $e++) {
                    if ($res[$i]['product_services'][$e]['parent_expiration_date'] == '1') {
                        $res[$i]['parent_expiration_date'] = '1';
                    }
                }
            }
        }
        return $res;
    }

//    public function getInvoiceProductsItems($invoice_id, $invoice_type) {
//        global $productsObj;
//        $sql = "SELECT ii.*, p.product_barcode, pl.name as product_name ";
//        $sql .= " FROM `invoice_items` ii  ";
//        $sql .= " LEFT JOIN `products` p  ON ii.product_id = p.id ";
//        $sql .= "LEFT JOIN `product_langs` pl ON pl.product_id = p.id AND pl.lang_code = '{$this->lang_code}' ";
//        $sql .= "WHERE  ii.`invoice_id`='{$invoice_id}' ";
////        $sql .= "GROUP BY p.id ";
//        $sql .= "ORDER BY ii.date_added DESC ";
//
////       echo $sql . "<hr>";
//        $res = $this->mDb->getAll($sql);
//        if ($res) {
//            for ($i = 0; $i < count($res); $i++) {
//                $res[$i]['images'] = $this->getProductimgs($res[$i]['product_id'], 1);
//                $res[$i]['image'] = $res[$i]['images'][0]['name'];
//
//                $res[$i]['product_services'] = $productsObj->getProduct_services($res[$i]['product_id']);
//                $res[$i]['store_amounts'] = $productsObj->getProductStoreAmounts($res[$i]['product_id'], $res[$i]['store_id']);
//                $res[$i]['store_title'] = $this->getStoreTitle($res[$i]['store_id']);
//                $res[$i]['parent_expiration_date'] = '0';
//                for ($e = 0; $e < count($res[$i]['product_services']); $e++) {
//                    if ($res[$i]['product_services'][$e]['parent_expiration_date'] == '1') {
//                        $res[$i]['parent_expiration_date'] = '1';
//                    }
//                }
//            }
//        }
//        return $res;
//    }

    public function getStoreTitle($id) {
        $sql = "SELECT  title FROM `store_langs` ";
        $sql .= " WHERE  `store_id` = '{$id}'  AND lang_code = '{$this->lang_code}'  ";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getInvoiceAddRestrictions($id) {
        $sql = "SELECT id,invoice_type,count_invoice_type,client_id,total_price,additional_value,additional_value_pers,sup_total_price";
        $sql .= ",discount,coupon_discount,tax_pres,discount_pers,invoice_discount,is_paid,use_credit ";
        $sql .= " FROM `invoices`   ";
        $sql .= " WHERE  id = '{$id}'";

        // echo $sql;
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['invoice_items'] = $this->getInvoiceProductsList($res['id'], $res['invoice_type']);

            return $res;
        }
    }

    public function getInvoiceOneByAdmin($id) {
        $sql = "SELECT 
                    i.*,
                    u.user_name as affiliator_name
                FROM invoices i
                LEFT JOIN users u ON u.id = i.affiliator_id
                WHERE i.id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($res) {
            $res['invoice_items'] = $this->getInvoiceProductsItems($res['id']);
            $res['products_count'] = $this->getInvoiceProductsCount($res['id']);
            return $res;
        }
    }

    public function getOneAdjustShelvesByAdmin($id) {
        $sql = "SELECT * ";
        $sql .= " FROM `adjust_shelves_invoices`   ";
        $sql .= " WHERE  id = '{$id}'";
        $sql .= " AND ( `admin_id` ='" . ADMIN['id'] . "'  and  set_from='app') ";

        // echo $sql;
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['invoice_items'] = $this->getAdjustShelvesList($res['id']);

            return $res;
        }
    }

    public function getAdjustShelvesList($id) {
        $sql = "SELECT asi.shelf_id as id ,sas.name ,sas.store_id,asi.invoice_id ";
        $sql .= " FROM `adjust_shelves_invoices_items`  asi ";
        $sql .= " LEFT JOIN `store_adjust_shelves` sas  ON sas.id = asi.shelf_id ";
        $sql .= " WHERE  invoice_id = '{$id}'";
        $sql .= " group by  asi.shelf_id ";
        // echo $sql;
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {

                $res[$i]['products'] = $this->getAllProductsByShelfId($res[$i]['id'], $res[$i]['invoice_id']);
            }
        }

        return $res;
    }

    public function getAllProductsByShelfId($shelf_id, $invoice_id) {
        $sql = "SELECT asi.id,asi.product_id,asi.store_id,asi.scan_date,pl.name as product_name,p.product_barcode   ";
        $sql .= " FROM `adjust_shelves_invoices_items`  asi ";
        $sql .= " LEFT JOIN `products` p  ON p.id = asi.product_id ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = '{$this->lang_code}'";
        $sql .= " WHERE  asi.shelf_id = '{$shelf_id}' and asi.invoice_id='{$invoice_id}' ";

//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['store_title'] = $this->getStoreTitle($res[$i]['store_id']);
                $images = $this->getProductimgs($res[$i]['product_id'], 1);
                $res[$i]['image'] = $images[0]['name'];
            }
        }

        return $res;
    }

    public function deleteAdjustShelvesById($id) {

        $sql = "DELETE asi, asii FROM  `adjust_shelves_invoices` asi ";
        $sql .= " LEFT JOIN `adjust_shelves_invoices_items` asii ON asi.id = asii.invoice_id   ";
        $sql .= " WHERE asi.id='{$id}'  ";
        $sql .= " AND (asi.`admin_id` ='" . ADMIN['id'] . "'  and asi.set_from='app') ";
//       echo $sql."<hr>";
        return $this->mDb->query($sql);
    }

    public function invoiceRestrictions($id) {
        $Req = $this->getInvoiceAddRestrictions($id);

        ///////////////////      قيود فواتير البيع    ///////////////////
        $newArray = array();
        $data_table['table_name'] = "daily_restrictions";
        $data_table['column_name'] = "count_restrictions";
        $newArray['count_restrictions'] = $this->settings->getlastIdFromByTableName($data_table);
        $newArray['count_restrictions'] = $newArray['count_restrictions'] + 1;
        $newArray['type'] = 'sales-invoice';
        $newArray['invoice_id'] = $id;
        $newArray['mode'] = $Req['invoice_type'];
        $newArray['count_invoice_type'] = $Req['count_invoice_type'];
        $newArray['description'] = ' فاتورة بيع رقم : ' . $Req['count_invoice_type'];

        $newArray['list'] = array();
// حساب العميل 
        $account_code = $this->getAccountCodeByUser($Req['client_id']);
        if ($account_code && ($Req['total_price'] - $Req['use_credit']) > 0) {
            $list = array();
            $list['account_code'] = $account_code;
            $list['description'] = $newArray['description'];
            $list['debtor'] = ($Req['total_price'] - $Req['use_credit']); // مدين
            $list['creditor'] = "0"; // دائن
            array_push($newArray['list'], $list);
        }
        $account_code = $this->getAccountCodeByRoutingKey('shipping_expenses', '1'); // حساب مصاريف شحن المبيعات

        if ($Req['additional_value_pers']) {
            $creditor = ($Req['additional_value'] * $Req['sup_total_price'] / 100);
        } else {
            $creditor = ($Req['additional_value']);
        }

        if ($account_code && ($creditor) > 0) {
            $list = array();
            $list['account_code'] = $account_code;
            $list['description'] = $newArray['description'];
            $list['debtor'] = '0'; // مدين
            $list['creditor'] = $creditor; // دائن
            array_push($newArray['list'], $list);
        }

        $account_code = $this->getAccountCodeByRoutingKey('sales', '1'); // حساب  المبيعات
        if ($account_code && ($Req['sup_total_price'] - $Req['discount'] - $Req['coupon_discount']) > 0) {
            $list = array();
            $list['account_code'] = $account_code;
            $list['description'] = $newArray['description'];
            $list['debtor'] = '0'; // مدين
            $list['creditor'] = ($Req['sup_total_price'] - $Req['discount'] - $Req['coupon_discount']); // دائن
            array_push($newArray['list'], $list);
        }

        $account_code = $this->getAccountCodeByRoutingKey('tax', '1'); // حساب  الضريبة
        if ($account_code && ($Req['tax_pres'] * $Req['sup_total_price'] / 100) > 0) {
            $list = array();
            $list['account_code'] = $account_code;
            $list['description'] = $newArray['description'];
            $list['debtor'] = '0'; // مدين
            $list['creditor'] = ($Req['tax_pres'] * $Req['sup_total_price'] / 100); // دائن
            array_push($newArray['list'], $list);
        }

        $account_code = $this->getAccountCodeByRoutingKey('discount_Permissible', '1'); // حساب   الخصم    
        if ($Req['discount_pers']) {
            $creditor = ($Req['invoice_discount'] * $Req['total_price'] / 100);
        } else {
            $creditor = ($Req['invoice_discount']);
        }
        if ($account_code && ($creditor) > 0) {
            $list = array();
            $list['account_code'] = $account_code;
            $list['description'] = $newArray['description'];
            $list['debtor'] = '0'; // مدين
            $list['creditor'] = ($creditor); // دائن
            array_push($newArray['list'], $list);
        }
        $this->addEditRestrictions($newArray);

        ///////////////////////     قيود تكلفة المبيعات       ///////////////////////

        $newArray = array();
        $data_table['table_name'] = "daily_restrictions";
        $data_table['column_name'] = "count_restrictions";
        $newArray['count_restrictions'] = $this->settings->getlastIdFromByTableName($data_table);
        $newArray['count_restrictions'] = $newArray['count_restrictions'] + 1;
        $newArray['type'] = 'sales-cost';
        $newArray['invoice_id'] = $id;
        $newArray['mode'] = $Req['invoice_type'];
        $newArray['count_invoice_type'] = $Req['count_invoice_type'];
        $newArray['description'] = ' تكلفة مبيعات فاتورة بيع رقم : ' . $Req['count_invoice_type'];

        $newArray['list'] = array();
        // حساب  تكلفة المبيعات
        $account_code = $this->getAccountCodeByRoutingKey('sales_cost', '1');

        $debtor = 0;
        foreach ($Req['invoice_items'] as $k => $v) {
            $debtor += ($v['cost'] * $v['quantity']);
        }
        if ($account_code && ($debtor) > 0) {
            $list = array();
            $list['account_code'] = $account_code;
            $list['description'] = $newArray['description'];
            $list['debtor'] = $debtor; // مدين
            $list['creditor'] = '0'; // دائن
            array_push($newArray['list'], $list);
        }
//        // حساب   المخزن

        $creditor = array();
        foreach ($Req['invoice_items'] as $k => $v) {
            if ($v['is_gift'] == '0') {
                $creditor[$v['store_id']] += ($v['cost'] * $v['quantity']);
            }
        }

        foreach ($creditor as $k => $v) {
            $account_code = $this->getAccountCodeByStores($k);
            if ($account_code && $v > 0) {
                $list = array();
                $list['account_code'] = $account_code;
                $list['description'] = $newArray['description'];
                $list['debtor'] = "0"; // مدين
                $list['creditor'] = $v; // دائن
                array_push($newArray['list'], $list);
            }
        }

        $this->addEditRestrictions($newArray);

        if ($Req['is_paid'] == 'partially_paid' || $Req['is_paid'] == 'paid') {
            ///////////////////////     قيود مدفوعات العميل       ///////////////////////

            $allVoucher = $this->getVoucherByInvoice($id);
//            echo "<pre>";
//            print_r($allVoucher);
//            echo "</pre>";
            if (count($allVoucher) > 0) {
                foreach ($allVoucher as $k => $v) {

                    $newArray = array();
                    $data_table['table_name'] = "daily_restrictions";
                    $data_table['column_name'] = "count_restrictions";
                    $newArray['count_restrictions'] = $this->settings->getlastIdFromByTableName($data_table);
                    $newArray['count_restrictions'] = $newArray['count_restrictions'] + 1;
                    $newArray['type'] = 'client-payments';
                    $newArray['invoice_id'] = $id;
                    $newArray['mode'] = $Req['invoice_type'];
                    $newArray['count_invoice_type'] = $Req['count_invoice_type'];
                    $newArray['voucher_id'] = $v['id'];
                    $newArray['dateTime'] = $v['date_added'];
                    $newArray['description'] = '  مدفوعات عميل -  فاتورة بيع رقم : ' . $Req['count_invoice_type'];

                    $newArray['list'] = array();

                    $account_code = $this->getAccountCodeBySafe($v['treasure_id']);
                    if ($account_code && $v['price'] > 0) {
                        $list = array();
                        $list['account_code'] = $account_code;
                        $list['description'] = $newArray['description'];
                        $list['debtor'] = $v['price']; // مدين
                        $list['creditor'] = "0"; // دائن
                        array_push($newArray['list'], $list);
                    }

                    // حساب العميل 
                    $account_code = $this->getAccountCodeByUser($Req['client_id']);
//                    echo $account_code."<hr>";
                    if ($account_code && $v['price'] > 0) {
                        $list = array();
                        $list['account_code'] = $account_code;
                        $list['description'] = $newArray['description'];
                        $list['debtor'] = "0"; // مدين
                        $list['creditor'] = $v['price']; // دائن
                        array_push($newArray['list'], $list);
                    }
                    $this->addEditRestrictions($newArray);
                }
            }
        }
        return $Req;
    }

    public function getVoucherByInvoice($invoiceId) {

        $sql = "SELECT * FROM `vouchers` ";
        $sql .= " WHERE id > 0 ";
        $sql .= $invoiceId ? " AND (`for_id` ='{$invoiceId}' ) " : '';
        $sql .= " ORDER BY  id ASC ";
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    public function getAccountCodeByRoutingKey($routing_key, $parent) {

        $sql = "SELECT account_code FROM `{$this->mPrefix}accounts_routing_list`   ";
        $sql .= "WHERE routing_key = '{$routing_key}' and parent ='{$parent}' ";

        $res = $this->mDb->getOne($sql);

//        echo $sql."<hr>";
        return $res;
    }

    public function getdailyRestrictionsId($invoice_id, $mode, $type, $voucher_id = '') {
        $sql = "SELECT id   FROM `daily_restrictions` where invoice_id ='{$invoice_id}' and mode='{$mode}' and type='{$type}' ";
        $sql .= $voucher_id ? " and voucher_id ='{$voucher_id}'" : "";
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    public function getAccountCodeByUser($id) {
        $sql = "SELECT account_code   FROM `users` where id ='{$id}' ";
        return $this->mDb->getOne($sql);
    }

    public function getAccountCodeByStores($id) {
        $sql = "SELECT account_code   FROM `stores` where id ='{$id}' ";
        return $this->mDb->getOne($sql);
    }

    public function getAccountCodeBySafe($id) {
        $sql = "SELECT account_code   FROM `treasures` where id ='{$id}' ";
        return $this->mDb->getOne($sql);
    }

    public function addEditRestrictions($data) {
        $dateTime = $data['dateTime'] ? $data['dateTime'] : $this->dateTime;
        $p_d = $this->getdailyRestrictionsId($data['invoice_id'], $data['mode'], $data['type'], $data['voucher_id']);
        if ($p_d) {
            $this->addRestrictionsList($data['list'], $p_d);
        } else {


            $sql = "INSERT INTO `daily_restrictions` SET ";
            foreach ($this->mDb->getCols('daily_restrictions', $data) as $k => $v) {
                $sql .= ($k == 'id' || $k == 'list') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$dateTime}' ";
// echo $sql  ;die();
            $id = $this->mDb->queryreturnlastid($sql);
            if ($id) {
                for ($i = 0; $i < count($data['list']); $i++) {
                    $sql = "INSERT INTO `daily_restrictions_list` SET ";
                    foreach ($this->mDb->getCols('daily_restrictions_list', $data['list'][$i]) as $k => $v) {
                        $sql .= ($k == 'id' || $k == 'list') ? "" : "`{$k}`='{$v}',";
                    }
                    $sql .= "p_id='{$id}', `date_added` = '{$this->dateTime}' ";

                    $this->mDb->queryreturnlastid($sql);
                }
            }

            return $id;
        }
    }

    public function addRestrictionsList($data, $p_id) {
        if ($p_id) {
            $this->deleteDailyRestrictionsList($p_id);

            for ($i = 0; $i < count($data); $i++) {
                $sql = "INSERT INTO `daily_restrictions_list` SET ";
                foreach ($this->mDb->getCols('daily_restrictions_list', $data[$i]) as $k => $v) {
                    $sql .= ($k == 'id' || $k == 'list') ? "" : "`{$k}`='{$v}',";
                }
                $sql .= "p_id='{$p_id}', `date_added` = '{$this->dateTime}' ";
//echo $sql."<hr>";
                $this->mDb->queryreturnlastid($sql);
            }
        }

        return $p_id;
    }

    public function deleteDailyRestrictionsList($p_id) {
        $sql = "DELETE FROM  `daily_restrictions_list` ";
        $sql .= " WHERE  p_id ='{$p_id}'   ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function historyEditInvoice($dataLast, $Req) {
        $edit = false;
        $sql = "INSERT INTO history_edit_invoice
                    (
                        admin_id,
                        invoice_id, 
                        mode, 
                        product_id, 
                        quantity_last,
                        quantity,
                        price_last,
                        price,
                        notes_last,
                        notes,
                        status_last,
                        status,
                        date_added,
                        shipping_company,
                        shipping_company_last,
                        shipping_value,
                        shipping_value_last,
                        invoice_discount,
                        invoice_discount_last
                    ) VALUES ";
        // $admin_id = (defined('CLIENT') && isset(CLIENT['id']) ? CLIENT['id'] : null) 
        // ?? (defined('ADMIN') && isset(ADMIN['id']) ? ADMIN['id'] : null);
        $admin_id = (CLIENT['id'] ?? null) ?? (ADMIN['id'] ?? null);

        if ($dataLast['status'] != $Req['status']) {
            $edit = true;
            $status = $Req['status'] ? "'{$Req['status']}'" : 'null';
            $statusLast = $dataLast['status'] ? "'{$dataLast['status']}'" : 'null';
            $sql .= "($admin_id,'{$Req['id']}','change_invoice_status','0','0','0','0','0',null,null,{$statusLast},{$status},'{$this->dateTime}',0,0,0,0,0,0),";
        }
        if ($dataLast['note'] != $Req['note']) {
            $edit = true;
            $note = $Req['note'] ? "'{$Req['note']}'" : 'null';
            $noteLast = $dataLast['note'] ? "'{$dataLast['note']}'" : 'null';
            $sql .= "($admin_id,'{$Req['id']}','change_note','0','0','0','0','0',{$noteLast},{$note},null,null,'{$this->dateTime}',0,0,0,0,0,0),";
        }
        if (!empty($Req['shipment_id']) && ($dataLast['shipment_id'] !== $Req['shipment_id'])) {
            $edit = true;
            $shipping_company = $Req['shipment_id'];
            $shipping_company_Last = $dataLast['shipment_id'];
            $sql .= "($admin_id,'{$Req['id']}','change_shipping_company','0','0','0','0','0',null,null,null,null,'{$this->dateTime}',$shipping_company,$shipping_company_Last,0,0,0,0),";
        }
        if ($dataLast['shipment_value'] != $Req['shipment_value']) {
            $edit = true;
            $shipping_value = $Req['shipment_value'];
            $shipping_value_Last = $dataLast['shipment_value'];
            $sql .= "($admin_id,'{$Req['id']}','change_shipping_value','0','0','0','0','0',null,null,null,null,'{$this->dateTime}',0,0,$shipping_value,$shipping_value_Last,0,0),";
        }
        //NO DELETE 
        // if ($dataLast['invoice_discount'] != $Req['invoice_discount']) {
        //     $edit = true;
        //     $invoice_discount = $Req['invoice_discount'];
        //     $invoice_discount_Last = $dataLast['invoice_discount'];
        //     $sql .= "($admin_id,'{$Req['id']}','change_invoice_discount','0','0','0','0','0',null,null,null,null,'{$this->dateTime}',0,0,0,0,$invoice_discount,$invoice_discount_Last),";
        // }
        for ($i = 0; $i < count($Req['invoice_items']); $i++) {
            $index = array_search($Req['invoice_items'][$i]['product_id'], array_column($dataLast['invoice_items'], 'product_id'));
            if ($index > -1) {
                //change_product_quantity
                if ($dataLast['invoice_items'][$index]['quantity'] != $Req['invoice_items'][$i]['quantity']) {
                    if ($dataLast['invoice_items'][$index]['quantity'] > $Req['invoice_items'][$i]['quantity']) {
                        // انقاص الكمية
                        $edit = true;
                        $sql .= "($admin_id,'{$Req['id']}','quantity_reduce','{$Req['invoice_items'][$i]['product_id']}','{$dataLast['invoice_items'][$index]['quantity']}','{$Req['invoice_items'][$i]['quantity']}','{$dataLast['invoice_items'][$index]['price']}','{$Req['invoice_items'][$i]['price']}',null,null,null,null,'{$this->dateTime}',0,0,0,0,0,0),";
                    } else if ($dataLast['invoice_items'][$index]['quantity'] < $Req['invoice_items'][$i]['quantity']) {
                        // زيادة الكمية
                        $edit = true;
                        $sql .= "($admin_id,'{$Req['id']}','quantity_increase','{$Req['invoice_items'][$i]['product_id']}','{$dataLast['invoice_items'][$index]['quantity']}','{$Req['invoice_items'][$i]['quantity']}','{$dataLast['invoice_items'][$index]['price']}','{$Req['invoice_items'][$i]['price']}',null,null,null,null,'{$this->dateTime}',0,0,0,0,0,0),";
                    }
                }
                //change_product_price
                if ($dataLast['invoice_items'][$index]['price'] != $Req['invoice_items'][$i]['price']) {
                    if ($dataLast['invoice_items'][$index]['price'] > $Req['invoice_items'][$i]['price']) {
                        // تخفيض السعر
                        $edit = true;
                        $sql .= "($admin_id,'{$Req['id']}','price_reduce','{$Req['invoice_items'][$i]['product_id']}','{$dataLast['invoice_items'][$index]['quantity']}','{$Req['invoice_items'][$i]['quantity']}','{$dataLast['invoice_items'][$index]['price']}','{$Req['invoice_items'][$i]['price']}',null,null,null,null,'{$this->dateTime}',0,0,0,0,0,0),";
                    } else if ($dataLast['invoice_items'][$index]['price'] < $Req['invoice_items'][$i]['price']) {
                        // زيادة السعر
                        $edit = true;
                        $sql .= "($admin_id,'{$Req['id']}','price_increase','{$Req['invoice_items'][$i]['product_id']}','{$dataLast['invoice_items'][$index]['quantity']}','{$Req['invoice_items'][$i]['quantity']}','{$dataLast['invoice_items'][$index]['price']}','{$Req['invoice_items'][$i]['price']}',null,null,null,null,'{$this->dateTime}',0,0,0,0,0,0),";
                    }
                }
            } else {
                //add_product
                $edit = true;
                $sql .= "($admin_id,'{$Req['id']}','add_product','{$Req['invoice_items'][$i]['product_id']}','0','{$Req['invoice_items'][$i]['quantity']}','0','{$Req['invoice_items'][$i]['price']}',null,null,null,null,'{$this->dateTime}',0,0,0,0,0,0),";
            }
        }

        for ($s = 0; $s < count($dataLast['invoice_items']); $s++) {
            $index1 = array_search($dataLast['invoice_items'][$s]['product_id'], array_column($Req['invoice_items'], 'product_id'));

            if ($index1 > -1) {
                
            } else {
                //delete_product    
                $edit = true;
                $sql .= "($admin_id,'{$Req['id']}','delete_product','{$dataLast['invoice_items'][$s]['product_id']}','0','{$dataLast['invoice_items'][$s]['quantity']}','0','{$dataLast['invoice_items'][$s]['price']}',null,null,null,null,'{$this->dateTime}'),";
            }
        }
        if ($edit == true) {
            $sql = rtrim($sql, ',');
//            echo $sql."<hr>";
            $this->mDb->query($sql);
        }
    }

    // 'start_client_dept','start_client_pay','order_commission_pay','order_merchant_supply_pay','balance_withdrawal_request_dept','balance_withdrawal_request_pending','order_commission_pending','order_merchant_supply_pending','order_commission_refund_dept','order_merchant_refund_dept','sale_invoice_dept','receipt_invoice_pay','sale_return_invoice_pay','receipt_return_invoice_dept','get_voucher_pay','cashing_voucher_dept'

    public function completeInvoice($id, $Req) {
        if ($Req['invoice_type'] == 'sale-invoice') {
            $note = ' فاتورة بيع رقم : ' . $Req['count_invoice_type'];
            // $treasures_balances['type'] = 'add';
            // balance
            $client_balance['transaction'] = 'sale_invoice_dept';
            $client_balance['value'] = $Req['total_price'];

            $affiliator_balance['transaction'] = 'sale_invoice_pay';
            $affiliator_balance['value'] = $Req['net_total_affiliator_profit'];

            // balance

            $invoiceVoucher['voucher_type'] = "get-voucher";
            $invoiceVoucher['voucher_clause_id'] = '2';
        } elseif ($Req['invoice_type'] == 'sale-return-invoice') {
            $note = ' فاتورة مرتجع بيع رقم : ' . $Req['count_invoice_type'];
            // $treasures_balances['type'] = 'remove';
            // balance
            $client_balance['transaction'] = 'sale_return_invoice_pay';
            $client_balance['value'] = $Req['total_price'];

            $affiliator_balance['transaction'] = 'sale_return_invoice_dept';
            $affiliator_balance['value'] = $Req['net_total_affiliator_profit'];

            // balance
            $invoiceVoucher['voucher_type'] = "cashing-voucher";
            $invoiceVoucher['voucher_clause_id'] = '4';
        } elseif ($Req['invoice_type'] == 'receipt-invoice') {
            $note = ' فاتورة شراء رقم : ' . $Req['count_invoice_type'];
            // $treasures_balances['type'] = 'remove';
            // balance
            $client_balance['transaction'] = 'receipt_invoice_pay';
            $client_balance['value'] = $Req['total_price'];

            $affiliator_balance['transaction'] = 'receipt_invoice_dept';
            $affiliator_balance['value'] = $Req['net_total_affiliator_profit'];
            // balance
            $invoiceVoucher['voucher_type'] = "cashing-voucher";
            $invoiceVoucher['voucher_clause_id'] = '3';
        } elseif ($Req['invoice_type'] == 'receipt-return-invoice') {
            $note = ' فاتورة مرتجع شراء رقم : ' . $Req['count_invoice_type'];
            // $treasures_balances['type'] = 'add';
            // balance
            $client_balance['transaction'] = 'receipt_return_invoice_dept';
            $client_balance['value'] = $Req['total_price'];
            // balance


            $affiliator_balance['transaction'] = 'receipt_return_invoice_pay';
            $affiliator_balance['value'] = $Req['net_total_affiliator_profit'];

            $invoiceVoucher['voucher_type'] = "get-voucher";
            $invoiceVoucher['voucher_clause_id'] = '5';
        }

        $this->userObj->deleteBalanceByParams($affiliator_balance['transaction'], $Req['id']);
        $this->userObj->deleteBalanceByParams($client_balance['transaction'], $Req['id']);

        if ($Req['client_id'] > 0) {
            $client_balance['user_id'] = $Req['client_id'];
            $client_balance['for_id'] = $id;
            $client_balance['treasure_id'] = '1';
            $this->userObj->addBalance($client_balance);
        }


        if ($Req['is_paid'] == 'paid') {
            // /add  Voucher to client_id 
            $data_table['table_name'] = "vouchers";
            $data_table['type_value'] = $invoiceVoucher['voucher_type'];
            $data_table['column_type'] = "voucher_type";
            $data_table['column_name'] = "count_voucher_type";
            $count_voucher_type = $this->settings->getlastTypeIdFromByTableName($data_table);

            $invoiceVoucher['account_type'] = "clients";
            $invoiceVoucher['admin_id'] = $Req['admin_id'];
            $invoiceVoucher['count_voucher_type'] = $count_voucher_type + 1;
            $invoiceVoucher['note'] = $note;
            $invoiceVoucher['price'] = $Req['total_price'];
            $invoiceVoucher['treasure_id'] = '1';
            $invoiceVoucher['user_id'] = $Req['client_id'];
            $invoiceVoucher['voucher_way'] = "cash";
            $invoiceVoucher['for_id'] = $id;
            $invoiceVoucher['for_type'] = $Req['invoice_type'];
            $this->addEditVoucher($invoiceVoucher);

            if ($Req['invoice_type'] == 'sale-invoice' && $Req['shipment_value'] > 0) {
                $treasures_balances['note'] = ' تكلفة شحن ' . $note;
                $treasures_balances['for_id'] = $id;
                $treasures_balances['for_type'] = $Req['invoice_type'];
                $treasures_balances['balance'] = $Req['shipment_value'];
                $treasures_balances['balance'] = $Req['shipment_value'];

                $treasures_balances['admin_id'] = $Req['admin_id'];
                $treasures_balances['type'] = 'remove';
                $this->treasuresObj->addTreasures_balances('1', $treasures_balances);
            }


            if ($Req['affiliator_id'] > 0) {
                $affiliator_balance['user_id'] = $Req['affiliator_id'];
                $affiliator_balance['for_id'] = $id;
                $affiliator_balance['treasure_id'] = $Req['treasure_id'];
                $affiliator_balance['value'] = $Req['net_total_affiliator_profit'];
                $this->userObj->addBalance($affiliator_balance);
            }
        }


        if ($Req['status'] == 'canceled') {
            // حذف القيود
            $this->deleteDailyRestrictions($Req['id']);

            $this->deleteProductStoreInvoce($Req['id'], $Req['invoice_type']);
            $this->userObj->deleteBalanceByParams($affiliator_balance['transaction'], $Req['id']);
            $this->userObj->deleteBalanceByParams($client_balance['transaction'], $Req['id']);

            $this->deleteBalanceItemsInMode($Req, 'drop_shipping');
            $this->deleteBalanceItemsInMode($Req, 'coupon_marketing');
            $this->deleteBalanceItemsInMode($Req, 'use_credit');
        }
    }

    public function deleteDailyRestrictions($invoice_id) {
        $sql = "DELETE dr, drl FROM daily_restrictions dr
                LEFT JOIN `daily_restrictions_list` drl ON drl.p_id = dr.id
                WHERE dr.`invoice_id` = :invoice_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':invoice_id', $invoice_id, PDO::PARAM_INT);
        return $stmt->execute();
    }

    public function addInvoiceItemsGroups($invoice_items, $invoice_id) {
        if (!empty($invoice_items['product_group_data'])) {
            $sql = "INSERT INTO `invoice_items_groups` (
                    `invoice_id`, 
                    `product_id`, 
                    `group_id`, 
                    `name`, 
                    `img`, 
                    `description`, 
                    `delivery_price`, 
                    `order_price`, 
                    `date_added`
                ) VALUES (
                    :invoice_id, 
                    :product_id, 
                    :group_id, 
                    :name, 
                    :img, 
                    :description, 
                    :delivery_price, 
                    :order_price, 
                    :date_added
                )";

            $stmt = $this->mDb->connect()->prepare($sql);

            $stmt->bindParam(':invoice_id', $invoice_id, PDO::PARAM_INT);
            $stmt->bindParam(':product_id', $invoice_items['product_id'], PDO::PARAM_INT);
            $stmt->bindParam(':group_id', $invoice_items['product_group_data']['id'], PDO::PARAM_INT);
            $stmt->bindParam(':name', $invoice_items['product_group_data']['name'], PDO::PARAM_STR);
            $stmt->bindParam(':img', $invoice_items['product_group_data']['img'], PDO::PARAM_STR);
            $stmt->bindParam(':description', $invoice_items['product_group_data']['description'], PDO::PARAM_STR);
            $stmt->bindParam(':delivery_price', $invoice_items['product_group_data']['delivery_price'], PDO::PARAM_STR);
            $stmt->bindParam(':order_price', $invoice_items['product_group_data']['order_price'], PDO::PARAM_STR);
            $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);

            return $stmt->execute();
        }
        return false;
    }

    public function addInvoiceItems($id, $invoice_items, $admin_id, $for_type, $dateTime = '', $status = '') {


//         echo '<pre>';
//         print_r($invoice_items);
//         echo '</pre>';
//         die();

        for ($i = 0; $i < count($invoice_items); $i++) {

            $date_added = $invoice_items[$i]['date_added'] ? $invoice_items[$i]['date_added'] : $this->dateTime;
            $sql = '';
            $invoice_items[$i]['is_gift'] = $invoice_items[$i]['is_gift'] || $invoice_items[$i]['is_gift'] == true ? '1' : '0';
            $sql .= "INSERT INTO `invoice_items` SET ";
            foreach ($this->mDb->getCols('invoice_items', $invoice_items[$i]) as $k => $v) {
                $sql .= ($k == 'id' || $k == 'service_id' || $k == 'date_added' || $k == 'store' || $k == 'invoice_id' || $k == 'product_store_id' || $k == 'product_code' || $k == 'product_barcode' || $k == 'image' || $k == 'images' || $k == 'trademark_title') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `invoice_id` = '{$id}' , `date_added`='{$date_added}' ; ";
//             echo $sql."<hr>";
            $res = $this->mDb->query($sql);
            if ($res) {

                if ($for_type == 'sale-invoice') {
                    $product_stores['type'] = 'remove';
                } elseif ($for_type == 'sale-return-invoice') {
                    $product_stores['type'] = 'add';
                } elseif ($for_type == 'receipt-invoice') {
                    $product_stores['type'] = 'add';
                } elseif ($for_type == 'receipt-return-invoice') {
                    $product_stores['type'] = 'remove';
                }
                $product_stores['name'] = $invoice_items[$i]['product_type_name'];

                $product_stores['product_id'] = $invoice_items[$i]['product_id'];
                $product_stores['store_id'] = $invoice_items[$i]['store_id'];
                $product_stores['expiration_date'] = $invoice_items[$i]['expiration_date'];
                $product_stores['for_id'] = $id;
                $product_stores['for_type'] = $for_type;
                $product_stores['value'] = $invoice_items[$i]['quantity'];
                $product_stores['admin_id'] = $admin_id;
                $this->productsObj->addEditProduct_stores($product_stores, $dateTime);

                if ($status !== 'canceled') {
                    $this->productsObj->addEditProductStoresAmounts($product_stores, $dateTime);
                    // اضافة الكمية على الرف
                    $this->productsObj->addProductStoresAmountsQuantityOnShelf($product_stores, $status, $id);
                }

                if (!empty($invoice_items[$i]['product_group_data'])) {
                    $this->addInvoiceItemsGroups($invoice_items[$i], $id);
                }
            }
        }

        return $res;
        //   echo $sql;die();
    }

    public function addInvoicesAdjustShelvesItems($id, $invoice_items) {


        for ($i = 0; $i < count($invoice_items); $i++) {
            for ($p = 0; $p < count($invoice_items[$i]['products']); $p++) {

                $scan_date = $invoice_items[$i]['products'][$p]['scan_date'] ? $invoice_items[$i]['products'][$p]['scan_date'] : $this->dateTime;
                $sql = '';

                $sql .= "INSERT INTO `adjust_shelves_invoices_items` SET ";
                $sql .= " `invoice_id` = '{$id}' , `shelf_id`='{$invoice_items[$i]['id']}'  ";
                $sql .= " ,`product_id` = '{$invoice_items[$i]['products'][$p]['product_id']}' , `store_id`='{$invoice_items[$i]['products'][$p]['store_id']}'  ";
                $sql .= " , `scan_date`='{$scan_date}' ; ";
//             echo $sql."<hr>";
                $res = $this->mDb->query($sql);
                if ($res) {
                    $this->updateProductShelfId($invoice_items[$i]['id'], $invoice_items[$i]['products'][$p], $scan_date);
                }
            }
        }

        return $res;
        //   echo $sql;die();
    }

    public function updateProductShelfId($shelf_id, $data, $scan_date) {
        $id = $this->getProductShelfId($shelf_id, $data['product_id'], $data['store_id']);
        if ($id) {
            $sql = " UPDATE   `product_stores_amounts_shelf` SET `shelf_id` ='{$shelf_id}' ,`scan_date` ='{$scan_date}' ";
            $sql .= " WHERE id='{$id}' and  `product_id` =  '{$data['product_id']}' and  store_id =  '{$data['store_id']}' ";
//             echo $sql."<hr>";
            $res = $this->mDb->query($sql);
        } else {
            $sql .= "INSERT INTO `product_stores_amounts_shelf` SET ";
            $sql .= "  `shelf_id` ='{$shelf_id}'    ";
            $sql .= " ,`product_id` =  '{$data['product_id']}', `store_id` =  '{$data['store_id']}'  ";
            $sql .= " , `scan_date`='{$scan_date}' ; ";
//               echo $sql."<hr>";
            $res = $this->mDb->query($sql);
        }
        return $res;
    }

    public function getProductShelfId($shelf_id, $product_id, $store_id) {
        $sql = "SELECT id  FROM `product_stores_amounts_shelf` where `shelf_id`='{$shelf_id}' and  `product_id` =  '{$product_id}' and  `store_id` =  '{$store_id}' ";
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    public function getPaidStatus($id) {
        $sql = "SELECT is_paid   FROM `invoices` where id ='{$id}' ";
        return $this->mDb->getOne($sql);
    }

    public function getInvoiceStatus($id) {
        $sql = "SELECT status   FROM `invoices` where id ='{$id}' ";
        return $this->mDb->getOne($sql);
    }

    public function getInvoiceCountInvoiceType($id) {
        $sql = "SELECT count_invoice_type   FROM `invoices` where id ='{$id}' ";
        return $this->mDb->getOne($sql);
    }

  
        public function deleteInvoiceItems($invoice_id) {
        $sql = "DELETE i, g
        FROM `{$this->mPrefix}invoice_items` AS i
        LEFT JOIN `{$this->mPrefix}invoice_items_groups` AS g
        ON i.invoice_id = g.invoice_id 
        WHERE i.invoice_id = :invoice_id ";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':invoice_id', $invoice_id, PDO::PARAM_INT);
        return $stmt->execute();
    }

    public function deleteBalanceItemsInMode($Req, $mode) {

        if ($mode == 'coupon_marketing') {
            $sql = "DELETE From `{$this->mPrefix}balance`   ";
            $sql .= "where  type ='hanging' and client_id ='{$Req['marketing_data']['client_id']}' and   coupon_id ='{$Req['marketing_data']['coupon_id']}' and   invoice_id ='{$Req['invoice_edit_id']}' and mode='coupon_marketing' ";
        } else if ($mode == 'drop_shipping') {
            $sql = "DELETE From `{$this->mPrefix}balance`   ";
            $sql .= "where  type ='hanging' and client_id ='" . CLIENT['id'] . "'  and   invoice_id ='{$Req['invoice_edit_id']}' and mode='drop_shipping'";
        } else if ($mode == 'use_credit') {
            $sql = "DELETE From `{$this->mPrefix}balance`   ";
            $sql .= "where  type ='get' and client_id ='" . CLIENT['id'] . "'  and   invoice_id ='{$Req['invoice_edit_id']}' and mode='use_credit' ";
        }

//       echo $sql."<hr>";
        $this->mDb->query($sql);
    }

    public function deleteCartItems($Req) {
        global $cartsObj;
        $sql = "SELECT id   FROM `carts` where invoice_id ='{$Req['invoice_edit_id']}' and type='request_is_done' ";
        $item['cart_id'] = $this->mDb->getOne($sql);
        if ($item['cart_id']) {
            $cartsObj->deleteCart($item);
        }
    }

    public function deleteProductStoreInvoce($for_id, $for_type) {

        $sql = "DELETE From `{$this->mPrefix}product_stores`   ";
        $sql .= "where for_id ='{$for_id}'  AND  for_type ='{$for_type}'   ";
        $this->mDb->query($sql);
    }

    public function getInvoices(
            $aStart, $aLimit, $sort, $type, $searchIvoiceType, $searchAffiliator_id, $searchClient_id, $searchVoucher_clause_id, $searchDateFrom, $searchDateTo, $searchId, $searchIs_paid, $searchStatus, $searchCity_id, $searchMobile, $searchAdminId
    ) {

        global $productsObj;
        //   echo "$sql";die();

        if ($searchIvoiceType == 'sale-invoice' || $searchIvoiceType == 'sale-return-invoice' || $searchIvoiceType == 'receipt-invoice' || $searchIvoiceType == 'receipt-return-invoice') {
            // invoices 
            $sql1 = "SELECT  sum(total_price) as sum_total_price     FROM `invoices` i";

            $sql2 = "SELECT  i.* ,u3.user_name as affiliator_name , u.id as user_id , u.user_level , u.user_name  , i.total_price as value_price__    , i.invoice_type as invoice_type__ , i.count_invoice_type as invoice_sequence__   ,  'invoices' as invoice_table ,u2.user_name as added_by    FROM `invoices` i";

            $sql = " LEFT JOIN `users` u2 ON u2.id = i.admin_id ";
            $sql .= " LEFT JOIN `users` u ON u.id = i.client_id ";
            $sql .= " LEFT JOIN `users` u3 ON u3.id = i.affiliator_id ";

            $sql .= " WHERE   i.id > 0  and   i.client_id = " . CLIENT['id'] . " and   i.affiliator_id = " . AFFILIATOR['id'] . "  ";

            $sql .= $searchId ? " AND (i.`count_invoice_type` ='{$searchId}' ) " : '';
            $sql .= $searchIs_paid ? " AND (i.`is_paid` ='{$searchIs_paid}' ) " : '';
            $sql .= $searchStatus ? " AND (i.`status` ='{$searchStatus}' ) " : '';
            $sql .= $searchClient_id ? " AND (i.`client_id` ='{$searchClient_id}' ) " : '';
            $sql .= $searchAffiliator_id ? " AND (i.`affiliator_id` ='{$searchAffiliator_id}' ) " : '';

            $sql .= $searchIvoiceType ? " AND (i.`invoice_type` ='{$searchIvoiceType}' ) " : '';

            $sql .= $searchDateFrom ? " AND i.`date_added`   >= '{$searchDateFrom}' " : "";
            $sql .= $searchDateTo ? " AND i.`date_added`  <= '{$searchDateTo}' " : "";
            $sql .= $searchCity_id ? ' AND (i.city_id = "' . $searchCity_id . '"    ) ' : '';
            $sql .= $searchMobile ? ' AND (i.mobile like "%' . $searchMobile . '%"    ) ' : '';
            $sql .= $searchAdminId ? ' AND (i.admin_id = "' . $searchAdminId . '"   ) ' : '';

            $sql .= " ORDER BY i.{$sort} {$type}";
        }
        // elseif ($searchIvoiceType == 'merchant-supply-invoice' || $searchIvoiceType == 'merchant-return-invoice' || $searchIvoiceType == 'mortal-invoice'  || $searchIvoiceType == 'settlement-invoice' || $searchIvoiceType == 'inventory-invoice') {
        //     // other_invoices
        //     $sql1 = "SELECT  sum(oi.total_price) as sum_total_price     FROM `other_invoices` oi";
        //     $sql2 = "SELECT oi.* , u.id as user_id , u.user_level, u.user_name , oi.invoice_type as invoice_type__  , oi.count_invoice_type as invoice_sequence__  ,  'other_invoices' as   invoice_table ,u2.user_name as added_by   FROM `other_invoices` oi";
        //     $sql  = " LEFT JOIN `users` u ON u.id = oi.merchant_id ";
        //     $sql .= " LEFT JOIN `users` u2 ON u2.id = oi.admin_id ";
        //     $sql .= " WHERE   oi.id > 0 ";
        //     $sql .= $searchId ? " AND (oi.`count_invoice_type` ='{$searchId}' ) " : '';
        //     $sql .= $searchUser_id ? " AND (oi.`merchant_id` ='{$searchUser_id}' ) " : '';
        //     $sql .= $searchIvoiceType ? " AND (oi.`invoice_type` ='{$searchIvoiceType}' ) " : '';
        //     $sql .= $searchAdminId ? ' AND (oi.admin_id = "' . $searchAdminId . '"   ) ' : '';
        //$sql .= $searchDateFrom    ? " AND oi.`date_added`   >= '{$searchDateFrom}' " : "";
        //  $sql .= $searchDateTo    ? " AND oi.`date_added`  <= '{$searchDateTo}' " : "";        //     $sql .= " ORDER BY oi.{$sort} {$type}";
        // } 
        elseif ($searchIvoiceType == 'get-voucher' || $searchIvoiceType == 'cashing-voucher') {
            //vouchers


            $sql1 = "SELECT  sum(v.price) as sum_total_price   FROM `vouchers` v";
            $sql2 = "SELECT    v.* , u.id as user_id , u.user_level , u.user_name ,price as value_price__  , v.voucher_type as invoice_type__   , v.count_voucher_type as invoice_sequence__  , ii.name as voucher_clause_name   , 'vouchers'  as  invoice_table ,u2.user_name as added_by FROM `vouchers` v";

            $sql = " LEFT JOIN `users` u ON u.id = v.user_id ";
            $sql .= " LEFT JOIN `users` u2 ON u2.id = v.admin_id ";

            $sql .= " LEFT JOIN `voucher_clauses` ii ON ii.id = v.voucher_clause_id ";

            $sql .= " WHERE   v.id > 0 ";
            $sql .= $searchId ? " AND (v.`count_voucher_type` ='{$searchId}' ) " : '';
            $sql .= $searchClient_id ? " AND (v.`user_id` ='{$searchClient_id}' ) " : '';

            $sql .= $searchAffiliator_id ? " AND (v.`user_id` ='{$searchAffiliator_id}' ) " : '';

            $sql .= $searchIvoiceType ? " AND (v.`voucher_type` ='{$searchIvoiceType}' ) " : '';
            $sql .= $searchVoucher_clause_id ? " AND (v.`voucher_clause_id` ='{$searchVoucher_clause_id}' ) " : '';
            $sql .= $searchAdminId ? ' AND (v.admin_id = "' . $searchAdminId . '"   ) ' : '';
            $sql .= $searchDateFrom ? " AND v.`date_added`   >= '{$searchDateFrom}' " : "";
            $sql .= $searchDateTo ? " AND v.`date_added`  <= '{$searchDateTo}' " : "";
            $sql .= " ORDER BY v.{$sort} {$type}";
        }






        $sql_limit = $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // 
        // $res['sum_total_price']  = $this->mDb->getOne($sql1 . $sql);
//          $res['data']  = $this->mDb->getAll($sql2 . $sql . $sql_limit);
//        echo $sql2 . $sql . $sql_limit."<hr>";
        $res = $this->mDb->getAll($sql2 . $sql . $sql_limit);
        for ($i = 0; $i < count($res); $i++) {

            if ($res[$i]['api_id_to']) {
                $res[$i]['details_store_external'] = $productsObj->getDetailsStoreExternalById($res[$i]['api_id_to']);
            }

            $res[$i]['cart_id'] = $this->getcartIdInInvoiceEditId($res[$i]['id']);
            $res[$i]['invoice_items'] = $this->getInvoiceProducts($res[$i]['id']);
        }
        // echo  $sql2 . $sql . $sql_limit;die();
        return $res;
    }

    public function getcartIdInInvoiceEditId($id) {
        $sql = "SELECT  id 
                FROM carts 
                WHERE invoice_edit_id = :id
                    AND type = 'editing_in_progress'";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchColumn(0);
        return $res ? $res : '';
    }

    public function getInvoicesCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `invoices`";
        return $this->mDb->getOne($sql);
    }

    public function getOneInvoice($Req) {
        $client_id = CLIENT['id'] ?? 0;
        $affiliator_id = AFFILIATOR['id'];
        global $couponsObj;
        $sql = "SELECT p.* 
                FROM invoices p
                WHERE p.id = :id   
                    AND p.client_id = :client_id 
                    AND p.affiliator_id = :affiliator_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $Req, PDO::PARAM_INT);
        $stmt->bindParam(':client_id', $client_id, PDO::PARAM_INT);
        $stmt->bindParam(':affiliator_id', $affiliator_id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($res) {
            $res['cart_id'] = $this->getcartIdInInvoiceEditId($res['id']);
            $res['couponInfo'] = $couponsObj->getCouponUsedInfo($res['id'], 'invoice');
            $res['invoice_items'] = $this->getInvoiceProducts($Req);
            $res['all_voucher'] = $this->getAllVoucher($res['id']);
            if ($res['payment_method_type']) {
                $payment_method_name = $this->getPaymentMethodName($res['payment_method_type']);
            }
            $res['payment_method_name'] = $payment_method_name ? $payment_method_name : $res['payment_method_name'];

            $shipment_company = $this->getShipmentName($res['shipment_id']);
            $res['shipment_company'] = $shipment_company ? $shipment_company : $res['shipment_company'];
        }
        return $res;
    }

    public function getOneInvoiceByAdmin($Req) {
        global $couponsObj;
        $sql = "SELECT `p`.* FROM `invoices` p ";
        $sql .= " WHERE p.id = '{$Req}'   and   p.affiliator_id = " . AFFILIATOR['id'] . "  ";
//         echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['cart_id'] = $this->getcartIdInInvoiceEditId($res['id']);
            $res['couponInfo'] = $couponsObj->getCouponUsedInfo($res['id'], 'invoice');
            $res['invoice_items'] = $this->getInvoiceProducts($Req);
            $res['all_voucher'] = $this->getAllVoucher($res['id']);
            $payment_method_name = $this->getPaymentMethodName($res['payment_method_type']);
            $res['payment_method_name'] = $payment_method_name ? $payment_method_name : $res['payment_method_name'];

            $shipment_company = $this->getShipmentName($res['shipment_id']);
            $res['shipment_company'] = $shipment_company ? $shipment_company : $res['shipment_company'];
        }
        // echo "<pre>";print_r($Req);die();
        return $res;
    }

    public function getAllVoucher($invoiceId) {

        $sql = "SELECT * FROM `vouchers`  ";
        $sql .= " WHERE id > 0 ";
        $sql .= " AND (`for_id` ='{$invoiceId}' ) ";
        $sql .= " ORDER BY  id ASC ";
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    public function getPaymentMethodName($payment_method_type) {
        if ($payment_method_type) {
            $sql = "SELECT aol.`{$payment_method_type}_name` FROM `affiliator_options` ao ";
            $sql .= " LEFT JOIN `affiliator_options_langs` aol ON ao.id = aol.o_id  and  aol.lang_code='{$this->lang_code}' ";
            $sql .= " WHERE   ao.user_id = " . AFFILIATOR['id'] . " ";
            $res = $this->mDb->getOne($sql);
            return $res;
        }
    }

    public function getShipmentName($id) {
        $sql = "SELECT name FROM `shipping_methods_langs`  ";
        $sql .= " WHERE p_id = '{$id}'  and lang_code = '{$this->lang_code}'  ";
//        echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getInvoiceProducts($invoice_id) {
        global $productsObj;
        $sql = "SELECT  ii.*,pl.name as product_name  ,sum(quantity) as quantity ,p.api_id_to, p.product_code  , p.product_barcode  ,tl.title as trademark_title,p.trademark_id     FROM `invoice_items` ii   ";
        $sql .= " LEFT JOIN `products` p ON p.id = ii.product_id ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = ii.product_id and pl.lang_code='{$this->lang_code}' ";
        $sql .= " LEFT JOIN `trademark_langs` tl ON p.trademark_id = tl.trademark_id  AND  tl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE  ii.invoice_id = '{$invoice_id}' group by  ii.product_id, ii.product_type_name ,ii.is_gift  ";
        //    echo $sql."<hr>";
// echo "<pre>";
        // die();

        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['product_services'] = $productsObj->getProduct_services($res[$i]['product_id']);
                $res[$i]['images'] = $this->getProductimgs($res[$i]['product_id']);
                $res[$i]['image'] = $res[$i]['images'][0]['name'];
                $res[$i]['favorites_id'] = $productsObj->getFavoritesId($res[$i]['product_id']);
                // $res[$i]['quantity_show'] = $res[$i]['quantity'];
            }
        }
        return $res;
    }

    public function getProductimgs($id, $aLimit = '') {
        $sql = "SELECT name ,type ,date_added  FROM product_medias  ";
        $sql .= " WHERE `product_id` = '{$id}'  ";
        $sql .= $aLimit ? " LIMIT  0, {$aLimit} " : '';

        return $this->mDb->getAll($sql);
    }

    public function deleteProductStoreByParams($for_id, $for_type) {
        $sql = "SELECT product_id FROM product_stores ";
        $sql .= " WHERE `for_id` = '{$for_id}'  AND `for_type`= '{$for_type}'    ";
        // echo $sql . " <br>";
        $product_id = $this->mDb->getOne($sql);

        $sql = "DELETE FROM product_stores ";
        $sql .= " WHERE `for_id` = '{$for_id}'  AND `for_type`= '{$for_type}'    ";
        // echo $sql . " <br>";
        $res = $this->mDb->query($sql);

        if ($res) {



            //**VIP***
            // refresh Quantity To Open CART WITH STORE 1
            // $row =  $this->productsObj->getStatisticsFroProduct($product_id);
            // $total  =  ($row['total_add_amount_product'] * 1) -  ($row['total_sell_amount_product'] * 1);
            // $this->productsObj->refreshQuantityProductToOpenCart($product_id, $total);
            // p($row);
            //**VIP***
        }
    }

    public function avoidDeleteLastItemOnInvoices($temp) {
        if ($temp['invoice_table'] == 'invoices') {
            $data_table['column_type'] = "invoice_type";
            $data_table['column_name'] = "count_invoice_type";
            $count_type_item = $temp['count_invoice_type'];
        } elseif ($temp['invoice_table'] == 'other_invoices') {
            $data_table['column_type'] = "invoice_type";
            $data_table['column_name'] = "count_invoice_type";

            $count_type_item = $temp['count_invoice_type'];
        } elseif ($temp['invoice_table'] == 'vouchers') {
            $data_table['column_type'] = "voucher_type";
            $data_table['column_name'] = "count_voucher_type";
            $count_type_item = $temp['count_voucher_type'];
        }


        $data_table['table_name'] = $temp['invoice_table'];
        $data_table['type_value'] = $temp['invoice_type_'];
        $count_type = $this->settings->getlastTypeIdFromByTableName($data_table);

        if ($count_type_item == $count_type) {
            return false;
        } else {
            return true;
        }
    }

    public function deleteInvoice($id, $haveVoucher = true) {

        $temp['invoice_table'] = 'invoices';
        $temp['id'] = $id;
        $temp['invoice_type_'] = 'sale-invoice';
        $ret = $this->avoidDeleteLastItemOnInvoices($temp);
        // p($ret);
        if ($ret || $haveVoucher == false) { //VIP $haveVoucher == false
            $sql = "DELETE FROM `{$temp['invoice_table']}` ";
            $sql .= " WHERE `id` = '{$temp['id']}' and   client_id = " . CLIENT['id'] . " and   affiliator_id = " . AFFILIATOR['id'] . "  ";
            $sql .= $temp['invoice_table'] == 'invoices' || $temp['invoice_table'] == 'other_invoices' ? " AND `invoice_type`= '{$temp['invoice_type_']}'   " : " ";
            $sql .= $temp['invoice_table'] == 'vouchers' ? "  AND `voucher_type`= '{$temp['invoice_type_']}'   " : " ";

            // echo $id ;
            // die();
            $res = $this->mDb->query($sql);

            if ($res) {
                $sql = "DELETE FROM treasures_balances ";
                $sql .= " WHERE `for_id` = '{$temp['id']}' AND `for_type`= '{$temp['invoice_type_']}'   ";
                $this->mDb->query($sql);

                $this->deleteProductStoreByParams($temp['id'], $temp['invoice_type_']);

                $sql = "DELETE FROM user_balances ";
                $sql .= " WHERE `for_id` = '{$temp['id']}'  ";
                $sql .= $temp['invoice_type_'] == 'sale-invoice' ? " AND (`transaction`= 'sale_invoice_dept' || `transaction` = 'sale_invoice_pay' )   " : " ";
                $sql .= $temp['invoice_type_'] == 'receipt-invoice' ? " AND (`transaction`= 'receipt_invoice_pay' || `transaction` = 'sale_return_invoice_dept' )   " : " ";
                $sql .= $temp['invoice_type_'] == 'sale-return-invoice' ? " AND (`transaction`= 'sale_return_invoice_pay' || `transaction` = 'receipt_invoice_dept' )   " : " ";
                $sql .= $temp['invoice_type_'] == 'receipt-return-invoice' ? " AND (`transaction`= 'receipt_return_invoice_dept' || `transaction` = 'receipt_return_invoice_pay' )   " : " ";

                $sql .= $temp['invoice_type_'] == 'get-voucher' ? " AND `transaction`= 'get_voucher_pay'   " : " ";
                $sql .= $temp['invoice_type_'] == 'cashing-voucher' ? " AND `transaction`= 'cashing_voucher_dept'   " : " ";
                $this->mDb->query($sql);

                if (($temp['invoice_type_'] == 'sale-invoice' ||
                        $temp['invoice_type_'] == 'receipt-invoice' || $temp['invoice_type_'] == 'sale-return-invoice' ||
                        $temp['invoice_type_'] == 'receipt-return-invoice') and $haveVoucher == true) {

                    $voucher['invoice_table'] = 'vouchers';
                    $voucher['id'] = $this->getIdOfVoucherByInvoiceType($temp['invoice_type_'], $temp['id']);

                    if ($temp['invoice_type_'] == 'sale-invoice' || $temp['invoice_type_'] == 'receipt-return-invoice') {
                        $voucher['invoice_type_'] = "get-voucher";
                    } elseif ($temp['invoice_type_'] == 'sale-return-invoice' || $temp['invoice_type_'] == 'receipt-invoice') {
                        $voucher['invoice_type_'] = "cashing-voucher";
                    }

                    $this->deleteInvoice($voucher, false);
                }
            }
            return $res;
            // die();
        }
    }

    public function getIdOfVoucherByInvoiceType($invoice_type, $invoice_id) {
        $sql = "SELECT id FROM `vouchers` v ";
        $sql .= " WHERE v.for_type = '{$invoice_type}'  and for_id ='{$invoice_id}'   ";
        $res = $this->mDb->getOne($sql);
        // echo "<pre>";print_r($sql);die();
        return $res;
    }

    public function addEditVoucher($Req) {


        if (!$Req['id']) {

            $data_table['table_name'] = "vouchers";
            $data_table['type_value'] = $Req['voucher_type'];
            $data_table['column_type'] = "voucher_type";
            $data_table['column_name'] = "count_voucher_type";
            $Req['count_voucher_type'] = $this->settings->getlastTypeIdFromByTableName($data_table);
            $Req['count_voucher_type'] = $Req['count_voucher_type'] + 1;

            $sql = "INSERT INTO `vouchers` SET ";
            foreach ($this->mDb->getCols('vouchers', $Req) as $k => $v) {
                $sql .= ($k == 'user_name' || $k == 'id' || $k == 'invoice_items' || $k == 'added_by') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}' ";
            // echo $sql;
            // die();

            $res = $this->mDb->query($sql);

            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //add  product_price To System
                if ($Req['voucher_type'] == 'get-voucher') {
                    $treasures_balances['note'] = ' سند قبض رقم : ' . $Req['count_voucher_type'];
                    $treasures_balances['type'] = 'add';
                    $balance['transaction'] = 'get_voucher_pay';
                    $balance['value'] = $Req['price'];
                } else if ($Req['voucher_type'] == 'cashing-voucher') {
                    $treasures_balances['note'] = ' سند صرف رقم : ' . $Req['count_voucher_type'];
                    $treasures_balances['type'] = 'remove';
                    $balance['transaction'] = 'cashing_voucher_dept';
                    $balance['value'] = $Req['price'];
                }
                $treasures_balances['for_id'] = $id;
                $treasures_balances['for_type'] = $Req['voucher_type'];
                $treasures_balances['balance'] = $Req['price'];
                $treasures_balances['admin_id'] = $Req['admin_id'];
                //  treasure_id = 1 mean a default Treasures
                $this->treasuresObj->addTreasures_balances($Req['treasure_id'], $treasures_balances);

                $balance['user_id'] = $Req['user_id'];
                $balance['for_id'] = $id;
                $balance['treasure_id'] = $Req['treasure_id'];
                $this->userObj->addBalance($balance);

                //enter lang_details
                # code...
            }

            return $id;
        } else {
            if (!$Req['for_type']) {
                unset($Req['for_type']);
            }
            $sql = "UPDATE  `vouchers` SET ";
            foreach ($this->mDb->getCols('vouchers', $Req) as $k => $v) {
                $sql .= ($k == 'lang_parameter' || $k == 'voucher_clause_name' || $k == 'invoice_items' || $k == 'id' || $k == 'invoice_types' || $k == 'user_name' || $k == 'added_by') ? "" : "`{$k}`='{$v}',";
            }

            $sql = substr($sql, 0, -1);
            $sql .= " where `id` = '{$Req['id']}' ";
            $res = $this->mDb->query($sql);
            //  echo $sql; die();
            if ($res) {
                $this->treasuresObj->deleteTreasures_balances($Req['id'], $Req['voucher_type']);

                if ($Req['voucher_type'] == 'get-voucher') {
                    $treasures_balances['note'] = ' سند قبض رقم : ' . $Req['count_voucher_type'];
                    $treasures_balances['type'] = 'add';
                }
                if ($Req['voucher_type'] == 'cashing-voucher') {
                    $treasures_balances['note'] = ' سند صرف رقم : ' . $Req['count_voucher_type'];
                    $treasures_balances['type'] = 'remove';
                }
                $treasures_balances['for_id'] = $Req['id'];
                $treasures_balances['for_type'] = $Req['voucher_type'];
                $treasures_balances['balance'] = $Req['price'];
                $treasures_balances['admin_id'] = $Req['admin_id'];
                $this->treasuresObj->addTreasures_balances($Req['treasure_id'], $treasures_balances, $Req['date_added']);
            }






            return $res;
        }
    }

    public function CancelInvoice($invoice_id, $info) {
        $sql = "UPDATE  `invoices` SET `status`='canceled' ";
        $sql .= " where `id` = '{$invoice_id}' and  client_id = " . CLIENT['id'] . " and  affiliator_id = " . AFFILIATOR['id'] . "  ";
//               p($sql);
        $res = $this->mDb->query($sql);
        if ($res) {

            $info['status'] = 'canceled';
            $info['invoice_edit_id'] = $invoice_id;
            $this->completeInvoice($invoice_id, $info);

            // ارجاع الكمية 

            if ($info['invoice_type'] == 'sale-invoice') {
                $product_stores['type'] = 'add';
            } elseif ($info['invoice_type'] == 'receipt-invoice') {
                $product_stores['type'] = 'remove';
            }
            for ($p = 0; $p < count($info['invoice_items']); $p++) {
                $product_stores['name'] = $info['invoice_items'][$p]['product_type_name'];
                $product_stores['product_id'] = $info['invoice_items'][$p]['product_id'];
                $product_stores['store_id'] = $info['invoice_items'][$p]['store_id'];
                $product_stores['expiration_date'] = $info['invoice_items'][$p]['expiration_date'];
                $product_stores['value'] = $info['invoice_items'][$p]['quantity'];

                $this->productsObj->addEditProductStoresAmounts($product_stores);
            }
        }
        return $res;
    }

    public function changeStatusInvoice($data) {

        $laststatus = $this->getInvoiceStatus($data['invoice_id']);
        $sql = "UPDATE  `invoices` SET `status`='{$data['status']}' ";
        $sql .= " where `id` = '{$data['invoice_id']}'   ";
//        $sql .= " where `id` = '{$data['invoice_id']}' and  client_id = " . CLIENT['id'] . " and  affiliator_id = " . AFFILIATOR['id'] . "  ";
//               p($sql);
        $res = $this->mDb->query($sql);
        if ($res) {
            $lastInvoice['status'] = $laststatus;
            $data['id'] = $data['invoice_id'];
            $this->historyEditInvoice($lastInvoice, $data);
        }
        return $res;
    }

    public function getStatusCountByInvoices($searchIvoiceType) {


        $searchDateFrom = $this->mConfig['limit_show_data_from'];

        if ($searchIvoiceType == 'sale-invoice') {
// invoices 
//pending
            $sql = "SELECT 'قيد الانتظار' AS title, 'pending' AS status, COUNT(DISTINCT i.`id`)  AS invoice_count FROM invoices i ";
            $sql .= " LEFT JOIN `carts` c ON (c.invoice_edit_id = i.id and c.type='editing_in_progress') ";
            $sql .= " WHERE i.status = 'pending'  AND (i.`invoice_type` ='{$searchIvoiceType}' ) ";
            $sql .= "AND (c.`invoice_edit_id` IS NULL ) AND i.archive = '0'  AND i.`date_added`   >= '{$searchDateFrom}' ";

////waiting_confirm
//            $sql .= " UNION ALL SELECT ' جارى التأكيد' AS title, 'waiting_confirm' AS status, COUNT(DISTINCT i.id) AS invoice_count FROM invoices i ";
//
//            $sql .= " WHERE i.status = 'waiting_confirm' AND (i.`invoice_type` ='{$searchIvoiceType}' )  AND i.archive = '0' AND  i.`date_added`   >= '{$searchDateFrom}'";
//            $sql .= $searchIvoiceType ? " AND (i.`invoice_type` ='{$searchIvoiceType}' ) " : '';
//
//confirmed
            $sql .= " UNION ALL SELECT 'تم التأكيد' AS title, 'confirmed' AS status, COUNT(DISTINCT i.id) AS invoice_count FROM invoices i ";
            $sql .= " WHERE i.status = 'confirmed' AND (i.`invoice_type` ='{$searchIvoiceType}' ) AND  i.archive = '0' AND  i.`date_added`   >= '{$searchDateFrom}'";

//under_prepare
            $sql .= " UNION ALL SELECT ' جاري التجهيز ' AS title,'under_prepare' AS status, COUNT(DISTINCT i.id) AS invoice_count FROM invoices i ";
            $sql .= " WHERE i.status = 'under_prepare' AND (i.`invoice_type` ='{$searchIvoiceType}' )  AND  i.archive = '0' AND  i.`date_added`   >= '{$searchDateFrom}'";

//ready_to_delivered
            $sql .= " UNION ALL SELECT ' جاهز للشحن ' AS title,'ready_to_delivered' AS status, COUNT(DISTINCT i.id) AS invoice_count FROM invoices i ";
            $sql .= " WHERE i.status = 'ready_to_delivered' AND (i.`invoice_type` ='{$searchIvoiceType}' )  AND  i.archive = '0' AND  i.`date_added`   >= '{$searchDateFrom}'";

//            echo $sql."<hr>";
        }

        $res = $this->mDb->getAll($sql);

        return $res;
    }

    public function getAllInvoicesByAdmin($aStart, $aLimit, $sort, $type, $searchIvoiceType, $searchStatus, $id = '') {
        if ($searchIvoiceType == 'sale-invoice') {
            $sql = "SELECT  i.id,i.affiliator_id,i.client_id ,i.status,i.invoice_type,i.count_invoice_type,i.bar_code,i.bar_code_image,i.total_price";
            $sql .= ",i.total_quantity,i.is_paid,i.date_added,u3.user_name as affiliator_name,uo.front_fav_icon affiliator_front_fav_icon";
            $sql .= ", u.id as user_id  ,  CONCAT(u.user_name, ' ', COALESCE(u.last_name, '')) as client_name ";
            $sql .= ", 'invoices' as invoice_table ";
            $sql .= " FROM `invoices` i";

            $sql .= " LEFT JOIN `users` u ON u.id = i.client_id ";
            $sql .= " LEFT JOIN `users` u3 ON u3.id = i.affiliator_id ";
            $sql .= " LEFT JOIN `affiliator_options` uo ON uo.user_id = i.affiliator_id ";
            $sql .= " LEFT JOIN `carts` c ON (c.invoice_edit_id = i.id  and c.type='editing_in_progress') ";
            $sql .= " WHERE   i.id > 0 ";

            $sql .= $searchStatus && $searchStatus !== 'shipping_to_customer' && $searchStatus !== 'archive' ? $searchStatus !== 'editing_in_progress' ? " AND (i.`status` ='{$searchStatus}' ) AND (c.`invoice_edit_id` IS  NULL ) " : " AND (c.`invoice_edit_id` IS NOT NULL )" : ' ';
            $sql .= $searchStatus === 'shipping_to_customer' ? " AND (i.shipping_type = 'shipping_to_customer')   " : ' ';
            $sql .= $searchStatus === 'archive' ? " AND (i.archive = '1')   " : "";

            $sql .= $searchIvoiceType ? " AND (i.`invoice_type` ='{$searchIvoiceType}' ) " : '';

            $sql .= $searchIvoiceType == 'sale-invoice' && $searchStatus == '' ? " AND (i.`admin_id` ='" . ADMIN['id'] . "'  and i.set_from='app_admin') " : '';
            $sql .= $id ? " AND i.id = {$id} " : '';
            $sql .= " GROUP BY i.id ORDER BY i.{$sort} {$type}";
            $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        } else if ($searchIvoiceType == 'inventory-invoice') {


            $sql = "SELECT oi.* , u.id as user_id , u.user_level, u.user_name ,  'other_invoices' as   invoice_table ,u2.user_name as added_by   FROM `other_invoices` oi";
            $sql .= " LEFT JOIN `users` u ON u.id = oi.merchant_id ";
            $sql .= " LEFT JOIN `users` u2 ON u2.id = oi.admin_id ";

            $sql .= " WHERE   oi.id > 0 ";
            $sql .= $searchIvoiceType ? " AND (oi.`invoice_type` ='{$searchIvoiceType}' ) " : '';
            $sql .= $id ? " AND oi.id = {$id} " : '';
            $sql .= " ORDER BY oi.{$sort} {$type}";
            $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        }
//     echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                if ($searchIvoiceType == 'sale-invoice') {
                    $res[$i]['stores'] = $this->getProductStoresNameByInvoice($res[$i]['id']);
                    $res[$i]['products_count'] = $this->getInvoiceProductsCount($res[$i]['id']);
                } else if ($searchIvoiceType == 'inventory-invoice') {
                    $res[$i]['stores'] = $this->getProductStoresNameByOtherInvoice($res[$i]['id']);
                    $res[$i]['products_count'] = $this->getOtherInvoiceProductsCount($res[$i]['id']);
                    $res[$i]['products_grad_count'] = $this->getInvoiceProductsGradCount($res[$i]['id']);
                    $res[$i]['plus_quantity'] = $this->getInvoiceProductsGradPlusQuantity($res[$i]['id']);
                    $res[$i]['sub_quantity'] = $this->getInvoiceProductsGradSubQuantity($res[$i]['id']);
                }
            }
        }
        return $res;
    }

    public function getAllAdjustShelvesByAdmin($aStart, $aLimit, $sort, $type) {



        $sql = "SELECT asi.* ";
        $sql .= " FROM `adjust_shelves_invoices` asi ";
        $sql .= " WHERE   asi.id > 0 ";
        $sql .= " AND (asi.`admin_id` ='" . ADMIN['id'] . "'  and asi.set_from='app') ";
        $sql .= " GROUP BY asi.id ORDER BY asi.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//      echo $sql . "<hr>";
//
        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {

                $res[$i]['products_count'] = $this->getAdjustShelvesProductsCount($res[$i]['id']);
                $res[$i]['shelves_count'] = $this->getshelvesCount($res[$i]['id']);
            }
        }


// echo  $sql2 . $sql . $sql_limit;die();
        return $res;
    }

    public function getInvoiceProductsCount($invoice_id) {
        $sql = "SELECT  count(DISTINCT ii.product_id) FROM `invoice_items` ii   ";
        $sql .= " WHERE  ii.invoice_id = '{$invoice_id}'  ";
//echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getOtherInvoiceProductsCount($invoice_id) {
        $sql = "SELECT  count(ii.product_id) FROM `other_invoice_items` ii   ";
        $sql .= " WHERE  ii.invoice_id = '{$invoice_id}'  ";
//echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getInvoiceProductsGradCount($invoice_id) {
        $sql = "SELECT  count(ii.product_id) FROM `other_invoice_items` ii   ";
        $sql .= " WHERE  ii.invoice_id = '{$invoice_id}'  and  ii.quantity IS NOT NULL  ";
// echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getInvoiceProductsGradPlusQuantity($invoice_id) {
        $sql = "SELECT  IFNULL(sum(ii.increment_decrement),0) FROM `other_invoice_items` ii   ";
        $sql .= " WHERE  ii.invoice_id = '{$invoice_id}'  and  ii.increment_decrement > '0'  ";
// echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getInvoiceProductsGradSubQuantity($invoice_id) {
        $sql = "SELECT  IFNULL(sum(ii.increment_decrement),0) FROM `other_invoice_items` ii   ";
        $sql .= " WHERE  ii.invoice_id = '{$invoice_id}'  and  ii.increment_decrement < '0'  ";
// echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res ? $res : '-0';
    }

    public function getAdjustShelvesProductsCount($invoice_id) {
        $sql = "SELECT  count(DISTINCT asii.product_id) FROM `adjust_shelves_invoices_items` asii   ";
        $sql .= " WHERE  asii.invoice_id = '{$invoice_id}'  ";
//echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getshelvesCount($invoice_id) {
        $sql = "SELECT  count(DISTINCT asii.shelf_id) FROM `adjust_shelves_invoices_items` asii   ";
        $sql .= " WHERE  asii.invoice_id = '{$invoice_id}'  ";
//echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getProductStoresNameByInvoice($invoice_id = '') {
        $sql = "SELECT DISTINCT p.store_id,sl.title as store_title FROM `invoice_items` p";
        $sql .= " LEFT JOIN `product_stores_amounts` psa ON psa.store_id = p.store_id    ";
        $sql .= " LEFT JOIN `store_langs` sl ON sl.store_id = p.store_id   AND sl.lang_code = 'ar' ";
        $sql .= " WHERE  p.invoice_id = '{$invoice_id}' ";
        $sql .= " Group BY p.store_id,psa.`name`";
//      echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function getProductStoresNameByOtherInvoice($invoice_id = '') {
        $sql = "SELECT DISTINCT p.store_id,sl.title as store_title FROM `other_invoice_items` p";
        $sql .= " LEFT JOIN `product_stores_amounts` psa ON psa.store_id = p.store_id    ";
        $sql .= " LEFT JOIN `store_langs` sl ON sl.store_id = p.store_id   AND sl.lang_code = 'ar' ";
        $sql .= " WHERE  p.invoice_id = '{$invoice_id}' ";
        $sql .= " Group BY p.store_id,psa.`name`";
//      echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    //************************************** GetOneInvoiceByAdmin ***************************************/
    //************************************** GetOneInvoiceByAdmin ***************************************/


    public function GetOneInventoryInvoiceByAdmin($Req) {
        $sql = "SELECT 
                    p.*,
                    u.user_name as added_by  
                FROM other_invoices p
                LEFT JOIN users u ON u.id = p.admin_id
                WHERE p.id = :id";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $Req, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($res) {
            // $res['current_merchant'] = $this->userObj->getOneUser('', $res['merchant_id']);
            // $res['current_user'] = $res['current_merchant'];
            $res['invoice_items'] = $this->getInventoryInvoiceProducts($res['id'], $res['invoice_type'], $res['mode']);
        }
        return $res;
    }

    public function getInventoryInvoiceProducts($invoice_id, $invoice_type, $mode) {
        $sql = "SELECT 
                    oit.*, 
                    ps.is_deleted, 
                    p.product_code, 
                    p.product_barcode, 
                    tl.title as trademark_title, 
                    sl.title as store_title 
                FROM `other_invoice_items` oit
                LEFT JOIN `products` p ON p.id = oit.product_id
                LEFT JOIN `trademark_langs` tl ON p.trademark_id = tl.trademark_id AND tl.lang_code = :lang_code
                LEFT JOIN `store_langs` sl ON oit.store_id = sl.store_id AND sl.lang_code = :lang_code
                LEFT JOIN `product_stores` ps ON ps.name = oit.product_type_name AND ps.for_id = :invoice_id AND ps.for_type = :invoice_type
                WHERE oit.invoice_id = :invoice_id 
                GROUP BY oit.id";
        $sql .= "  ORDER BY oit.product_date_added DESC ";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindParam(':invoice_id', $invoice_id, PDO::PARAM_INT);
        $stmt->bindParam(':invoice_type', $invoice_type, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);

        if ($res) {
            foreach ($res as &$item) {
                $item['images'] = $this->getProductimgs($item['product_id']);
                $item['image'] = $item['images'][0]['name'];
                $item['quantity_show'] = $item['quantity'];
                $item['store_amounts'] = intval($item['store_amounts']);
                $item['product_services'] = $this->getProduct_services($item['product_id']);
                $item['shelfs'] = $this->getProductStoresAmountsByShelf($item['product_id'], $item['store_id'], $mode);
                $item['parent_expiration_date'] = '0';
                foreach ($item['product_services'] as $service) {
                    if ($service['parent_expiration_date'] == '1') {
                        $item['parent_expiration_date'] = '1';
                        break; // No need to check further once found
                    }
                }
            }
        }
        return $res;
    }

    public function getProductStoresAmountsByShelf($product_id, $store_id, $mode) {
        $sql = "SELECT   sas.id AS shelf_id ,sas.name AS shelf_name  FROM `product_stores_amounts_shelf` psas ";
        $sql .= " LEFT JOIN `store_adjust_shelves` sas ON sas.id = psas.shelf_id    ";
        $sql .= " WHERE  psas.product_id = :product_id and  psas.store_id = :store_id AND psas.mode = :mode";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':store_id', $store_id, PDO::PARAM_INT);
        $stmt->bindParam(':mode', $mode, PDO::PARAM_STR);
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getProduct_services($id) {
        $sql = "SELECT 
                    ps.service_id, 
                    s.id, 
                    sch.expiration_date AS parent_expiration_date, 
                    sl.ser_name, 
                    slch.ser_name AS parent_name, 
                    s.parent, 
                    s.service_system_commission  
                FROM product_services ps
                LEFT JOIN services s ON s.id = ps.service_id
                LEFT JOIN service_langs sl ON sl.service_id = s.id AND sl.lang_code = :lang_code
                LEFT JOIN services sch ON sch.id = s.parent
                LEFT JOIN service_langs slch ON slch.service_id = sch.id AND sl.lang_code = :lang_code
                WHERE ps.product_id = :product_id
                GROUP BY s.id 
                ORDER BY s.service_system_commission ASC";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindParam(':product_id', $id, PDO::PARAM_INT);
        $stmt->execute();

        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    //************************************** addEditInventoryInvoiceByAdmin ***************************************/

    public function addEditInventoryInvoiceByAdmin($Req) {
        if (!$Req['id']) {
            $newCountInvoiceType = $this->getInvoiceCountID();
            $data = $this->InsertNewInventoryInvoice($Req, $newCountInvoiceType);
            return $data;
        } else {
            $res = $this->UpdateInventoryInvoice($Req);
            if ($res) {
                $Req['mode'] = $Req['mode'] ? $Req['mode'] : "invoice";
                foreach ($Req['invoice_items'] as $product) {
                    if ($product['mode'] == 'add') {
                        $res = $this->AddNewInvoiceItem($product, $Req['id']);
                        $this->UpdateProductActive($product['product_id'], "2");
                        $this->AddProductValidShelds($product['shelfs'], $product['store_id'], $product['product_id']);
                    } elseif ($product['mode'] == 'edit') {
                        $res = $this->UpdateInvoiceItem($product, $Req['id']);
                        $this->AddProductValidShelds($product['shelfs'], $product['store_id'], $product['product_id']);
                    } elseif ($product['mode'] == 'delete') {
                        if ($product['repeated_count'] == 1) {
                            $this->updateProductItemInActive($product);
                        }
                        $this->DeleteProductValidShelds($product['store_id'], $product['product_id']);
                        $res = $this->DeleteInvoiceInvotryItem($product);
                    }
                    if ($Req['mode'] == 'invoice') {
                        $last_store_amounts = $product['quantity'];
                        $this->updateProductItemInCost($product);
                        $quantity = $this->getProductStoreAmounts($product['product_id'], $product['store_id'], $product['product_type_name'], $product['expiration_date']);
                        $product_stores = $this->MakeSomeChangesOnProductStore($product, $quantity, $Req['id'], 'inventory-invoice', $last_store_amounts, $Req['admin_id']);
                        $this->addEditProduct_stores($product_stores);
                        $this->addEditProductStoresAmounts($product_stores);
                        $this->updateProductItemInActive($product);
                        $this->SaveProductValidShelds($product['store_id'], $product['product_id']);
                        $res = $this->addProductStoresAmountsQuantityOnShelfForInvotryInvoice($product_stores, '', '');
                    }
                }
            }
            $array = [
                'id' => $Req['id'],
                'count_invoice_type' => $Req['count_invoice_type']
            ];
            return $array;
        }
    }

    public function addEditProductStoresAmounts($temp) {
        $oldData = $this->getProductStoresAmountsByData($temp);
        $new_store_amounts = 0;
        $new_quantity_reserved = $oldData['quantity_reserved'] ? $oldData['quantity_reserved'] : 0;
        if ($temp['for_type'] == 'inventory-invoice') {
            $new_store_amounts = $temp['store_amounts'];
        } else {
            if ($temp['type'] == 'add') {
                $new_store_amounts = (floatval($oldData['store_amounts']) + floatval($temp['value']));
            } else if ($temp['type'] == 'remove') {
                $new_store_amounts = (floatval($oldData['store_amounts']) - floatval($temp['value']));
            }
        }
        $new_store_amounts = $new_store_amounts >= 0 ? $new_store_amounts : 0;
        $new_quantity_on_shelf = $new_quantity_on_shelf >= 0 ? $new_quantity_on_shelf : 0;
        $new_quantity_reserved = $new_quantity_reserved >= 0 ? $new_quantity_reserved : 0;
        if (!$oldData['id']) {
            if ($temp['expiration_date'] && $new_store_amounts > 0 || !$temp['expiration_date']) {
                $sql = "INSERT INTO `product_stores_amounts` 
                            (`product_id`, `store_id`, `name`, `store_amounts`, `date_added`";
                $sql .= $temp['expiration_date'] ? ", `expiration_date`" : '';
                $sql .= ") VALUES (:product_id, :store_id, :name, :store_amounts, :date_added";
                $sql .= $temp['expiration_date'] ? ", :expiration_date" : '';
                $sql .= ")";
                $stmt = $this->mDb->connect()->prepare($sql);

                // Binding values
                $stmt->bindParam(':product_id', $temp['product_id'], PDO::PARAM_INT);
                $stmt->bindParam(':store_id', $temp['store_id'], PDO::PARAM_INT);
                $stmt->bindParam(':name', $temp['name'], PDO::PARAM_STR);
                $stmt->bindParam(':store_amounts', $new_store_amounts, PDO::PARAM_INT);
                $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
                $temp['expiration_date'] ? $stmt->bindParam(':expiration_date', $temp['expiration_date'], PDO::PARAM_STR) : '';
                return $stmt->execute();
            }
        } else {
            if ($temp['expiration_date'] && $new_store_amounts == '0') {
                $sql = "DELETE FROM `product_stores_amounts` WHERE id = :id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':id', $oldData['id'], PDO::PARAM_INT);
                return $stmt->execute();
            } else {
                $sql = "UPDATE `product_stores_amounts` SET 
                            store_amounts = :store_amounts, 
                            date_added = :date_added 
                        WHERE id = :id";
                $stmt = $this->mDb->connect()->prepare($sql);
                // Binding parameters
                $stmt->bindParam(':store_amounts', $new_store_amounts, PDO::PARAM_STR);
                $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
                $stmt->bindParam(':id', $oldData['id'], PDO::PARAM_INT);
                return $stmt->execute();
            }
        }
    }

    public function UpdateProductActive($id, $active) {
        $sql = "UPDATE `products` SET active = :active WHERE `id` = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':active', $active, PDO::PARAM_STR);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        return $stmt->execute();
    }

    public function getProductStoresAmountsByData($temp) {
        $sql = "SELECT `id`, `store_amounts`, `quantity_on_shelf`, `quantity_reserved` 
                FROM product_stores_amounts 
                WHERE `product_id` = :product_id 
                AND `store_id` = :store_id";

        // Optional parameters
        $sql .= $temp['name'] ? " AND `name` = :name" : '';
        $sql .= $temp['expiration_date'] ? " AND `expiration_date` = :expiration_date" : " AND `expiration_date` IS NULL";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $temp['product_id'], PDO::PARAM_INT);
        $stmt->bindParam(':store_id', $temp['store_id'], PDO::PARAM_INT);
        $temp['name'] ? $stmt->bindParam(':name', $temp['name'], PDO::PARAM_STR) : '';
        $temp['expiration_date'] ? $stmt->bindParam(':expiration_date', $temp['expiration_date'], PDO::PARAM_STR) : '';
        // Execute and return the row
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function updateProductItemInActive($Req) {
        $Req['product_last_active'] = $Req['product_last_active'] == '' ? '1' : $Req['product_last_active'];
        $sql = "UPDATE `products` SET active = :active WHERE `id` = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        // Binding parameters
        $stmt->bindParam(':active', $Req['product_last_active'], PDO::PARAM_STR);
        $stmt->bindParam(':id', $Req['product_id'], PDO::PARAM_INT);
        $res = $stmt->execute();
        if ($res) {
            $this->updateSharingApiProductsAllByProductId($Req['product_id']);
        }
        return $res;
    }

    public function updateSharingApiProductsAllByProductId($product_id) {
        $sql = "UPDATE `sharing_api_products` SET `edit` = :edit WHERE `product_id` = :product_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $editValue = '1'; // or true, depending on your logic
        $stmt->bindParam(':edit', $editValue, PDO::PARAM_STR);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $res = $stmt->execute();
        return $res ? $res : '';
    }

    public function getInvoiceCountID() {
        $sql = "SELECT count_invoice_type + 1 AS new_count_invoice_type 
                FROM `other_invoices` 
                ORDER BY id DESC 
                LIMIT 1";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        return $result['new_count_invoice_type'];
    }

    public function InsertNewInventoryInvoice($Req, $newCountInvoiceType) {
        $invoice_type = 'inventory-invoice';
        $admin_id = ADMIN['id'];
        $set_from = SETFROM;
        $sql = "INSERT INTO other_invoices 
                SET 
                    admin_id = :admin_id, 
                    invoice_type = :invoice_type, 
                    merchant_id = :merchant_id, 
                    total_quantity = :total_quantity, 
                    count_invoice_type = :count_invoice_type, 
                    note = :note, 
                    mode = :mode, 
                    set_from = :set_from, 
                    date_added = :date_added";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':admin_id', $admin_id, PDO::PARAM_INT);
        $stmt->bindParam(':invoice_type', $invoice_type, PDO::PARAM_STR);
        $stmt->bindParam(':merchant_id', $Req['merchant_id'], PDO::PARAM_INT);
        $stmt->bindParam(':total_quantity', $Req['total_quantity'], PDO::PARAM_INT);
        $stmt->bindParam(':count_invoice_type', $newCountInvoiceType, PDO::PARAM_INT);
        $stmt->bindParam(':note', $Req['note'], PDO::PARAM_STR);
        $stmt->bindParam(':mode', $Req['mode'], PDO::PARAM_STR);
        $stmt->bindParam(':set_from', $set_from, PDO::PARAM_STR);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        if ($stmt->execute()) {
            $id = $this->mDb->getLastInsertId();
        }
        $array = [
            'id' => $id,
            'count_invoice_type' => $newCountInvoiceType
        ];
        return $array;
    }

    public function UpdateInventoryInvoice($Req) {
        $sql = "UPDATE other_invoices 
                SET 
               
                    merchant_id = :merchant_id, 
                    total_quantity = :total_quantity, 
                    note = :note, 
                    mode = :mode, 
                    date_added_last_update = :date_added_last_update
                WHERE id = :id";

        $stmt = $this->mDb->connect()->prepare($sql);

        $stmt->bindParam(':merchant_id', $Req['merchant_id'], PDO::PARAM_INT);
        $stmt->bindParam(':total_quantity', $Req['total_quantity'], PDO::PARAM_INT);
        $stmt->bindParam(':note', $Req['note'], PDO::PARAM_STR);
        $stmt->bindParam(':mode', $Req['mode'], PDO::PARAM_STR);
        $stmt->bindParam(':date_added_last_update', $this->dateTime, PDO::PARAM_STR);
        $stmt->bindParam(':id', $Req['id'], PDO::PARAM_INT);
        if ($stmt->execute()) {
            return true;
        }
    }

    public function getStoresInProductId($product_id, $fromDetails = '', $store_id = '') {
        $sql = "SELECT DISTINCT 
                    p.id,
                    p.product_id,
                    p.store_id,
                    p.name,
                    p.expiration_date ,
                    sl.title as store_title 
                FROM product_stores_amounts p
                LEFT JOIN `store_langs` sl ON sl.store_id = p.store_id AND sl.lang_code = :lang_code
                WHERE p.`product_id` = :product_id ";
        $sql .= $store_id ? " AND p.`store_id` IN(:store_id)" : "";
        $sql .= $fromDetails ? " Group BY p.`store_id`,p.`name`,p.`expiration_date` " : "";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $store_id ? $stmt->bindParam(':store_id', $store_id, PDO::PARAM_STR) : "";
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if ($res) {
            $new_res = array();
            foreach ($res as $key => $value) {
                $res[$key]['store_amounts_product'] = $this->getProductStoreAmounts($value['product_id'], $value['store_id'], $value['name'], $value['expiration_date']);
            }
        } else {
            $res = array();
            $storeIds = explode(",", $store_id);
            for ($s = 0; $s < count($storeIds); $s++) {
                array_push($res, [
                    "id" => rand(123, 130),
                    "product_id" => $product_id,
                    "name" => "الافتراضي",
                    "store_amounts_product" => 0,
                    "store_id" => $storeIds[$s],
                    "store_title" => $this->getStoreTitle($storeIds[$s]),
                    "expiration_date" => null,
                ]);
            }
        }
        return $res;
    }

    public function getProductStoreAmounts($product_id, $store_id = '', $name = '', $expiration_date = '') {
        $parent_expiration_date = $this->getParentExpirationDateByProductId($product_id);
        $sql = "SELECT  
                    IFNULL(SUM(store_amounts),0)  as store_amounts  
                FROM `product_stores_amounts` 
                where product_id ='{$product_id}'     ";
        $sql .= $store_id ? " AND  `store_id` = '{$store_id}'   " : "";
        $sql .= $name ? " AND  `name` = '{$name}'   " : "";
        $sql .= ($parent_expiration_date && $store_id && $name) ? $expiration_date ? " AND  `expiration_date` = '{$expiration_date}' " : "   AND  `expiration_date` IS NULL  " : "";
        $sql .= "  group by product_id   ";
        $addition = $this->mDb->getOne($sql);
        return intval($addition);
    }

    public function getParentExpirationDateByProductId($id) {
        $sql = "SELECT sch.expiration_date AS parent_expiration_date 
                FROM product_services ps 
                LEFT JOIN services s ON s.id = ps.service_id 
                LEFT JOIN services sch ON sch.id = s.parent 
                WHERE ps.product_id = :product_id AND sch.expiration_date IS NOT NULL";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $id, PDO::PARAM_INT);
        $stmt->execute();

        return $stmt->fetchColumn(0);
    }

    public function getAllServicesNameOfProductById($id) {
        $sql = "SELECT sl.ser_name 
                FROM product_services ps 
                LEFT JOIN service_langs sl ON sl.service_id = ps.service_id AND sl.lang_code = :lang_code 
                WHERE ps.product_id = :product_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindParam(':product_id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return fetchArrayValue_from_dataBase($res, 'ser_name');
    }

    public function AddNewInvoiceItem($product, $id) {
        $availableKeys = [
            'product_id',
            'product_type_name',
            'quantity',
            'remaining_store_amounts',
            'store_id',
            'product_name',
            'unit_title',
            'store_title',
            'product_date_added',
            'store_amounts',
            'expiration_date',
            'cost',
            'real_cost',
            'total_cost',
            'increment_decrement',
            'product_last_active',
        ];

        foreach ($product as $key => $value) {
            if (!in_array($key, $availableKeys)) {
                unset($product[$key]);
            }
        }

        $columns = [];
        $placeholders = [];
        $params = [];

        foreach ($product as $key => $value) {
            if ($key === 'quantity' && (empty($value) && $value !== '0')) {
                // إذا كانت quantity فارغة أو null، اجعلها null
                $value = null;
            }

            $columns[] = "`$key`";
            $placeholders[] = ":$key";
            $params[":$key"] = $value; // إضافة القيم إلى مصفوفة المعلمات
        }

        $columns[] = "`invoice_id`";
        $placeholders[] = ":invoice_id";
        $params[':invoice_id'] = $id;

        $sql = "INSERT INTO other_invoice_items 
                (" . implode(", ", $columns) . ") 
            VALUES (" . implode(", ", $placeholders) . ")";
        $stmt = $this->mDb->connect()->prepare($sql);

        foreach ($params as $placeholder => $value) {
            // استخدام bindValue لتحديد إذا كانت القيمة null
            if (is_null($value)) {
                $stmt->bindValue($placeholder, null, PDO::PARAM_NULL);
            } else {
                $stmt->bindValue($placeholder, $value);
            }
        }

        $stmt->execute();
//        $stmt->debugDumpParams();
    }

    public function UpdateInvoiceItem($product, $invoiceId) {
        $availableKeys = [
            'product_id',
            'product_type_name',
            'quantity',
            'remaining_store_amounts',
            'store_id',
            'product_name',
            'unit_title',
            'store_title',
            'product_date_added',
            'store_amounts',
            'expiration_date',
            'cost',
            'real_cost',
            'total_cost',
            'increment_decrement',
            'product_last_active',
            'id'
        ];

        // Filter the product array
        foreach ($product as $key => $value) {
            if (!in_array($key, $availableKeys)) {
                unset($product[$key]);
            }
        }

        // Prepare columns and parameters for the UPDATE statement
        $sets = [];
        $params = [];
        foreach ($product as $key => $value) {
            $sets[] = "`$key` = :$key"; // Prepare the SET part
            $params[":$key"] = $value; // Bind the values
        }

        // Add the invoice ID parameter
        $params[':invoice_id'] = $invoiceId;
        $sets[] = "`invoice_id` = :invoice_id";
        $sql = "UPDATE other_invoice_items 
                SET " . implode(", ", $sets) . " 
                WHERE invoice_id = :invoice_id AND id = :id"; // Use the invoice ID to identify which row to update
        // Prepare and execute the statement
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($params as $placeholder => $value) {
            $stmt->bindValue($placeholder, $value);
        }
        $stmt->execute();
        return;
    }

    public function updateProductItemInCost($Req) {
        $sql = "UPDATE `products` SET cost = :real_cost WHERE `id` = :product_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':real_cost', $Req['real_cost'], PDO::PARAM_STR);
        $stmt->bindParam(':product_id', $Req['product_id'], PDO::PARAM_INT);
        return $stmt->execute();
    }

    public function MakeSomeChangesOnProductStore($product, $quantity, $id, $invoice_type, $last_store_amounts, $admin_id) {
        if (($quantity - $product['quantity']) < 0) {
            $product_stores['type'] = 'add';
            $product['quantity'] = $product['quantity'] - $quantity;
        } else if (($quantity - $product['quantity']) > 0) {
            $product_stores['type'] = 'remove';
            $product['quantity'] = $quantity - $product['quantity'];
        } else if (($quantity - $product['quantity']) == 0) {
            $product_stores['type'] = 'add';
            $product['quantity'] = 0;
        }
        $product_stores['name'] = $product['product_type_name'];
        $product_stores['product_id'] = $product['product_id'];
        $product_stores['store_id'] = $product['store_id'];
        $product_stores['expiration_date'] = $product['expiration_date'];
        $product_stores['for_id'] = $id;
        $product_stores['for_type'] = $invoice_type;
        $product_stores['value'] = $product['quantity'];
        $product_stores['store_amounts'] = $last_store_amounts;
        $product_stores['admin_id'] = $admin_id;
        $product_stores['is_deleted'] = $product['is_deleted'] == '1' ? '1' : '0';
        return $product_stores;
    }

    public function addEditProduct_stores($temp, $dateTime = '', $lastStoreAmounts = '-1') {
//        print_r($temp);
        $sql = "INSERT INTO `product_stores` SET ";
        foreach ($this->mDb->getCols('product_stores', $temp) as $k => $v) {
            $sql .= ($k == 'medias' || $k == 'id' || $k == 'product_types' || $k == 'lang_Details') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}' ";
        $res = $this->mDb->query($sql);

        if ($res) {
            if ($lastStoreAmounts != '' && $lastStoreAmounts == '0') {
                $sql = "UPDATE  `products` SET ";
                $sql .= " new_store_amounts_date_added='{$dateTime}'";
                $sql .= " where `id` = '{$temp['product_id']}' ";
                $this->mDb->query($sql);
            }
        }
        return $res;
    }

    public function addProductStoresAmountsQuantityOnShelfForInvotryInvoice($temp, $status, $id = '') {
        $oldData = $this->getProductStoresAmountsByData($temp);
        $new_quantity_on_shelf = $oldData['quantity_on_shelf'] ? $oldData['quantity_on_shelf'] : 0;
        $new_quantity_reserved = $oldData['quantity_reserved'] ? $oldData['quantity_reserved'] : 0;
        $new_quantity_on_shelf = $temp['store_amounts'];
        $new_quantity_reserved = 0;
        $res = $this->UpdateProductStoreAmountAsAdvanced($new_quantity_on_shelf, $new_quantity_reserved, $oldData['id'], '');
        return $res;
    }

    public function UpdateProductStoreAmountAsAdvanced($shelf, $reserved, $id, $store_id) {
        $sql = "UPDATE product_stores_amounts
                SET
                quantity_on_shelf = :quantity_on_shelf, ";
        $sql .= "quantity_reserved = :quantity_reserved ";
        $sql .= "WHERE id = :id";
        $sql .= $store_id ? " AND store_id = $store_id " : "";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':quantity_on_shelf', $shelf, PDO::PARAM_STR);
        $stmt->bindParam(':quantity_reserved', $reserved, PDO::PARAM_STR);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        return $stmt->execute();
    }

    public function DeleteInvoiceInvotryItem($product) {
        $sql = "DELETE FROM `other_invoice_items` WHERE id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $product['id'], PDO::PARAM_INT);
        return $stmt->execute();
    }

    //************************************** deleteInventoryInvoice ***************************************/
    public function deleteInventoryInvoice($temp) {
        if ($temp['mode'] == 'draft') {
            $invoice_items = $this->getInvoiceInventoryProductsList($temp['id']);
            foreach ($invoice_items as $product) {
                $this->updateProductItemInActive($product);
            }
        }

        $sql = "DELETE oi,oii FROM  other_invoices oi
                left join other_invoice_items oii on oi.id = oii.invoice_id";
        $sql .= " WHERE oi.`id` = :id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $temp['id'], PDO::PARAM_INT);
        $res = $stmt->execute();
//        echoSql($stmt);
        return $res;
    }

    public function getInvoiceInventoryProductsList($id) {
        $sql = "SELECT * FROM `other_invoice_items`  WHERE  invoice_id = :invoice_id  ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':invoice_id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res;
    }

//********************************************

    public function AddProductValidShelds($shelds, $store_id, $product_id) {
        $this->DeleteProductValidShelds($store_id, $product_id);
        foreach ($shelds as $sheld) {
            $sql = "INSERT INTO `product_stores_amounts_shelf` SET  ";
            $sql .= " `scan_date` = :scan_date, ";
            $sql .= " `product_id` = :product_id, ";
            $sql .= " `mode` = 'draft', ";
            $sql .= " `store_id` = :store_id, ";
            $sql .= " `shelf_id` = :shelf_id ";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':scan_date', $this->dateTime, PDO::PARAM_STR);
            $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
            $stmt->bindParam(':store_id', $store_id, PDO::PARAM_INT);
            $stmt->bindParam(':shelf_id', $sheld, PDO::PARAM_INT);
            $stmt->execute();
        }
    }

    public function SaveProductValidShelds($store_id, $product_id) {
        $sql = "DELETE FROM `product_stores_amounts_shelf` 
                WHERE product_id = :product_id AND store_id = :store_id AND mode = 'invoice' ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':store_id', $store_id, PDO::PARAM_INT);
        $stmt->execute();

        $sql = "UPDATE product_stores_amounts_shelf 
                SET mode = 'invoice' 
                WHERE  product_id = :product_id AND store_id = :store_id AND mode = 'draft'";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':store_id', $store_id, PDO::PARAM_INT);
        $stmt->execute();
    }

    public function DeleteProductValidShelds($store_id, $product_id) {
        $sql = "DELETE FROM product_stores_amounts_shelf 
                WHERE product_id = :product_id AND store_id = :store_id AND mode = 'draft' ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
        $stmt->bindParam(':store_id', $store_id, PDO::PARAM_INT);
        $stmt->execute();
    }

    //************************************** deleteOneShelf ***************************************/
    public function deleteOneShelf($temp) {
        $sql = "DELETE FROM product_stores_amounts_shelf 
                WHERE shelf_id = :shelf_id AND store_id = :store_id AND mode = :mode ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':shelf_id', $temp['shelf_id'], PDO::PARAM_INT);
        $stmt->bindParam(':store_id', $temp['store_id'], PDO::PARAM_INT);
        $stmt->bindParam(':mode', $temp['mode'], PDO::PARAM_STR);
        $res = $stmt->execute();
        return $res;
    }

    //************************************** GetStatusOfSaleInvoice ***************************************/

    public function GetStatusOfSaleInvoice($Req) {
        if ($Req) {
            $res = $this->getSaleInvoiceDataOfStatus($Req);
            if ($res) {
                $res['shipment_info'] = $this->getShipmentInfo($res['shipment_id']);
                if ($res['shipment_info']['shipping_policy'] === '1') {
                    $res['shipment_info']['shipping_policy_bar_code'] = $res['shipment_info']['company_code'] . '-' . $res['count_invoice_type'];
                    $res['shipment_info']['shipping_policy_bar_code_image'] = $res['shipment_info']['shipping_policy_bar_code'] . '.jpg';
                }
                $data = $this->getHistoryEditInvoice($Req['id']);
                $first_history = $this->getFirstHistoryEditInvoice($Req['id']);
                $first_history['status'] = $first_history['status_last'] ?? $res['status'];
                $first_history['date_added'] = $res['date_added'];
                $first_history['content'] = $this->getMessingDataContent($first_history, $res);
                $index = array_search($first_history['status'], array_column($data, 'status'));
                if ($index !== false) {
                    $data[$index] = $first_history;
                } else {
                    $data[] = $first_history;
                }
                $data = $this->changeHistoryByStatus($data);
                $res['history_edit_invoice'] = $this->updateMissingDates($data, $res);
                $res['history_edit_invoice'] = array_values($res['history_edit_invoice']);
            }
            return $res;
        }
    }

    public function getHistoryEditInvoice($invoice_id) {
        $sql = "
                WITH LastStatusOrder AS (
                    SELECT FIELD(status, 'pending', 'booked_up', 'waiting_confirm', 'confirmed', 'client_not_responce', 'under_prepare', 'prepared', 'ready_to_delivered', 'in_delivered', 'delivery_failed', 'delivered','canceled') AS last_status_order
                    FROM history_edit_invoice
                    WHERE invoice_id = :invoice_id
                        AND status IS NOT NULL
                        AND status != ''
                        AND mode = 'change_invoice_status'
                        AND date_added IS NOT NULL
                    ORDER BY date_added DESC
                    LIMIT 1
                ),
                FilteredHistory AS (
                    SELECT hei.*, pl.name AS product_name, u.user_name
                    FROM history_edit_invoice hei
                    LEFT JOIN product_langs pl 
                        ON pl.product_id = hei.product_id AND pl.lang_code = :lang_code
                    LEFT JOIN users u 
                        ON u.id = hei.admin_id
                    WHERE hei.invoice_id = :invoice_id
                        AND hei.status IS NOT NULL
                        AND hei.status != ''
                        AND hei.mode = 'change_invoice_status'
                        AND FIELD(hei.status, 'pending', 'booked_up', 'waiting_confirm', 'confirmed', 'client_not_responce', 'under_prepare', 'prepared', 'ready_to_delivered', 'in_delivered', 'delivery_failed', 'delivered','canceled')
                        <= (SELECT last_status_order FROM LastStatusOrder)
                ),
                AllStatuses AS (
                    SELECT 'pending' AS status UNION ALL
                    SELECT 'booked_up' UNION ALL
                    SELECT 'waiting_confirm' UNION ALL
                    SELECT 'confirmed' UNION ALL
                    SELECT 'client_not_responce' UNION ALL
                    SELECT 'under_prepare' UNION ALL
                    SELECT 'prepared' UNION ALL
                    SELECT 'ready_to_delivered' UNION ALL
                    SELECT 'in_delivered' UNION ALL
                    SELECT 'delivery_failed' UNION ALL
                    SELECT 'delivered' UNION ALL
                    SELECT 'canceled' 
                ),
                CombinedHistory AS (
                    SELECT s.status, h.product_name, h.user_name, status_last,
                        -- إبقاء التاريخ كما هو بدون تعديل
                        h.date_added,
                        h.invoice_id
                    FROM AllStatuses s
                    LEFT JOIN (
                        SELECT * FROM (
                            SELECT hei.*, ROW_NUMBER() OVER (PARTITION BY status ORDER BY date_added DESC) AS row_num
                            FROM FilteredHistory hei
                        ) AS subquery
                        WHERE row_num = 1
                    ) AS h ON s.status = h.status
                )
                SELECT status, product_name, user_name, date_added, invoice_id, status_last
                FROM CombinedHistory
                WHERE FIELD(status, 'pending', 'booked_up', 'waiting_confirm', 'confirmed', 'client_not_responce', 'under_prepare', 'prepared', 'ready_to_delivered', 'in_delivered', 'delivery_failed', 'delivered', 'canceled')
                    <= (SELECT last_status_order FROM LastStatusOrder)
                ORDER BY FIELD(status, 'pending', 'booked_up', 'waiting_confirm', 'confirmed', 'client_not_responce', 'under_prepare', 'prepared', 'ready_to_delivered', 'in_delivered', 'delivery_failed', 'delivered', 'canceled') ASC
                ";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindParam(':invoice_id', $invoice_id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res;
    }

    public function getShipmentInfo($id) {
        $sql = " SELECT 
                    sm.shipping_policy,
                    sm.image,
                    sm.main_branch_number,
                    sm.company_code ,
                    sm.id,
                    sm.default_shipping_method, 
                    smg.customer_price, 
                    smg.delivery_time_from,
                    smg.delivery_time_to,
                    smg.branch_number,
                    smg.store_price, 
                    sml.name 
                FROM `shipping_methods_governorate` smg ";
        $sql .= " LEFT JOIN `shipping_methods` sm ON sm.id = smg.p_id  ";
        $sql .= " LEFT JOIN `shipping_methods_langs` sml ON sm.id = sml.p_id  AND sml.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE sm.id = :id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        return $res;
    }

    public function historyEditSaleInvoice($invoice, $status) {
        if ($invoice['status'] != $status) {
            $sql = "INSERT INTO `history_edit_invoice`";
            $sql .= "(`invoice_id`,`mode`,`status_last`,`status`,`date_added`) VALUES ";
            $sql .= "(:invoice_id,:mode,:status_last,:status,:date_added)";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':invoice_id', $invoice['id'], PDO::PARAM_INT);
            $stmt->bindParam(':mode', $invoice['mode'], PDO::PARAM_STR);
            $stmt->bindParam(':status_last', $invoice['status'], PDO::PARAM_STR);
            $stmt->bindParam(':status', $status, PDO::PARAM_STR);
            $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
            $stmt->execute();
        }
    }

    public function getFirstHistoryEditInvoice($invoice_id) {
        $sql = "SELECT hei.status,hei.status_last, pl.name AS product_name, u.user_name
            FROM history_edit_invoice hei
            LEFT JOIN product_langs pl 
                ON pl.product_id = hei.product_id AND pl.lang_code = :lang_code
            LEFT JOIN users u 
                ON u.id = hei.admin_id
            WHERE hei.invoice_id = :invoice_id
            ORDER BY hei.date_added ASC
            LIMIT 1";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $stmt->bindParam(':invoice_id', $invoice_id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        return $res;
    }

    public function updateMissingDates($data, $res) {
        foreach ($data as $k => $date) {
            $data[$k]['content'] = $this->getMessingDataContent($date, $res);
            if ($date['date_added'] == null) {
                foreach ($data as $key => $nextDate) {
                    if ($nextDate['date_added'] != null && $k < $key) {
                        $data[$k]['date_added'] = $nextDate['date_added'];
                        break;
                    }
                }
            }
        }
        return $data;
    }

    public function getMessingDataContent($data, $res) {
        if ($data['status'] == 'pending') {
            $msg = $this->lang_code == 'ar' ? 'تم استلام طلبك رقم (' . $res['count_invoice_type'] . ') بنجاح!.. تابع تحديث حالة الطلب' : 'Your request No. (' . $res['count_invoice_type'] . ') has been successfully received! .. Continue to update the status of the order';
        } else if ($data['status'] == 'waiting_confirm') {
            $msg = $this->lang_code == 'ar' ? 'جاري التحقق من طلبك رقم (' . $res['count_invoice_type'] . ')' : 'Verifying your request No. (' . $res['count_invoice_type'] . ')';
        } else if ($data['status'] == 'confirmed') {
            $msg = $this->lang_code == 'ar' ? 'تم تأكيد طلبك رقم (' . $res['count_invoice_type'] . ')' : 'Your order number has been confirmed (' . $res['count_invoice_type'] . ')';
        } else if ($data['status'] == 'client_not_responce') {
            $msg = $this->lang_code == 'ar' ? 'حاول فريق خدمة العملاء التواصل معكم .. يرجى التواصل معنا فى اقرب وقت' : 'The customer service team tried to contact you. Please contact us as soon as possible';
        } else if ($data['status'] == 'delivery_failed') {
            $msg = $this->lang_code == 'ar' ? 'مندوب التوصيل حاول الاتصال بكم هاتفيا .. نرجوا الرد على المندوب' : 'The delivery representative tried to contact you by phone. Please respond to the representative';
        } else if ($data['status'] == 'under_prepare') {
            $msg = $this->lang_code == 'ar' ? 'أخبار جيدة! ... جارى تجهيز و تغليف طلبك رقم (' . $res['count_invoice_type'] . ')' : 'good news! ... Your request No. (' . $res['count_invoice_type'] . ') is being processed.';
        } else if ($data['status'] == 'prepared') {
            $msg = $this->lang_code == 'ar' ? 'أخبار جيدة! ... تم تجهيز وتغليف طلبك رقم (' . $res['count_invoice_type'] . ')' : 'good news! ... Your request No. (' . $res['count_invoice_type'] . ') It has been prepared.';
        } else if ($data['status'] == 'ready_to_delivered') {
            $msg = $this->lang_code == 'ar' ? 'أخبار جيدة! ... طلبك رقم (' . $res['count_invoice_type'] . ') جاهز للشحن , ستقوم شركة الشحن قريبا باستلام طلبك وتوصيله اليك' : 'good news! ... Your order No. (' . $res['count_invoice_type'] . ') is ready for shipment';
        } else if ($data['status'] == 'in_delivered') {
            $msg = $this->lang_code == 'ar' ? 'أخبار جيدة ! ... تم شحن طلبك رقم (' . $res['count_invoice_type'] . ') ' : 'good news! ... Your order No. (' . $res['count_invoice_type'] . ') is in progress';
        } else if ($data['status'] == 'delivered') {
            $msg = $this->lang_code == 'ar' ? 'شكرا لاستلامك الطلب رقم (' . $res['count_invoice_type'] . ') نسعد بخدمتكم!' : 'Thank you for receiving order No. (' . $res['count_invoice_type'] . ') We are happy to serve you!';
        } else if ($data['status'] == 'canceled') {
            $msg = $this->lang_code == 'ar' ? 'نأسف لذلك!.. تم الغاء طلبكم رقم (' . $res['count_invoice_type'] . ')' : "We're sorry!.. Your order No. (" . $res['count_invoice_type'] . ") has been cancelled.";
        } else if ($data['status'] == 'booked_up') {
            $msg = $this->lang_code == 'ar' ? 'طلبك رقم (' . $res['count_invoice_type'] . ') محجوز الان! .. لن يتم شحن الطلب حتى تقوم بتأكيد الشحن' : "Your order number (" . $res['count_invoice_type'] . ") is now reserved! .. Not shipped until you confirm shipment ";
        }
        return $msg;
    }

    public function getSaleInvoiceDataOfStatus($Req) {
        $sql = "SELECT 
                    p.status,
                    p.id,
                    p.city_name,
                    p.city_id,
                    p.address,
                    p.mobile,
                    p.shipping_type,
                    p.shipment_id,
                    p.count_invoice_type,
                    p.shipment_company,
                    p.shipment_value,
                    p.address_full_name,
                    p.client_id,
                    u.user_name as added_by,
                    p.date_added,
                    csa.full_name,
                    csa.title as client_shipping_address ,
                    csa.mobile as client_shipping_mobile FROM invoices p ";
        $sql .= " LEFT JOIN users u ON u.id = p.admin_id ";
        $sql .= " LEFT JOIN client_shipping_addresses csa ON csa.id = p.address_id ";
        $sql .= " WHERE p.id = :id  AND invoice_type = 'sale-invoice' ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $Req['id'], PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function changeHistoryByStatus($data) {
        if (end($data)['status'] == 'canceled') {
            foreach ($data as $key => $entry) {
                if (
                        ($entry['date_added'] == null || $entry['date_added'] == '' ) ||
                        ($entry['status'] == 'delivered')
                ) {
                    unset($data[$key]);
                }
            }
        } else {
            foreach ($data as $key => $entry) {
                if (in_array($entry['status'], ['delivery_failed', 'client_not_responce', 'booked_up']) &&
                        ($entry['date_added'] == null || $entry['date_added'] == '')) {
                    unset($data[$key]);
                }
            }
        }
        return $data;
    }
}
