<?php

$productsObj = new Products();

class Products {

    public $mDb;
    public $mConfig;
    public $lang_code;
    public $dateTime;
    public $date;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->date = date('Y-m-d');
        $this->lang_code = LANGUAGE;
    }

    public function getClientsHaveListenToProductAvailability() {
        $sql = "SELECT n.* , pla.name as product_name_ar ,   ple.name as product_name_en FROM product_availability_notices n  ";
        $sql .= " LEFT JOIN `products` p ON p.id = n.product_id   ";
        $sql .= " LEFT JOIN `product_langs` pla ON pla.product_id = p.id  AND  pla.lang_code = 'ar' ";
        $sql .= " LEFT JOIN `product_langs` ple ON ple.product_id = p.id  AND  ple.lang_code = 'en' ";

        $sql .= " WHERE p.active  ='1' AND  n.`notify_status` = 'not_send'  ";
        $res = $this->mDb->getAll($sql);

        $res_cach = $res;
        for ($i = 0; $i < count(($res_cach)); $i++) {

            $affiliatorStores = $this->getAffiliatorStoresIds($res[$i]['affiliator_id']);
            $store_amounts = $this->getProductStoreAmounts($res[$i]['product_id'], $affiliatorStores);
            // p($store_amounts);
            if ($store_amounts <= 0) {
                unset($res[$i]);
            }
        }


        return array_values($res);
    }

    public function getProductStoreAmounts($product_id, $store_id = '', $name = '') {

        $sql = "SELECT  IFNULL(SUM(store_amounts),0)  as store_amounts  FROM `product_stores_amounts` where product_id ='{$product_id}'     ";
        $sql .= $store_id ? " AND  `store_id` IN({$store_id})   " : "";
        $sql .= $name ? " AND  `name` = '{$name}'   " : "";

        $sql .= "  group by product_id   ";
//      echo $sql."<hr>";
        $addition = $this->mDb->getOne($sql);

        return intval($addition);
    }

    public function getAffiliatorStoresIds($affiliator_id) {
        $sql = "SELECT store_id  FROM `affiliator_stores`  ";
        $sql .= " WHERE   user_id  ='{$affiliator_id}'     ";

        $res = $this->mDb->getAll($sql);
//  echo $sql;
//   die();
        return $res ? fetchArrayValue_from_dataBase($res, 'store_id') : array();
    }

    public function updateProductAvailabilityListinerStatus($listiner_ids) {
        $sql = "UPDATE   product_availability_notices  SET  `notify_status` =  'send',`send_date_added`='{$this->dateTime}'  where id in (" . $listiner_ids . ")";

        $this->mDb->query($sql);
    }

    function getAutoLoadSettings() {

        $sql = " SELECT name,value ";
        $sql .= " FROM `{$this->mPrefix}settings` ";
        $sql .= " WHERE `autoload`='1' ";

        $res = $this->mDb->getAll($sql);
        foreach ($res as $k => $v) {
            $temp[$v['name']] = $v['value'];
        }
        $temp['CurrenciesItem'] = $this->getAllCurrencies();

        return $temp;
    }

    function getAllCurrencies($aStart = '0', $aLimit = '0', $sort = 'id', $type = 'DESC', $searchName = '') {

        $sql = "SELECT * FROM currencies  ";
        $sql .= " ORDER BY  {$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    public function updatelast_priceInprice() {
        $sql = "SELECT `id`,`price_one`,`last_price_one` FROM `products` WHERE `last_price_one`>`price_one` and `last_price_one`>'0' and `price_one` > '0'";
        $res = $this->mDb->getAll($sql);
        foreach ($res as $k => $v) {
            $sql = "UPDATE   products  SET  `price_one` =  '{$v['last_price_one']}',`last_price_one`='{$v['price_one']}'  where id ='{$v['id']}' ";
            echo $sql . "<hr>";
            $this->mDb->query($sql);
        }
    }

    public function updateProductEditPriceExchange($id) {
        $sql = "UPDATE   products  SET  `edit_price_exchange` =  '0'  where id ='{$id}' ";
        $this->mDb->query($sql);
    }

    public function getProductInvoiceReceiptInfo($product_id) {
        $sql = "SELECT  avg(price)   FROM `invoices`  i  ";
        $sql .= " LEFT JOIN `invoice_items` ii ON i.id = ii.invoice_id ";
        $sql .= " WHERE i.invoice_type = 'receipt-invoice' AND product_id = '{$product_id}' ";
        $res['avg'] = $this->mDb->getOne($sql);
        $res['avg'] = round($res['avg'], 2);

        $sql = "SELECT price FROM `invoices`  i  ";
        $sql .= " LEFT JOIN `invoice_items` ii ON i.id = ii.invoice_id ";
        $sql .= " WHERE i.invoice_type = 'receipt-invoice'  AND product_id = '{$product_id}' order by  ii.id DESC  Limit 1  ";
        $last_price = $this->mDb->getAll($sql);
        $res['last_price'] = $last_price[0]['price'] ? $last_price[0]['price'] : '0';

        $sql = "SELECT price FROM `invoices`  i  ";
        $sql .= " LEFT JOIN `invoice_items` ii ON i.id = ii.invoice_id ";
        $sql .= " WHERE i.invoice_type = 'receipt-invoice'  AND product_id = '{$product_id}' order by  ii.price ASC  Limit 1  ";
        $less_price = $this->mDb->getAll($sql);
        $res['less_price'] = $less_price[0]['price'] ? $less_price[0]['price'] : '0';
        return $res;
    }

//    public function updateProductItemInCost($Req) {
//
//        $sql = "UPDATE `products` SET cost='{$Req['real_cost']}' ";
//        $sql .= " WHERE `id` ='{$Req['product_id']}' ";
////echo $sql."<hr>";
//        return $this->mDb->query($sql);
//    }

    public function getProductEditPriceExchange() {
        $sql = "SELECT * FROM `products` where edit_price_exchange ='1' ";
        $sql .= " LIMIT 0, 100";
        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count(($res)); $i++) {
            $res[$i]['product_invoice_receipt_info'] = $this->getProductInvoiceReceiptInfo($res[$i]['id']);

            $lastAllStoreAmounts = $this->getProductStoreAmounts($res[$i]['id']);

            $res[$i]['cost'] = (((floatval($res[$i]['cost']) * floatval($lastAllStoreAmounts)) ) / (floatval($lastAllStoreAmounts)));

//            $this->updateProductItemInCost($invoice_items[$i]);
//                
//            if ($res[$i]['cost'] == 0) {
//            $res[$i]['cost'] = $res[$i]['product_invoice_receipt_info']['avg'];
//            }
            echo "<pre>";
            print_r($res[$i]);
            echo "</pre> <hr>";
//            echo 'id=' . $res[$i]['id'] . "<hr>";
//            echo 'show_cost_in_currency=' . $res[$i]['show_cost_in_currency'] . "<hr>";
            if (($res[$i]['show_cost'] == '0' && $res[$i]['show_cost_in_currency'] == '0')) {
                $this->updateProductEditPriceExchange($res[$i]['id']);
            } else if ($res[$i]['show_cost_in_currency'] == '1') {
                if ($res[$i]['currency_id'] && $res[$i]['price_in_currency']) {
                    $settingsItem = $this->getAutoLoadSettings();

                    $res[$i]['shipping_cost'] = $settingsItem['shipping_amount'];
                    $res[$i]['shipping'] = (floatval($settingsItem['shipping_amount']) / (floatval($settingsItem['shipping_weight']) * 1000 / (floatval($res[$i]['product_weight']))));

                    //// $currentSelectCurrency
                    $key = array_search($res[$i]['currency_id'], array_column($settingsItem['CurrenciesItem'], 'id'));

                    if ($key > -1) {
                        $currentSelectCurrency = $settingsItem['CurrenciesItem'][$key];
                        $res[$i]['price_exchange'] = $currentSelectCurrency['price'];
                    }
                    ////currentDefaultCurrency
                    $keyDefault = array_search('1', array_column($settingsItem['CurrenciesItem'], 'default'));
                    if ($keyDefault > -1) {
                        $currentDefaultCurrency = $settingsItem['CurrenciesItem'][$keyDefault];
                    }
                    ////currentDefaultCurrency
                    $keyshipping = array_search($settingsItem['shipping_currency'], array_column($settingsItem['CurrenciesItem'], 'id'));
                    if ($keyshipping > -1) {
                        $currentShippingCurrency = $settingsItem['CurrenciesItem'][$keyshipping];
                        $res[$i]['shipping_cost_virtual_currency'] = (floatval($currentShippingCurrency['price']) * floatval($res[$i]['shipping']));
                    }



                    $res[$i]['price_in_default_currency'] = floatval($res[$i]['price_in_currency']) * floatval($res[$i]['price_exchange']);

//                    $res[$i]['discount_in_currency'] = (floatval($res[$i]['discount_rate_in_currency']) * floatval($res[$i]['price_in_currency']) / 100);

                    if (floatval($res[$i]['discount_rate_in_currency']) > 0) {
                        $res[$i]['discount_in_currency'] = floatval((floatval($res[$i]['price_in_currency']) - ((floatval($res[$i]['discount_rate_in_currency']) * floatval($res[$i]['price_in_currency'])) / 100)));
                    } else {
                        $res[$i]['discount_in_currency'] = 0;
                    }

                    $res[$i]['discount_in_default_currency'] = floatval($res[$i]['discount_in_currency']) * floatval($res[$i]['price_exchange']);

//                    $res[$i]['price_in_default_currency'] = floatval($res[$i]['price_in_default_currency']) - floatval($res[$i]['discount_in_default_currency']);


                    if (floatval($res[$i]['discount_in_currency']) > 0) {
                        $res[$i]['price_in_default_currency'] = ((floatval($res[$i]['price_in_default_currency']) + floatval($res[$i]['discount_in_default_currency'])) - floatval($res[$i]['price_in_default_currency']));
                    } else {
                        $res[$i]['price_in_default_currency'] = floatval($res[$i]['price_in_default_currency']);
                    }


                    if ($res[$i]['add_shipping_cost']) {
                        $res[$i]['price_cost_virtual_currency'] = floatval(number_format((floatval($res[$i]['price_in_default_currency']) + floatval($res[$i]['shipping_cost_virtual_currency'])), 0));
                    } else {
                        $res[$i]['price_cost_virtual_currency'] = floatval(number_format((floatval($res[$i]['price_in_default_currency'])), 0));
                    }
// 

                    $res[$i]['commission'] = floatval($res[$i]['price_one']) - floatval($res[$i]['price_multi']);
                    $res[$i]['price'] = floatval($res[$i]['commission']) + floatval($res[$i]['price_multi']);

                    if ($res[$i]['fixed_column'] == 'price') {
                        if (floatval($res[$i]['price_one']) > 0) {
                            /////price_one
                            $res[$i]['price_one_profit'] = floatval(number_format((floatval($res[$i]['price_one']) - floatval($res[$i]['price_cost_virtual_currency'])), 2));
                            $res[$i]['price_one_profit_rate'] = floatval(number_format((((floatval($res[$i]['price_one']) - floatval($res[$i]['price_cost_virtual_currency'])) / floatval($res[$i]['price_cost_virtual_currency'])) * 100), 2));
                        }
                        if (floatval($res[$i]['price_half']) > 0) {
                            //////price_half
                            $res[$i]['price_half_profit'] = floatval(number_format((floatval($res[$i]['price_half']) - floatval($res[$i]['price_cost_virtual_currency'])), 2));
                            $res[$i]['price_half_profit_rate'] = floatval(number_format((((floatval($res[$i]['price_half']) - floatval($res[$i]['price_cost_virtual_currency'])) / floatval($res[$i]['price_cost_virtual_currency'])) * 100), 2));
                        }
                        if (floatval($res[$i]['price_multi']) > 0) {
                            /////price_multi
                            $res[$i]['price_multi_profit'] = floatval(number_format((floatval($res[$i]['price_multi']) - floatval($res[$i]['price_cost_virtual_currency'])), 2));
                            $res[$i]['price_multi_profit_rate'] = floatval(number_format((((floatval($res[$i]['price_multi']) - floatval($res[$i]['price_cost_virtual_currency'])) / floatval($res[$i]['price_cost_virtual_currency'])) * 100), 2));
                        }
                        if (floatval($res[$i]['price_gomla_gomla']) > 0) {
                            /////price_gomla_gomla
                            $res[$i]['price_gomla_gomla_profit'] = floatval(number_format((floatval($res[$i]['price_gomla_gomla']) - floatval($res[$i]['price_cost_virtual_currency'])), 2));
                            $res[$i]['price_gomla_gomla_profit_rate'] = floatval(number_format((((floatval($res[$i]['price_gomla_gomla']) - floatval($res[$i]['price_cost_virtual_currency'])) / floatval($res[$i]['price_cost_virtual_currency'])) * 100), 2));
                        }
                        ////
                    } else if ($res[$i]['fixed_column'] == 'profit') {
                        if (floatval($res[$i]['price_one_profit']) > 0) {
                            ////price_one_profit
                            $res[$i]['price_one'] = round((floatval($res[$i]['price_one_profit']) + floatval($res[$i]['price_cost_virtual_currency'])));
                            $res[$i]['price_one_profit_rate'] = floatval(((floatval($res[$i]['price_one_profit']) / floatval($res[$i]['price_cost_virtual_currency'])) * 100));
                        }
                        if (floatval($res[$i]['price_half_profit']) > 0) {
                            ////price_half_profit
                            $res[$i]['price_half'] = round((floatval($res[$i]['price_half_profit']) + floatval($res[$i]['price_cost_virtual_currency'])));
                            $res[$i]['price_half_profit_rate'] = floatval(((floatval($res[$i]['price_half_profit']) / floatval($res[$i]['price_cost_virtual_currency'])) * 100));
                        }
                        if (floatval($res[$i]['price_multi_profit']) > 0) {
                            /////price_multi_profit
                            $res[$i]['price_multi'] = round((floatval($res[$i]['price_multi_profit']) + floatval($res[$i]['price_cost_virtual_currency'])));
                            $res[$i]['price_multi_profit_rate'] = floatval(((floatval($res[$i]['price_multi_profit']) / floatval($res[$i]['price_cost_virtual_currency'])) * 100));
                        }
                        if (floatval($res[$i]['price_gomla_gomla_profit']) > 0) {
                            //////price_gomla_gomla_profit
                            $res[$i]['price_gomla_gomla'] = round((floatval($res[$i]['price_gomla_gomla_profit']) + floatval($res[$i]['price_cost_virtual_currency'])));
                            $res[$i]['price_gomla_gomla_profit_rate'] = floatval(((floatval($res[$i]['price_gomla_gomla_profit']) / floatval($res[$i]['price_cost_virtual_currency'])) * 100));
                        }
                    } else if ($res[$i]['fixed_column'] == 'profit_rate') {
                        /////

                        if (floatval($res[$i]['price_one_profit_rate']) > 0) {
                            ////price_one_profit_rate
                            $res[$i]['price_one_profit'] = floatval(number_format(((floatval($res[$i]['price_cost_virtual_currency']) / 100) * floatval($res[$i]['price_one_profit_rate'])), 2));
                            $res[$i]['price_one'] = round(((floatval($res[$i]['price_cost_virtual_currency']) / 100) * floatval($res[$i]['price_one_profit_rate']) + floatval($res[$i]['price_cost_virtual_currency'])));
                        }
                        if (floatval($res[$i]['price_half_profit_rate']) > 0) {
                            /////cost
                            $res[$i]['price_half_profit'] = floatval(((floatval($res[$i]['price_cost_virtual_currency']) / 100) * floatval($res[$i]['price_half_profit_rate'])));
                            $res[$i]['price_half'] = round(((floatval($res[$i]['price_cost_virtual_currency']) / 100) * floatval($res[$i]['price_half_profit_rate']) + floatval($res[$i]['price_cost_virtual_currency'])));
                        }
                        if (floatval($res[$i]['price_multi_profit_rate']) > 0) {
                            /////price_multi_profit_rate
                            $res[$i]['price_multi_profit'] = floatval(((floatval($res[$i]['price_cost_virtual_currency']) / 100) * floatval($res[$i]['price_multi_profit_rate'])));
                            $res[$i]['price_multi'] = round(((floatval($res[$i]['price_cost_virtual_currency']) / 100) * floatval($res[$i]['price_multi_profit_rate']) + floatval($res[$i]['price_cost_virtual_currency'])));
                        }
                        if (floatval($res[$i]['price_gomla_gomla_profit_rate']) > 0) {
                            /////price_gomla_gomla_profit_rate
                            $res[$i]['price_gomla_gomla_profit'] = floatval(((floatval($res[$i]['price_cost_virtual_currency']) / 100) * floatval($res[$i]['price_gomla_gomla_profit_rate'])));
                            $res[$i]['price_gomla_gomla'] = round(((floatval($res[$i]['price_cost_virtual_currency']) / 100) * floatval($res[$i]['price_gomla_gomla_profit_rate']) + floatval($res[$i]['price_cost_virtual_currency'])));
                        }
                    }




                    if (floatval($res[$i]['last_price_one_rate']) > 0) {
                        $res[$i]['last_price_one'] = round((floatval($res[$i]['price_one']) - (floatval($res[$i]['last_price_one_rate']) * floatval($res[$i]['price_one']) / 100)));
                    } else if ($res[$i]['fixed_column'] == 'price' && floatval($res[$i]['last_price_one']) > 0) {
                        $res[$i]['last_price_one_rate'] = floatval((((floatval($res[$i]['price_one']) - floatval($res[$i]['last_price_one'])) / floatval($res[$i]['price_one'])) * 100));
                    }

                    if (floatval($res[$i]['last_price_half_rate']) > 0) {
                        $res[$i]['last_price_half'] = round((floatval($res[$i]['price_half']) - (floatval($res[$i]['last_price_half_rate']) * floatval($res[$i]['price_half']) / 100)));
                    } else if ($res[$i]['fixed_column'] == 'price' && floatval($res[$i]['last_price_half']) > 0) {
                        $res[$i]['last_price_half_rate'] = floatval((((floatval($res[$i]['price_half']) - floatval($res[$i]['last_price_half'])) / floatval($res[$i]['price_half'])) * 100));
                    }

                    if (floatval($res[$i]['last_price_multi_rate']) > 0) {
                        $res[$i]['last_price_multi'] = round((floatval($res[$i]['price_multi']) - (floatval($res[$i]['last_price_multi_rate']) * floatval($res[$i]['price_multi']) / 100)));
                    } else if ($res[$i]['fixed_column'] == 'price' && floatval($res[$i]['last_price_multi']) > 0) {
                        $res[$i]['last_price_multi_rate'] = floatval((((floatval($res[$i]['price_multi']) - floatval($res[$i]['last_price_multi'])) / floatval($res[$i]['price_multi'])) * 100));
                    }

                    if (floatval($res[$i]['last_price_gomla_gomla_rate']) > 0) {
                        $res[$i]['last_price_gomla_gomla'] = round((floatval($res[$i]['price_gomla_gomla']) - (floatval($res[$i]['last_price_gomla_gomla_rate']) * floatval($res[$i]['price_gomla_gomla']) / 100)));
                    } else if ($res[$i]['fixed_column'] == 'price' && floatval($res[$i]['last_price_gomla_gomla']) > 0) {
                        $res[$i]['last_price_gomla_gomla_rate'] = floatval((((floatval($res[$i]['price_gomla_gomla']) - floatval($res[$i]['last_price_gomla_gomla'])) / floatval($res[$i]['price_gomla_gomla'])) * 100));
                    }


                    //////////////////
                    if ($res[$i]['fixed_column'] == 'price') {
                        if (floatval($res[$i]['last_price_one_rate']) > 0) {
                            $res[$i]['price_one_profit'] = floatval(number_format((floatval($res[$i]['last_price_one']) - floatval($res[$i]['price_cost_virtual_currency'])), 2));
                            $res[$i]['price_one_profit_rate'] = floatval((((floatval($res[$i]['last_price_one']) - floatval($res[$i]['price_cost_virtual_currency'])) / floatval($res[$i]['price_cost_virtual_currency'])) * 100));
                        }
                        //////
                        if (floatval($res[$i]['last_price_half_rate']) > 0) {
                            $res[$i]['price_half_profit'] = floatval((floatval($res[$i]['last_price_half']) - floatval($res[$i]['price_cost_virtual_currency'])));
                            $res[$i]['price_half_profit_rate'] = floatval((((floatval($res[$i]['last_price_half']) - floatval($res[$i]['price_cost_virtual_currency'])) / floatval($res[$i]['price_cost_virtual_currency'])) * 100));
                        }
                        //////
                        if (floatval($res[$i]['last_price_multi_rate']) > 0) {
                            $res[$i]['price_multi_profit'] = floatval((floatval($res[$i]['last_price_multi']) - floatval($res[$i]['price_cost_virtual_currency'])));
                            $res[$i]['price_multi_profit_rate'] = floatval((((floatval($res[$i]['last_price_multi']) - floatval($res[$i]['price_cost_virtual_currency'])) / floatval($res[$i]['price_cost_virtual_currency'])) * 100));
                        }
                        //////
                        if (floatval($res[$i]['last_price_gomla_gomla_rate']) > 0) {
                            $res[$i]['price_gomla_gomla_profit'] = floatval((floatval($res[$i]['last_price_gomla_gomla']) - floatval($res[$i]['price_cost_virtual_currency'])));
                            $res[$i]['price_gomla_gomla_profit_rate'] = floatval((((floatval($res[$i]['last_price_gomla_gomla']) - floatval($res[$i]['price_cost_virtual_currency'])) / floatval($res[$i]['price_cost_virtual_currency'])) * 100));
                        }
                    }






//                    echo "<pre>";
//                    print_r($res[$i]);
//                    echo "</pre> <hr>";

                    $sql = "UPDATE  `products` SET ";
                    foreach ($this->mDb->getCols('products', $res[$i]) as $k => $v) {
                        $sql .= ($k == 'lang_parameter' || $k == 'medias' || $k == 'id' || $k == 'product_services' || $k == 'product_discounts' || $k == 'lang_Details' || $k == 'code') ? "" : "`{$k}`='{$v}',";
                    }
                    $sql = substr($sql, 0, -1);
                    $sql .= " where `id` = '{$res[$i]['id']}' ";
                    echo $sql . "<hr>";
                    // die();
                    $resUPDATE = $this->mDb->query($sql);
                    if ($resUPDATE) {
                        $this->updateProductEditPriceExchange($res[$i]['id']);
                    }
                } else {
                    $this->updateProductEditPriceExchange($res[$i]['id']);
                }
            } else if ($res[$i]['show_cost'] == '1') {


                if ($res[$i]['fixed_column'] == 'price') {
                    if (floatval($res[$i]['price_one']) > 0) {
                        /////price_one
                        $res[$i]['price_one_profit'] = floatval(number_format((floatval($res[$i]['price_one']) - floatval($res[$i]['cost'])), 2));
                        $res[$i]['price_one_profit_rate'] = floatval(number_format((((floatval($res[$i]['price_one']) - floatval($res[$i]['cost'])) / floatval($res[$i]['cost'])) * 100), 2));
                    }
                    if (floatval($res[$i]['price_half']) > 0) {
                        //////price_half
                        $res[$i]['price_half_profit'] = floatval(number_format((floatval($res[$i]['price_half']) - floatval($res[$i]['cost'])), 2));
                        $res[$i]['price_half_profit_rate'] = floatval(number_format((((floatval($res[$i]['price_half']) - floatval($res[$i]['cost'])) / floatval($res[$i]['cost'])) * 100), 2));
                    }
                    if (floatval($res[$i]['price_multi']) > 0) {
                        /////price_multi
                        $res[$i]['price_multi_profit'] = floatval(number_format((floatval($res[$i]['price_multi']) - floatval($res[$i]['cost'])), 2));
                        $res[$i]['price_multi_profit_rate'] = floatval(number_format((((floatval($res[$i]['price_multi']) - floatval($res[$i]['cost'])) / floatval($res[$i]['cost'])) * 100), 2));
                    }
                    if (floatval($res[$i]['price_gomla_gomla']) > 0) {
                        /////price_gomla_gomla
                        $res[$i]['price_gomla_gomla_profit'] = floatval(number_format((floatval($res[$i]['price_gomla_gomla']) - floatval($res[$i]['cost'])), 2));
                        $res[$i]['price_gomla_gomla_profit_rate'] = floatval(number_format((((floatval($res[$i]['price_gomla_gomla']) - floatval($res[$i]['cost'])) / floatval($res[$i]['cost'])) * 100), 2));
                    }
                    ////
                } else if ($res[$i]['fixed_column'] == 'profit') {
                    if (floatval($res[$i]['price_one_profit']) > 0) {
                        ////price_one_profit
                        $res[$i]['price_one'] = round((floatval($res[$i]['price_one_profit']) + floatval($res[$i]['cost'])));
                        $res[$i]['price_one_profit_rate'] = floatval(((floatval($res[$i]['price_one_profit']) / floatval($res[$i]['cost'])) * 100));
                    }
                    if (floatval($res[$i]['price_half_profit']) > 0) {
                        ////price_half_profit
                        $res[$i]['price_half'] = round((floatval($res[$i]['price_half_profit']) + floatval($res[$i]['cost'])));
                        $res[$i]['price_half_profit_rate'] = floatval(((floatval($res[$i]['price_half_profit']) / floatval($res[$i]['cost'])) * 100));
                    }
                    if (floatval($res[$i]['price_multi_profit']) > 0) {
                        /////price_multi_profit
                        $res[$i]['price_multi'] = round((floatval($res[$i]['price_multi_profit']) + floatval($res[$i]['cost'])));
                        $res[$i]['price_multi_profit_rate'] = floatval(((floatval($res[$i]['price_multi_profit']) / floatval($res[$i]['cost'])) * 100));
                    }
                    if (floatval($res[$i]['price_gomla_gomla_profit']) > 0) {
                        //////price_gomla_gomla_profit
                        $res[$i]['price_gomla_gomla'] = round((floatval($res[$i]['price_gomla_gomla_profit']) + floatval($res[$i]['cost'])));
                        $res[$i]['price_gomla_gomla_profit_rate'] = floatval(((floatval($res[$i]['price_gomla_gomla_profit']) / floatval($res[$i]['cost'])) * 100));
                    }
                } else if ($res[$i]['fixed_column'] == 'profit_rate') {
                    /////

                    if (floatval($res[$i]['price_one_profit_rate']) > 0) {
                        ////price_one_profit_rate
                        $res[$i]['price_one_profit'] = floatval(number_format(((floatval($res[$i]['cost']) / 100) * floatval($res[$i]['price_one_profit_rate'])), 2));
                        $res[$i]['price_one'] = round(((floatval($res[$i]['cost']) / 100) * floatval($res[$i]['price_one_profit_rate']) + floatval($res[$i]['cost'])));
                    }
                    if (floatval($res[$i]['price_half_profit_rate']) > 0) {
                        /////cost
                        $res[$i]['price_half_profit'] = floatval(((floatval($res[$i]['cost']) / 100) * floatval($res[$i]['price_half_profit_rate'])));
                        $res[$i]['price_half'] = round(((floatval($res[$i]['cost']) / 100) * floatval($res[$i]['price_half_profit_rate']) + floatval($res[$i]['cost'])));
                    }
                    if (floatval($res[$i]['price_multi_profit_rate']) > 0) {
                        /////price_multi_profit_rate
                        $res[$i]['price_multi_profit'] = floatval(((floatval($res[$i]['cost']) / 100) * floatval($res[$i]['price_multi_profit_rate'])));
                        $res[$i]['price_multi'] = round(((floatval($res[$i]['cost']) / 100) * floatval($res[$i]['price_multi_profit_rate']) + floatval($res[$i]['cost'])));
                    }
                    if (floatval($res[$i]['price_gomla_gomla_profit_rate']) > 0) {
                        /////price_gomla_gomla_profit_rate
                        $res[$i]['price_gomla_gomla_profit'] = floatval(((floatval($res[$i]['cost']) / 100) * floatval($res[$i]['price_gomla_gomla_profit_rate'])));
                        $res[$i]['price_gomla_gomla'] = round(((floatval($res[$i]['cost']) / 100) * floatval($res[$i]['price_gomla_gomla_profit_rate']) + floatval($res[$i]['cost'])));
                    }
                }




                if (floatval($res[$i]['last_price_one_rate']) > 0) {
                    $res[$i]['last_price_one'] = round((floatval($res[$i]['price_one']) - (floatval($res[$i]['last_price_one_rate']) * floatval($res[$i]['price_one']) / 100)));
                } else if ($res[$i]['fixed_column'] == 'price' && floatval($res[$i]['last_price_one']) > 0) {
                    $res[$i]['last_price_one_rate'] = floatval((((floatval($res[$i]['price_one']) - floatval($res[$i]['last_price_one'])) / floatval($res[$i]['price_one'])) * 100));
                }

                if (floatval($res[$i]['last_price_half_rate']) > 0) {
                    $res[$i]['last_price_half'] = round((floatval($res[$i]['price_half']) - (floatval($res[$i]['last_price_half_rate']) * floatval($res[$i]['price_half']) / 100)));
                } else if ($res[$i]['fixed_column'] == 'price' && floatval($res[$i]['last_price_half']) > 0) {
                    $res[$i]['last_price_half_rate'] = floatval((((floatval($res[$i]['price_half']) - floatval($res[$i]['last_price_half'])) / floatval($res[$i]['price_half'])) * 100));
                }

                if (floatval($res[$i]['last_price_multi_rate']) > 0) {
                    $res[$i]['last_price_multi'] = round((floatval($res[$i]['price_multi']) - (floatval($res[$i]['last_price_multi_rate']) * floatval($res[$i]['price_multi']) / 100)));
                } else if ($res[$i]['fixed_column'] == 'price' && floatval($res[$i]['last_price_multi']) > 0) {
                    $res[$i]['last_price_multi_rate'] = floatval((((floatval($res[$i]['price_multi']) - floatval($res[$i]['last_price_multi'])) / floatval($res[$i]['price_multi'])) * 100));
                }

                if (floatval($res[$i]['last_price_gomla_gomla_rate']) > 0) {
                    $res[$i]['last_price_gomla_gomla'] = round((floatval($res[$i]['price_gomla_gomla']) - (floatval($res[$i]['last_price_gomla_gomla_rate']) * floatval($res[$i]['price_gomla_gomla']) / 100)));
                } else if ($res[$i]['fixed_column'] == 'price' && floatval($res[$i]['last_price_gomla_gomla']) > 0) {
                    $res[$i]['last_price_gomla_gomla_rate'] = floatval((((floatval($res[$i]['price_gomla_gomla']) - floatval($res[$i]['last_price_gomla_gomla'])) / floatval($res[$i]['price_gomla_gomla'])) * 100));
                }


                //////////////////
                if ($res[$i]['fixed_column'] == 'price') {
                    if (floatval($res[$i]['last_price_one_rate']) > 0) {
                        $res[$i]['price_one_profit'] = floatval(number_format((floatval($res[$i]['last_price_one']) - floatval($res[$i]['cost'])), 2));
                        $res[$i]['price_one_profit_rate'] = floatval((((floatval($res[$i]['last_price_one']) - floatval($res[$i]['cost'])) / floatval($res[$i]['cost'])) * 100));
                    }
                    //////
                    if (floatval($res[$i]['last_price_half_rate']) > 0) {
                        $res[$i]['price_half_profit'] = floatval((floatval($res[$i]['last_price_half']) - floatval($res[$i]['cost'])));
                        $res[$i]['price_half_profit_rate'] = floatval((((floatval($res[$i]['last_price_half']) - floatval($res[$i]['cost'])) / floatval($res[$i]['cost'])) * 100));
                    }
                    //////
                    if (floatval($res[$i]['last_price_multi_rate']) > 0) {
                        $res[$i]['price_multi_profit'] = floatval((floatval($res[$i]['last_price_multi']) - floatval($res[$i]['cost'])));
                        $res[$i]['price_multi_profit_rate'] = floatval((((floatval($res[$i]['last_price_multi']) - floatval($res[$i]['cost'])) / floatval($res[$i]['cost'])) * 100));
                    }
                    //////
                    if (floatval($res[$i]['last_price_gomla_gomla_rate']) > 0) {
                        $res[$i]['price_gomla_gomla_profit'] = floatval((floatval($res[$i]['last_price_gomla_gomla']) - floatval($res[$i]['cost'])));
                        $res[$i]['price_gomla_gomla_profit_rate'] = floatval((((floatval($res[$i]['last_price_gomla_gomla']) - floatval($res[$i]['cost'])) / floatval($res[$i]['cost'])) * 100));
                    }
                }



                $res[$i]['commission'] = floatval($res[$i]['price_one']) - floatval($res[$i]['price_multi']);
                $res[$i]['price'] = floatval($res[$i]['commission']) + floatval($res[$i]['price_multi']);

//                    echo "<pre>";
//                    print_r($res[$i]);
//                    echo "</pre> <hr>";

                $sql = "UPDATE  `products` SET ";
                foreach ($this->mDb->getCols('products', $res[$i]) as $k => $v) {
                    $sql .= ($k == 'lang_parameter' || $k == 'medias' || $k == 'id' || $k == 'product_services' || $k == 'product_discounts' || $k == 'lang_Details' || $k == 'code') ? "" : "`{$k}`='{$v}',";
                }
                $sql = substr($sql, 0, -1);
                $sql .= " where `id` = '{$res[$i]['id']}' ";
                echo $sql . "<hr>";
                // die();
                $resUPDATE = $this->mDb->query($sql);
                if ($resUPDATE) {
                    $this->updateProductEditPriceExchange($res[$i]['id']);
                }
            }
        }


        return $res;
    }
}
