<?php

/* * *************************************************************************
 *
 *   PROJECT: school managment system
 *   powerd by ashraf hamdy
 *   Copyright 2018 IT Plus Inc
 *   http://it-plus.co/
 *
 *
 * ************************************************************************* */

class iplusTo {

    public $mDbhost;
    public $mDbuser;
    public $mDbpwd;
    public $mDbname;
    public static $handel;

    public function __construct() {
        global $Config;


        $this->mDbhost = $Config['dbhost'];
        $this->mDbuser = $Config['dbuser'];
        $this->mDbpwd = $Config['dbpwd'];
        $this->mDbname = $Config['dbname_to'];
        $this->connect();

        $this->mMailer = new Mailer();
        $this->mMailer->mConfig = $Config;

        $this->mConfig = $Config;
    }

    /**
     * Connects to database
     */
    public function connect() {

        if (self::$handel === null) {
            try {
                self::$handel = new PDO('mysql:host=' . $this->mDbhost . ';dbname=' . $this->mDbname, $this->mDbuser, $this->mDbpwd);
                self::$handel->query("set names 'utf8mb4';");
            } catch (Exception $e) {
                die($e->getMessage());
            }
        }
        return self::$handel;
    }

    /**
     * Close connection to database
     *
     * @param $aConnection connection
     *
     * return bool
     */
    function close() {
        unset(self::$handel);
        return self::$handel;
    }

    /**
     * @param $aSql
     * @return bool
     */
    function query($aSql) {
        $query = $this->connect()->prepare($aSql);
        return $query->execute();
    }

    function queryReturnRowCount($aSql) {
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        return $query->rowCount();
    }

    /* function queryapi($aSql) {
      $query = $this->connect()->prepare($aSql);
      $query->execute();
      return $query->rowCount() ? true : false;
      } */

     function queryreturnlastid($aSql) {
        $con = $this->connect();
        $query = $con->prepare($aSql);
        $query->execute();
        return $con->lastInsertId();
    }

    /**
     * @param $aSql
     * @return array
     */
    /* function getRow($aSql) {
      $query = $this->connect()->prepare($aSql);
      $query->execute();
      return $query->fetch();
      } */

    function getRow($aSql) {
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        return $query->fetch(PDO::FETCH_ASSOC);
    }

    /**
     * @param $aSql
     * @return array
     */
    /* function getAll($aSql) {

      $query = $this->connect()->prepare($aSql);
      $query->execute();


      $out = Array();

      while ($temp = $query->fetch()) {
      $out[] = $temp;
      }

      return $out;
      } */

    function getAll($aSql) {

        $query = $this->connect()->prepare($aSql);
        $query->execute();


        $out = array();

        while ($temp = $query->fetch(PDO::FETCH_ASSOC)) {
            $out[] = $temp;
        }

        return $out;
    }

    /**
     * @param $aSql
     * @return array
     */
    function &getAssoc($aSql) {
        $out = array();
        $res = &$this->connect()->prepare($aSql);
        $res->execute();

        while ($temp = $res->fetch(PDO::FETCH_ASSOC)) {
            $key = array_shift($temp);
            $out[$key][] = $temp;
        }
        return $out;
    }

    /**
     * @param $aSql
     * @return string
     */
    function getOne($aSql) {

        $query = $this->connect()->prepare($aSql);
        $query->execute();
        return $result = $query->fetchColumn(0);
    }

    /**
     * Returns array of tables
     *
     * @return arr
     */
    function getTables() {
        $out = array();

        $sql = "SHOW TABLES FROM {$this->mDbname}";
        $res = $this->connect()->prepare($sql);
        $res->execute();
        while ($row = $res->fetch()) {
            $out[] = $row[0];
        }

        return $out;
    }

    /**
     * Prints out block with error
     */
    function printError($aError) {
        echo $aError;
    }

    /**
     * Returns recordset as associative array where the key is the first field
     *
     * @param str $aSql sql query
     *
     * @return arr
     */
    function getCols($tableName, $Req) {
        $aSql = "SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = N'" . $tableName . "' and TABLE_SCHEMA = '" . $this->mDbname . "' ";
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        // echo $aSql;
        $out = array();
        while ($temp = $query->fetch(PDO::FETCH_ASSOC)) {
            if ($temp['COLUMN_NAME'] != 'id' && $temp['COLUMN_NAME'] != 'id') {
                if (isset($Req[$temp['COLUMN_NAME']])) {
                    $return[$temp['COLUMN_NAME']] = $Req[$temp['COLUMN_NAME']];
                }
            }
        }

        return $return;
    }

    function getColumnName($tableName) {
        $aSql = "SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = N'" . $tableName . "' and TABLE_SCHEMA = '" . $this->mDbname . "' ";
        $aSql.="  ORDER BY `ORDINAL_POSITION` ASC ";
//        echo $aSql."<hr>";
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        $return = array();

        while ($temp = $query->fetch(PDO::FETCH_ASSOC)) {
            if ($temp['COLUMN_NAME'] != 'id' && $temp['COLUMN_NAME'] != 'admin_id' && $temp['COLUMN_NAME'] != 'date_added') {

                $arr = explode("_", $temp['COLUMN_NAME']);
                $arrpop = $arr;
                array_pop($arrpop);
                $arrpop = implode("_", $arrpop);
                $i = array_search(reset($arr), array_column($return, 'mode'));

                if ($i > -1 && end($arr) !== 'show') {

                    $i3 = array_search($arrpop, array_column($return[$i]['options'], 'mode'));
                    if ($i3 > -1) {
                        $return[$i]['options'][$i3][$temp['COLUMN_NAME']] = $temp['COLUMN_DEFAULT'];
                    } else {
                        $options = array();
                        $options['mode'] = $arrpop;
                        $options[$temp['COLUMN_NAME']] = $temp['COLUMN_DEFAULT'];
                        array_push($return[$i]['options'], $options);
                    }
                } else {
                    if (end($arr) == 'show') {
                        $i2 = array_search(reset($arr), array_column($return, 'mode'));
                        if ($i2 > -1) {
                            $return[$i2][$temp['COLUMN_NAME']] = $temp['COLUMN_DEFAULT'];
                        } else {
                            array_push($return, ["mode" => reset($arr), $temp['COLUMN_NAME'] => $temp['COLUMN_DEFAULT'], "options" => array()]);
                        }
                    } else {
                        array_push($return, ["mode" => reset($arr), $temp['COLUMN_NAME'] => $temp['COLUMN_DEFAULT'], "options" => array()]);
                    }
                }
            }
        }

        return $return;
    }

    function getKeyValue($aSql) {
        $out = array();
        $res = $this->connect()->prepare($aSql);
        $res->execute();
        while ($temp = $res->fetch()) {
            $out[$temp[0]] = $temp[1];
        }
        return $out;
    }

    public function getLastInsertId() {
        return $this->connect()->lastInsertId();
    }

    // ahmadklsany
    public function getlastIdFromTable($table) {
        $sql = " SELECT `AUTO_INCREMENT` FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = '{$table}' ";
        $res = $this->getOne($sql);

        if ($res) {
            return $res;
        } else {
            return 0;
        }
    }

    public function addCronJob($filename = '') {
//        echo $filename."<hr>";
        if ($filename) {
            $output = shell_exec('crontab -l');
            if (stripos($output, $filename) == false) {
                file_put_contents("/tmp/crontab.txt", $output . $filename . PHP_EOL);
//                file_put_contents("/tmp/crontab.txt", ''. PHP_EOL);
                return exec('crontab  /tmp/crontab.txt');
            }
        }
    }

    public function delCronJob($filename = '') {
//            echo $filename."<hr>";
        if ($filename) {
            $output = shell_exec('crontab -l');
            $remove_cron = str_replace($filename, "", $output);
            file_put_contents("/tmp/crontab.txt", $remove_cron . PHP_EOL);
            return exec('crontab  /tmp/crontab.txt');
        }
    }

}
